-------------------------------------------------------------------------------

          KbMedia Player for Windows Version 3.13             (2024/04/30 公開)

                           Copyright(C) 1998-2024 Kobarin
                             E-Mail: hidkob@pb.highway.ne.jp
                           HomePage: https://kobarin.sakura.ne.jp/
-------------------------------------------------------------------------------

「ツール」->「プラグイン設定」で全てのプラグインが
「failed to load plug-in」と表示されていて何も再生出来ない場合は

https://visualstudio.microsoft.com/ja/downloads/#other-ja-family
https://aka.ms/vs/17/release/VC_redist.x64.exe (ファイル直リンク)(x64)
https://aka.ms/vs/17/release/VC_redist.x86.exe (ファイル直リンク)(x86)

にある「Visual Studio 2022 の Microsoft Visual C++ 再頒布可能パッケージ」をイン
ストールして下さい。64bit OS では x64(64bit) 版と x86(32bit)版両方のランタイム
が必要となります。x64 版だけでなく x86 版のランタイムもインストールして下さい。

ランタイムが未インストールの状態で KbMedia Player を起動した後にランタイムをイ
ンストールした場合、未インストール時にロードに失敗していたプラグインは自動では
ロードされません。「ツール」->「プラグイン設定」で「最新の情報に更新」ボタンを
クリックすればプラグインを認識する筈です。

-------------------------------------------------------------------------------

【更新履歴】（括弧内は公開日）

3.13(2024/04/30)

・本体の開発環境を更新(RAD Studio 12.1 Patch 1 を適用)
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.85.0.0 に更新

/*---------------------------------------------------------------------------*/

3.13beta3(2024/04/27)

・kbwsr.kpi に関する以下の修正
　・ベースを foo_input_wsr v0.30 に変更
　・foo_input_wsr に準じた設定に対応
　　・エミュレーションコアを選択出来るようになった
　　　(mednafen/oswan/in_wsr)
　　・エミュレーションコアごとに再生周波数と音量を設定出来るようにした
　　・ChannelMuting に対応(各コア共通)
　・wsr_player_mednafen.dll と wsr_player_oswan.dll に対する以下の修正
　　・再生時に落ちるデータがあったのを修正
　　・名探偵コナン 西の名探偵最大の危機！(SWJ-BAN027.wsr)
　・wsr_player_mednafen.dll と wsr_player_oswan.dll で音が鳴らない曲データを確
　　認
　　・With you〜みつめていたい〜(SWJ-SHLC01.wsr)
　　・修正は出来ていない
　　・wsr_player_in_wsr.dll では音が鳴る
・kbvgm.kpi に関する以下の修正
　・libvgm を 2024/04/24 の版に更新(Resampler.c)
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 7.0.8(2024/04/25) に更新
・kbungca.kpi に関する以下の修正
　・kbungca.dll の IGca の呼び出し規約を __cdecl から __stdcall に変更
・「ツール」=>「PLS/TAGファイル作成」の「NEZplug 拡張 M3U/PLS を TAG に変換」を
　実行すると落ちるのを修正(M3U を開いたとき)
　・レジストリを書き換えないと機能が使えないので誰も気づいてないだろうけど

/*---------------------------------------------------------------------------*/

3.13beta2(2024/04/21)

・各種プラグイン/DLL の開発環境を VS2022 17.9.6 に更新
・kbGuru2SMF.kpi に関する以下の修正
　・以下、GuruGuruSMF4.dll に関する修正
　・リズムパートの SysEx を使用する曲データが正常に再生されないのを改善
　　・ピアノになってしまうことがある曲データ
　　・チャンネルボリュームが利かないことがある曲データ
　　・最初の発音までの時間の進み方が遅くなった(MIDI イベントによっては送信前後
　　　にウェイトを置く為)
　　・根本的な原因(ピアノになるデータとならないデータの違い、チャンネルボリュー
　　　ムが利くデータと利かないデータの違い)が分からず、対症療法的な措置
　・冒頭の空白をスキップ、シークに関する以下の修正
　　・リズムパートの SysEx を使う曲データで正常に再生されなくなることがあるのを
　　　改善(冒頭の空白をスキップ、シークをしなければ正常に再生出来るデータ)
　・たまに再生がおかしくなるデータはまだ存在するがその確率は低くなった
　・演奏スレッドと同じスレッド内で処理するようにした
　・処理に時間がかかるようになった
　　・MIDI イベントによっては送信前後にウェイトを置く為
　　・特に冒頭付近が時間かかるので曲データによっては冒頭の空白スキップがあまり
　　　機能しなくなった
　　・処理中は進捗状況に応じた位置を返すようにした
　・以下の SysEx を無視するようにした
　　・テキスト表示、ドット絵、PatchName、XG のSysEx(マスターボリュームはチャン
　　　ネルボリュームに置換)
　・非ループ曲(CC111 を含まない曲)でリセットを含む曲データのループ時は先頭に戻
　　ったときにリセットを送信するようにした
　　・非ループ曲の2周目以降が不自然になる曲データの改善
　　・「非ループ曲のループ再生」を true にするデメリットが少なくなった
　　・リセットを含まない曲データでは2週目以降が不自然になる可能性があるが、
　　　GuruGuruSMF の仕様に合わせて敢えてリセットは送信しない
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 10.71(2024/04/19) に更新
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.32.6(2024/04/04) に更新
・kbopus.kpi に関する以下の修正
　・libopus を 1.5.2(2024/04/12) に更新

/*---------------------------------------------------------------------------*/

3.13beta(2024/04/08)

・本体の開発環境を C++Builder 12 v29.0.51961.7529 に更新
・kbGuru2SMF.kpi に関する以下の修正
　・「同梱の GuruGuruSMF4.dll を使う」設定を追加
　　・true のときは「GuruGuruSMF4.dll のパス」を無視
　　・公式版を使いたいときにパスを設定し直すのを省ける
　・キーシフトの設定に対応
　　・GuruGuruSMF4.dll の機能の動作確認用。通常は 0 にする
　・マスターピッチの設定に対応(playopt のと名前が被るので表示は「ピッチ」)
　　・GuruGuruSMF4.dll の機能の動作確認用。通常は 0 にする
　・フェードインの設定に対応
　　・GuruGuruSMF4.dll の機能の動作確認用。通常は 0 にする
　・フェードアウトの設定に対応
　　・0 以外にすると本体の演奏停止ボタン押下時及び「演奏」メニューの「フェード
　　　アウト」時に指定時間かけてフェードアウトさせる
　　・現在の演奏プラグインの仕様では「演奏メニュー」の「フェードアウト」時だけ
　　　フェードアウトさせることが出来ない(その為の API が存在しない)
　・GuruGuruSMF4.dll に関する以下の修正(DirectMusic 使用時)
　　・複数ポート(メタイベント0x21)に対応
　　　・最大4ポート
　　・フェードイン/フェードアウト(以下フェード)中にモタるのを修正
　　　・フェード中はポーリングの Sleep 時間を短くした(5ms => 1ms)
　　・フェードの終了までかかる時間が不正確なのを修正
　　　・Sleep の回数で判定していたのを実際の経過時間で判定
　　・フェードアウト中にフェードアウトが呼ばれても無視するようにした
　　　(最初のフェードアウトが続行されるのみ)
　　・フェードイン中にフェードアウトが呼ばれた場合は同時に進行するようにした
　　　(フェードインしてる分だけ直ぐには音量が下がらず、音量が下がり始めるのが
　　　遅くなるがフェードアウトが終わるのは呼ばれてから指定時間経過後)
・kbrunkpi.exe に関する以下の修正
　・Windows 10 バージョン 2004 以降の環境でタイマーの精度が低かったのを修正
　　(Sleep 等の API を使用するプラグインの動作改善)

/*---------------------------------------------------------------------------*/

3.12(2024/04/04)

・Vista 以降版と XP 対応版(32bit版のみ)を分けて配布するようにした
　・本体(Kbmplay.exe) は Vista 以降版も XP 対応版も同じ
　・本体の 64bit版が XP 64bit版で動作しない為、XP 対応版は 32bit版のみ配布
　・今後、XP 対応版は正式版でのみ配布
　・開発環境の更新により XP 対応が困難になった時点で XP 対応を打ち切る
　・Vista 以降版は XP では一部のプラグインが動作しない
　・XP 対応版より Vista 以降版の方が高速に動作
・kbasio.kpi に関する以下の修正
　・IASIO::init に渡すウィンドウを作成する為の専用のスレッドを廃止
　　・IASIO のインスタンスを作成/破棄するのと同じスレッドで作成
　・再生位置の取得方法を修正
・x64フォルダに plugin.txt 等がなかったのを修正
・M3U を開いたとき必要以上にプレイリストが「updated」になるのを修正
　・「updated」になる条件は「ツール」->「その他の設定」->「M3U の保存形式」の
　　「拡張M3U」の設定に従う
　　・拡張M3U が無効の場合
　　　・タイトル/アーティスト/曲長のいずれが変わっても「updated」にならない
　　・拡張M3U が有効の場合
　　　・タイトル/アーティストが変われば「updated」になる
　　　・曲長についてはミリ秒単位で不一致でも秒単位で一致してれば「updated」にな
　　　　らない
　　・曲を追加・削除した場合は拡張M3Uの設定に関わらず「updated」になる
　・開いた M3U が拡張M3Uなのかではなく、設定で判断
・先頭行が # で始まるが #EXTM3U でない M3U の先頭行をファイル名として扱っていた
　のを修正

/*---------------------------------------------------------------------------*/

3.12beta8(2024/03/29)

・各種プラグイン/DLL の開発環境を VS2022 17.9.5 に更新
・演奏プラグインに対して UpdateConfig を呼ばない(プラグインが対応していても設定
　変更がリアルタイムに反映されない)のを修正
・kbasio.kpi に関する以下の修正
　・スレッドの同期に関する修正
　　・環境によっては動作しないのを修正(?)
　・ドライバのパスに環境変数が使われてると認識出来ないのを修正(Realtek ASIO)
　　・ドライバ入れ直したら環境変数は使われなくなったが
　　・Realtek ASIO は色んな部分で挙動が怪しい
　・対症療法的な Realtek ASIO 対策を辞めた
　　・作者の環境では常にデバイスオープンに失敗する
　　・無理矢理再生させても48000Hzになったり色々と挙動不審なので対応を諦めた
　　・foobar2k v2.1.3(x64)では再生出来るので対策はある筈なのだが…
　・再生中はドライバ設定画面を出さない(IASIO::controlPanel() を呼ばない)ように
　　した
　　・何が起こるか予測出来ない為
　　・逆にドライバ設定画面を出している間は再生出来ない(デバイスオープンに失敗)
　　　(controlPanel() 呼び出し後すぐに制御を戻すタイプの場合は再生出来る)
・kbGuru2SMF.kpi に関する以下の修正
　・プラグイン設定で音量を設定出来るようにした
　　・他の MIDI 対応プラグインと比べて音量が大きいと感じる場合の調整用
　　・最大値(127)と異なる値にするのは推奨はしない
　・本体から SetVolume が呼ばれたときに GuruGuruSMF の SetVolume に渡す値を修正
　　・渡された音量(%)値と実際に鳴る音量が感覚的に合致するようになった(と思う)
　・演奏開始前に本体から SetVolume/SetTempo を呼ばれても反映されないのを修正
　　・音量が100%でない状態のときに曲を切り替えた場合等
　・GuruGuruSMF4.dll に関する以下の修正
　　・以下は全て DirectMusic 使用時のみ(本プラグインでは DirectMusic しか使用し
　　　ないが)
　　・GM/GS/XG のマスターボリュームSysExに対応
　　　・SysEx でフェードアウトしながら演奏終了する曲でフェードアウトが利くよう
　　　　になった
　　　・DirectMusic のマスターボリュームSysExへの対応が不安定なのでチャンネルボ
　　　　リュームに置き換えて処理
　　・処理が大幅に遅れているときに遅れを取り戻さないようにした
　　　・スリープモードからの復帰時や極端にPCに負荷がかかっている場合等
　　　　(デバッグ中の動作が気になっていた)
　　・DirectMusic使用時はスリープモードに入ったらデバイスを閉じる処理を無効化
　　　・処理の遅れを取り戻さなくすることで長時間のスリープからの復帰でも問題な
　　　　くなった筈なので(他にも理由があってこの機能があるのかもしれないけど)
　　　・スリープからの復帰時に本体によって演奏終了と見なされて曲が切り替わって
　　　　いたのが切り替わらずに演奏が再開されるようになった
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.7.6(2024/03/24) に更新
・kbviv.kpi に関する以下の修正
　・スレッドの同期に関する内部的な修正

/*---------------------------------------------------------------------------*/

3.12beta7(2024/03/24)

・各種プラグイン/DLL の開発環境を VS2022 17.9.4 に更新
・各種プラグイン/DLL に関する以下の修正
　・最新のプラットフォームツールセット(XP非対応)でビルド出来るようにソースコー
　　ドやコンパイルオプションを修正
　・XP 対応を打ち切った訳ではないが、64bit版の本体は XP で動作しない為、64bit版
　　のプラグイン/DLL は最新のプラットフォームツールセットでビルドするようにした
・kbGuru2SMF.kpi に関する以下の修正
　・デバイスクローズ時に150msのウェイトをかけていたのを辞めた
　　・曲の切り替えが高速化
　　・リセット SysEx の完了待ちのようだが送信後はデバイスを閉じて音が止まるだけ
　　　なので待ちは不要と判断
・kbvgm.kpi に関する以下の修正
　・未初期化の変数にアクセスして落ちる可能性があったのを修正
　　・vgmplayer_cmdhandler.cpp::VGMPlayer::Cmd_AY_Stereo()内の clDev
　　・実際に不具合を確認した訳ではない
・kbfmoplmidi.kpi に関する以下の修正
　・プラグイン設定に関する以下の修正
　　・説明文を修正
　　・無視していた設定(FMPort等)を廃止
　　・YM3526_Disable/YM3812_Disable/YMF262_Disable を廃止
　　　・機能していなかった&機能させても音が鳴らなくなるだけなので無意味と判断
　　・EmuCore の設定に対応
　　　・FM OPL MIDI Player にはない設定だがソースコードに含まれていたので
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 10.60(2024/03/19) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.7.5(2024/03/17) に更新
・nwdll.dll に関する以下の修正
　・libjpeg を libjpeg 9f(2024/01/14)に更新
・レジストリにデータがない場合の「先読みバッファのサイズ」の既定値が25msになっ
　ていたのを本来の値(5000ms)に修正
・SMF の曲長計算の結果が32bit版と64bit版とで異なることがあったのを修正
　・更新した覚えがないのにプレイリストが updated になる原因

/*---------------------------------------------------------------------------*/

3.12beta6(2024/03/20)

・ループタグ使用曲の終端付近へのシークが正しく機能しないのを修正
・別ウィンドウの Media エクスプローラの位置、サイズ、ツリーの幅、パスを保存する
　ようにした
・v3.12beta2 以降、WindowsXP で動作しないプラグインがあったのを修正
　・kbunarc.kpi/kbvsti.kpi/kbpsf2.kpi
　・プラグインの更新履歴には反映しない
・kbfmp.kpi に関する以下の修正
　・プラグイン設定画面の説明文を修正
・kbpmd.kpi に関する以下の修正
　・PMDWin.dll を v0.52(2023/03/04)に更新
　・プラグイン設定画面の説明文を修正
・kbmdx.kpi に関する以下の修正
　・Portable mdx decoder を 2023/12/26 の版に更新
・kbmsxplug.kpi に関する以下の修正
　・MSXplug(in_msx) を v1.9.1(2022/11/26)に更新
　・emu2149 を v1.41(2022/11/26)に更新
　・libkss を v1.2.0(2023/07/16)に更新
・kbsap.kpi に関する以下の修正
　・libasap(asap.c/asap.h) を 6.0.3(2024/03/09) に更新
・kbvgm.kpi に関する以下の修正
　・libvgm を v0.51.1(2024/01/03)に更新
　　・"Mikey"チップに対応(データが見つけられなくて動作未確認)
　　・EmulationCore の設定にも対応(動作未確認)
・kbwv.kpi に関する以下の修正
　・libwavpack のプリプロセッサの定義に OPT_ASM_X86 と OPT_ASM_X64 を追加
　　・デコード速度が高速化

/*---------------------------------------------------------------------------*/

3.12beta5(2024/03/16)

・本体の開発環境を C++Builder 12 v29.0.51511.6924 に更新
・各種プラグイン/DLL の開発環境を VS2022 17.9.3 に更新
・終了時に演奏してなくてもレジューム再生が利いてしまうことがあるのを修正
・起動直後等のプラグイン検索時、見つかったプラグインをロードする直前にそのパス
　を表示するようにした
　・バージョンアップ直後の初回起動に時間がかかってフリーズしてるように見えるの
　　を防ぐ効果
　・実際にフリーズした場合に原因となるプラグインが分かるようにする効果
　・2回目以降の起動時は基本的にプラグインをロードしないので表示されない
・デコーダプラグインで連続再生時、最後の曲の終端が再生されないのを修正
・kbflac.kpi に関する以下の修正
　・libFLAC を 1.4.3(2023/06/23) に更新
・kbGuru2SMF.kpi に関する以下の修正
　・DLS に対応
　　・プラグイン設定で DLS のパスを設定(| で区切ることで複数ファイル指定可)
　　・曲データと同じフォルダに DLS があればそれも使う
　　・音色が被る場合の優先順位は
　　　・曲データと同じフォルダ(見つかった順) => プラグイン設定(記述順)
　　・動作確認出来るデータがない
・kbm4a.kpi に関する以下の修正
　・FAAD2 を v2.11.1(2023/11/14) に更新
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 10.55(2024/03/12) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.7.4(2024/03/03) に更新
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.32.5(2024/02/17) に更新
　・プラグイン設定で選択可能なデコーダの数を増やした
・kbsnesapu.kpi に関する以下の修正
　・SNESAPU.DLL を 2.20.1.8272(2023/12/03) に更新
　・SNESAPU.DLL 2.20.0 以降の新サンプリングレートコンバータのノイズ対策
　　・実機エコー/FIR 処理 が true で再生周波数が 32001Hz 以上のとき
　　・KPI_MEDIAINFO::dwUnitSample に 10ms 相当の値(44100Hz なら441)を渡すことで
　　　必ず EmuAPU を 10ms 単位で指定する
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 7.0.7(2024/02/26) に更新
　・LZMA SDK を 23.01(2023/06/20) に更新
・kbwv.kpi に関する以下の修正
　・libwavpack を 5.7.0(2024/02/27) に更新
・kblibpng.dll に関する以下の修正
　・libpng を 1.6.43(2024/02/23) に更新
・kbzlib.dll に関する以下の修正
　・zlib を 1.3.1(2024/01/22 に更新

/*---------------------------------------------------------------------------*/

3.12beta4(2024/03/09)

・kbGuru2SMF.kpi に関する以下の修正
　・GuruGuruSMF4.dll に関する以下の修正
　　・ベースを v4.0.8 に更新
　　・DirectMusic 関連のオブジェクトの全ての操作をそれを作成したスレッド内のみ
　　　で行うようにした(Port.cpp を大幅修正)
　　・GGS4CloseDevice を呼んでから FreeLibrary すればフリーズしなくなった為、
　　　フリーズ対策として新設した後始末用API(GGS4Uninialize_k)を廃止
　・GuruGuruSMF が演奏停止を返してもすぐに本体には停止を返さず、１秒経過してか
　　ら返すようにした
　　・連続再生時に曲によっては最後の音が切れた感じになるため
　・GGS4Play() の option に渡す設定に対応
　　・ループ再生
　　・冒頭の空白をスキップ
　　・末尾の空白をスキップ
　　・マスターピッチ
　　・ノーマライズ
　　・エクスクルーシブ
・本体の更新はバージョン情報のみ

/*---------------------------------------------------------------------------*/

3.12beta3(2024/03/04)

・各種プラグイン/DLL の開発環境を VS2022 17.9.2 に更新
・kbGuru2SMF.kpi に関する以下の修正
　・タイミングによってデバイスを開けずに再生開始出来ないことがあるのを修正
　・複数のインスタンスを同時に作成出来るようになった
　　（プラグイン情報の Reentrant が Yes(MultipleInstance=∞) になった)
　　・GuruGuruSMF4.dll の API を新設
　　・公式版 GuruGuruSMF4.dll も使用可能(Reentrant が No になる)
　　・大変だった割にはメリットがほとんどない
　　・互換性は残してあるので、公式版の GuruGuruSMF4.dll を使用する他のアプリケ
　　　ーションからも使用可能(公式版同様アンロード時にフリーズする可能性はある)
　・CC111 を使用したループ曲を開いたときは KPI_MEDIAINFO::qwLoop に -1 を設定す
　　るようにした
　　・v3.12beta3 の仕様変更によるもの
　　・qwLoop を設定しないと本体はループ非対応のプラグインと見なして単曲リピート
　　　時でも本体の設定に応じた回数とフェード時間の SMF を生成して渡す
　　・その場合、プラグインがループ再生しようとしてもフェードアウトが終わってか
　　　らループポイントに戻ることになって無音になってしまう
・kbasio.kpi に関する以下の修正
　・本体の COM の初期化(STA/MTA)に影響せずに動作するようにした
　　・v3.12beta2 で動作しなくなった為
　　・プラグイン自身で作成したスレッド内で STA として COM を初期化
　　　(MTA だと動作せず)
　・IASIO::setSampleRate の戻り値をチェックするようにした
　　・サポート掲示板で指摘された件
・MIDI 対応演奏プラグインに関する以下の修正(本体の修正)
　・プラグインに SetRepeat を呼ばないのを修正
　・プラグインが CC111(ループ)に対応していてもループ再生が機能しないのを修正
　　・本体が渡す SMF データ自体がループとフェード処理を施したものである為、フ
　　　ェードアウトしてからループポイントに戻ることになり、戻っても無音が再生さ
　　　れてしまっていた
　・単曲リピート時、プラグインがループ対応のときはフェード処理を施さないデータ
　　を渡すようにした
　・↑の必要有無を判断するため、ループ曲のときは KPI_MEDIAINFO::qwLoop の値を
　　0 以外の値(具体的なループ時間または-1)に設定する必要がある
　・単曲リピートの設定変更時に曲データを開き直すようにした
　　・プラグインがループ非対応の場合は常にフェードアウトするデータを渡す
　　・プラグインがループ対応の場合は
　　　・単曲リピートが有効のときはフェードアウトしないデータを渡す
　　　・単曲リピートが無効のときはフェードアウトするデータを渡す
　　・ループ対応の判定の為、ループ対応の MIDI 演奏プラグインは単曲リピート時に
　　　同じデータ(プラグインに渡すデータとしては違うデータ)を2度開くことになる

/*---------------------------------------------------------------------------*/

3.12beta2(2024/03/01)

・各種プラグイン/DLL の開発環境を VS2022 17.9.1 に更新
・GuruGuruSMF4.dll を使用して DirectMusic で MIDI を再生する演奏プラグイン
　kbGuru2SMF.kpi を同梱
　・You さんがサポート掲示板で公開された v0.01 を Kobarin が引き継ぐ
・kbGuru2SMF.kpi に関する以下の修正(掲示板で公開された v0.01 からの変更点)
　・You さん製作の kbGuru2SMF.kpi v0.01 の開発を Kobarin が引き継ぐ
　・GuruGuruSMF4.dll を v4.0.6 から v4.0.7(を VS2022 でビルドしたもの)に変更
　・GuruGuruSMF4.dll を LoadLibrary して使うようにした
　・GuruGuruSMF4.dll に対する以下の修正
　　・VS2022 でビルド
　　・メモリリーク修正
　　・スリープ時にデバイスを閉じる処理が原因と思われる不具合(FreeLibrary 時にフ
　　　リーズ)の修正
　　・↑の為、GuruGuruSMF4.dll に後始末用API(GGS4Uninialize_k) を追加(他に方法
　　　が思いつかなかった)
　・GuruGuruSMF4.dll のパスを設定出来るようにした
　　・オリジナルの v4.0.7 は正常動作しない(v4.0.6 なら動作する)
・kbfmp.kpi に関する以下の修正
　・64bit版 WinFMP.dll が公開されたことに伴い、64bit 版の kbfmp.kpi_ のファイル
　　名を kbfmp.kpi に変更
・kbviv.kpi に関する以下の修正
　・本体の CoInitializeEx の呼び出しの有無やパラメータによらず動作するようにし
　　た
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.84.0.0 に更新
・ループタグ(LOOPSTART/LOOPLENGTH)を含む曲データのフェードアウト時に落ちること
　があるのを修正
・64bit 版で rcpcv.dll のロードに失敗すると以後 rcpcv.dll を導入しても本体を再
　起動するまでロードしなくなる(バージョン情報ダイアログでは導入済みと表示される
　が正しい情報を表示しない)のを修正
・本体の COM の初期化を STA から MTA に変更
　・kbviv.kpi が動作しなくなったがプラグイン側で対処

/*---------------------------------------------------------------------------*/

3.12beta(2022/11/08)

・演奏リストが更新されている状態のとき、OS をシャットダウン・再起動・サインアウ
　トするのを妨げないように(保存確認のダイアログを表示しないように)した
　・確認のダイアログに対して「いいえ」を選択したときの動作になる
　・終了時のリストの状態は保持されて次回起動時に確認される
・単曲リピートや連続再生時にスリープモードに入らないようにした
　・OS の「電源オプション」->「詳細設定->「マルチメディアの設定」->「メディア共
　　有時」の設定が「アイドリングがスリープ状態になるのを回避する」にしても、曲
　　の切り替え時に(切り替え前後で再生周波数が変わる場合等)デバイスを閉じる際に
　　スリープモードに入っていた
　・一部の Player プラグインで再生した場合は演奏停止してもスリープモードに入ら
　　ない(停止しただけではデバイスを閉じないから?)
　・演奏停止後にスリープモードに入らなくなる Player プラグインは以下の通り
　　・kbdmusic.kpi
　　・kbqt.kpi(MIDI 再生時のみ、*.mov では問題なし)
　・midiOut で MIDI を再生後に演奏停止してもスリープモードに入らない
　　(停止後も midiOut デバイスを閉じない為）
　・「アイドリングがスリープ状態になるのを回避する」にしてなくても再生中はスリ
　　ープモードに入らなくなる(設定出来るようにするべき？)
・kbvsti.kpi に関する以下の修正
　・AEffect::numInputs の値が 0 でないプラグイン(MAmiVSTi.dll)を使用すると落ち
　　るのを修正
　・プラグイン DLL のファイル名が "MAmiVSTi.dll" のときだけ effSetBlockSize に
　　渡すサイズを再生周波数の 30分の1 の値(44100Hz なら 1470)にするようにした
　　・音がぶつぶつ途切れる現象への対策
　　・正常に再生出来ないことに変わりはない
　　　(演奏開始直後の数秒間音が途切れる、音途切れが安定後もテンポがよれよれ)
　　・設定出来るようにした方が良いのかもしれないがプラグインによっては対応しな
　　　い値を渡すと本体を巻き込んで落ちてしまう
　・演奏開始時の初期化を強化(リセット系 SysEx を受信しないプラグインへの対策)
　　・CC/RPN を出来る限り初期値に設定、リセットオールコントローラー送信等
　　・リセットを受信しないプラグインを使用時に「キャッシュ」を true にして演奏
　　　を繰り返しても不自然になりにくくなった(VSTSynthFont で確認)
　　・プラグインによっては却って演奏が不自然になるかも(リセットオールコントロー
　　　ラーを送信するだけにしておいた方が良いかも)
　・「再生周波数」「音量」「音源リセット」「キャッシュ」の設定を x86/x64 版 で
　　区別して保存するようにした

/*---------------------------------------------------------------------------*/

3.11c(2022/10/23)

・64bit 版で「表示」メニューの「液晶:サイズ」を選択時に落ちるのを修正
・64bit 版で「waveIn による波形取得を行う」を有効時に Player プラグインで再生
　すると落ちる(現象は確認出来ないがそうなってもおかしくない)のを修正
・kbvsti.kpi に関する以下の修正
　・音量が実際には整数値でしか指定出来ていなかったのを修正

/*---------------------------------------------------------------------------*/

3.11b(2022/10/22)

・kbvsti.kpi に関する以下の修正
　・内部的に大幅な修正
　・設定項目に「キャッシュ」を追加
　　・曲切り替え時に前回使用していた Vsti プラグイン(以後単にプラグイン)のイン
　　　スタンスを使い回すかの設定
　・登録可能なプラグインの最大数を 8 個から 10 個に増やした
　　・もっと増やしても良いけど単体で MIDI 音源として使えるプラグインはそんなに
　　　ないような…。
　・プラグインごとに「再生周波数」「音源リセット」「キャッシュ」を設定出来るよ
　　うにした
　・複数ポート使用時にプラグインを複数回 LoadLibrary していたのを修正
　・プラグインのメソッドを全て同じスレッド（プラグインをロードしたのと同じスレ
　　ッド）から呼ぶようにした（↓の２点の不具合等が修正）
　・VSTi の設定ウィンドウを表示時の曲の切り替え、プラグインの再ロード、プラグイ
　　ンの切り替え等が不安定だった(本体が落ちたり、大量のダイアログボックスを発生
　　することがある)のを修正
　・VSTSynthFont v3.431(公開日時点で最新の有料版) でサウンドフォントを開こうと
　　するとダイアログが表示されずにフリーズするのを修正
　・audioMasterCallback の audioMasterGetTime に応じるようにした
　　・本体を巻き込んで強制終了・フリーズしていたプラグインのいくつかが動作する
　　　ようになった
　・Port-A 以外の設定画面を移動時にも他の画面と連動するようにした
・kbwavefile.kpi に関する以下の修正
　・64bit 版でダイアログ表示時に落ちる可能性があったのを修正

/*---------------------------------------------------------------------------*/

3.11a(2022/10/15)

・各種プラグイン/DLL の開発環境を VS2022 17.3.6 に更新
・64bit 版で「Drive」と「お気に入り」のポップアップメニューにアイコンが表示され
　なくなっていたのを修正
　・環境によってはメニュー表示後の動作が不安定になっていたかもしれない
・kbmpg123.kpi に関する以下の修正
　・32bit版/64bit版ともに「デコーダ」に「generic」しか選択出来なくなっていたの
　　を修正
　・AVX や SSE で最適化されたコードが無効になっていた
　・手違いでビルド時に ASM が無効になっていた

/*---------------------------------------------------------------------------*/

3.11(2022/10/11)

・libpng を 1.6.38(2022/09/16) に更新
・kbsnesapu.kpi に関する以下の修正
　・SNESAPU.DLL を 2.19.4.7822(2022/10/05) に更新
　・プラグイン自体に変更はないのでバージョンは変更せず
・kbungca.kpi に関する以下の修正
　・プラグインの開発環境を VC6 から VS2022 に更新
　　・GcaSDK を VC6 で DLL 化(kbungca.dll)し、kbungca.dll を介することでプラグ
　　　イン本体(kbungca.kpi)は VS2022 で開発するようにした
　　・kbungca.dll のビルドに VC6 が必要なのは変わりないが、kbungca.dll はほぼ更
　　　新する必要がない為、普段は VS2022 だけで開発できる
　　・GcaSDK(GcaSDK.lib) を VS2022 で直接使う方法があるなら教えて下さい(VC 版、
　　　.NET 版ともにリンカエラーになって使えない)
　・設定項目に「展開処理」を追加
　　・自動(ソリッドか否かで判断)、常にメモリ上に展開、常にディスク上に展開
　　　のいずれか
　　・メモリ上に展開するのが高速とは限らない
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 8.92(2022/10/07) に更新

/*---------------------------------------------------------------------------*/

3.11beta6(2022/10/08)

・旧仕様プラグインの設定画面を呼び出しても設定が反映されないことがあるのを修正
　(主に kbwinamp 対策)
・旧仕様プラグインの設定画面を表示するとプラグインに巻き込まれて本体が落ちるこ
　とがあるのを修正
　・設定画面を表示後、直ちに制御が戻るタイプのプラグインで、設定画面を閉じる前
　　にプラグインをアンロードするときに落ちる
　・設定画面が閉じられるまで待つことで対処(in_msx.dll+kbwinamp で確認)
・プラグイン設定画面の %Kbmplay% セクションに「別プロセス経由で使用」を追加
　・プラグインが頻繁に本体を巻き込んで強制終了・フリーズする場合に true
　・通常は false
　・64bit版の本体から32bit版のプラグインを使用する場合(その逆も)は無視される
　　(設定しようとしても常に false になる)
・kbvgm.kpi に関する以下の修正
　・ファイルを閉じるときに本体が落ちるのを修正
　　・なぜか本体がデバッグ版のときにしか発生しなかったがリリース版で発生しない
　　　のが不思議
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.6.6(2022/09/25) に更新

/*---------------------------------------------------------------------------*/

3.11beta5(2022/10/03)

・各種プラグイン/DLL の開発環境を VS2022 17.3.5 に更新
・展開後のサイズが 32MB を超えるGZ 圧縮された曲(VGM/S98等) のタグ取得時、メモリ
　リークしたりタグの取得が出来ないことがあるのを修正
　・タグの取得については展開後のサイズの制限を32MB から128MB に変更
・VGM のコメントの取得が出来てなかったのを修正
・上記２点は kbvgm.kpi による VGM のタグ取得とは別処理
・kbmdx.kpi に関する以下の修正
　・ベースとするソースコードを Yosshin 氏の Portable mdx decoder(2022/09/03) に
　　更新
　・64bit 版に対応
　・ローパスフィルタの設定が出来なくなった(常に有効)
　・ループ曲でない曲の曲長が今までより 2 秒長くなった
　　・v0.03 以前は返した曲長より 2 秒長く再生していた
　・本体からの再生周波数を 22050/44100/48000 しか受け付けなくした
　　（速度と音程がおかしくなるので）(v0.03 でも)
　・再生周波数を設定出来るようにした
・kbvgm.kpi に関する以下の修正
　・emu2413 を v1.5.9 に更新
　・タグ取得に対応
　　・基本的に本体のタグ取得ルーチンを使わないようにした
　　　・ヘッダが不正(?)で libvgm では取得出来ないデータに対してのみ使う
　　・使用する音源チップ(YM2612等)、フォーマットのバージョン(VGM 1.51等)
　　　の取得に対応
　　・Media エクスプローラによる一覧表示は低速になった
　・エミュレーションコア(以下、単にコア)で選択した番号と実際に使うコアの対応関
　　係が誤っているものがあったのを修正(YM2612等)
　　・ソースコードにハードコーディングしないでライブラリの機能を使うようにした
　・コアの選択/無効化の設定で GA20 が表示されないのを修正
　・コアの設定の組み合わせをプリセットに保存できるようにした(3つまで)
　・同じ音源チップを2つ使う場合にコアの選択/無効化を Chip #1 と Chip #2 のどち
　　らに対して適用するか設定できるようにした(ChipInstance)
　　・両方適用、Chip #1 のみ(Chip #2 は無効化)、Chip #2 のみ(Chip #1 は無効化)
　　　のいずれか
　　・Chip #2 を使用する曲データは非常に少ない
　　・別々にコアを指定することは出来ない(そこまで必要?)
　　・v0.10 では Chip #1 のみに適用、Chip #2 は既定のコア
　・サイズが大きいデータを再生時のメモリ使用量を削減(cym/mym/x1f を除く)
　・GZ 圧縮されたデータの展開後のサイズが 32MB を超えると最後まで再生されない
　　のを修正
　・GZ 圧縮された yrw801.rom に対応
　　・必要ないと思うが in_vgm.dll/VGMPlay は対応しているので念の為
　・一部の曲データ(VGM)を開くとフリーズするのを修正
　・zlib を内蔵するのをやめて本体と同じ場所にある kbzlib.dll を使うようにした
　　・プラグインのファイルサイズが小さくなった
・kbpxtone.kpi に関する以下の修正
　・ベースのソースコードを pxtone-source-code 220910a に更新
　　・IO 関係のインターフェースが変わっただけで音質等の違いはない
・kbunarc.kpi に関する以下の修正
　・TGZ を扱うと kbzlib.dll 内部でメモリリークするのを修正

/*---------------------------------------------------------------------------*/

3.11beta4(2022/09/26)

・kbvgm.kpi(同梱せずにプラグイン置き場で公開していたもの)に関する以下の修正
　・プレイヤー本体に標準同梱することにした
　・バージョン番号を kbs98.kpi/kbgym.kpi より使用優先度が高くなるようにした
　　・両プラグインの後継版としての意味もあるので
　・ベースとなるライブラリを libvgm v0.51.0 に更新(2022/08/03 のもの)
　・新たに拡張子 s98/gym/cym/mym/x1f に対応
　・拡張子 cmf を対応拡張子から除外
　・yrw801.rom のパスを設定出来るようにした
　　・サウンドチップに YMF278B を使用する曲で必要になることがある
・kbs98.kpi に関する以下の修正
　・kbvgm.kpi が本プラグインで対応する全ての形式に対応して本体に標準同梱された
　　為、存在意義がほぼなくなった
　・emu2413 を v1.5.9(2022/09/21) に更新
　・拡張子 s98 を有効化/無効化する設定を追加
　・拡張子 vgm/vgz を有効化/無効化する設定の既定値を有効から無効に変更
　・無効にしなくても既定で優先度が高い kbvgm.kpi の方が使われるが念の為
・kbgym.kpi に関する以下の修正
　・kbvgm.kpi が GYM にも対応して本体に標準同梱された為存在意義がほぼなくなった
　・libbzip2 を 1.0.8(2019/07/19) に更新
　　・bz2圧縮されたデータがない為動作確認出来ず
　　・S98 のような圧縮後に拡張子を変えただけのものとは違うらしい
　・拡張子 gym を有効化/無効化する設定を追加
　　・無効にしなくても既定で優先度が高い kbvgm.kpi の方が使われるが念の為
・kbflac.kpi に関する以下の修正
　・libFLAC を 1.4.1(2022/09/22) に更新

/*---------------------------------------------------------------------------*/

3.11beta3(2022/09/23)

・64bit 版でリストに名前を付けて保存時に落ちるのを修正
・kbfmp.kpi と kbpmd.kpi に関する以下の修正
　・kbfmp.kpi
　　・FileIO インターフェースを使わずに WinFMP.dll v0.51 でアーカイブ内の曲を再
　　　生するとテンポラリを削除出来ない(v0.18 では発生せず)のを修正
　・kbfmp.kpi/kbpmd.kpi 共通
　　・FileIO インターフェース使用時の動作改善
　　　・同じデータを何度も開いたり閉じたりしないようにキャッシュするようにした
　　　・キャッシュ機構は v1.16 から実装済みだったが手違いで無効になってた
・kbsap.kpi に関する以下の修正
　・libasap(asap.c/asap.h) を 5.2.0(2022/09/20) に更新

/*---------------------------------------------------------------------------*/

3.11beta2(2022/09/22)

・各種プラグイン/DLL の開発環境を VS2022 17.3.4 に更新
・プラグイン設定画面に関する細かい修正
・BOM なし UTF-8 の CueSheet で文字化けするのを修正
・kbfmp.kpi と kbpmd.kpi に関する以下の修正
　・kbfmp.kpi
　　・バージョン番号を kbpmd.kpi に合わせることにした(v1.13/1.14/1.15は欠番)
　　・64bit 版のプラグインを kbfmp.kpi_ という名前で配布することにした
　　　・WinFMP.dll の 64bit 版が公開されたら kbfmp.kpi にリネームすることで使用
　　　　可能になる
　　・WinFMP.dll v0.51 だとアーカイブ内で PVI 等の PCM に依存する曲データを再生
　　　出来ないのを修正(おそらく WinFMP.dll v0.51 のバグ)
　・kbmpd.kpi
　　・PMDWin.dll を v0.51(2021/12/19) に更新(VS2022 でビルド)
　　　・PMDWin.dll のメモリリーク修正
　・kbfmp.kpi/kbpmd.kpi 共通
　　・DLL のパスが未指定のときはプラグインと同じフォルダの DLL だけをロードし、
　　　失敗しても本体と同じフォルダ等からはロードしないようにした
　・FileIO インターフェースに対応(WinFMP.dll v0.19/PMDWin.dll v0.40 以降)
　　・アーカイブ内のデータを再生時に一時ファイルを作成しなくなった
　　　（アーカイブプラグインが対応している形式のみ）
　　・リズム音源のパスや PCM 検索パスのファイル名制限がなくなった
　　　（Unicode でしか表現出来ないものや MAX_PATH バイト以上の長さに対応)
　　・FileIO インターフェース未対応の DLL でも従来通り動作する
　　・設定により FileIO インターフェースを使わないようにすることも出来る
　・設定に関する以下の修正
　　・DLL の検索パス設定時のダイアログのフィルターを修正
　　　・WinFMP.dll.256/PMDWin.dll.256 等を選択出来るようにした
　　・General セクションに以下の設定項目を追加(3番目以降はFMPMD2000互換)
　　　・MultipleInstance
　　　・FileIO インターフェースを使う
　　　・FM を 55kHz で合成
　　　・PPZ8 駆動周波数
　　　・PCM がなくても強制的に再生
　　　・補間(PPS)
　　　・補間(P86)
　　　・補間(PPZ8)
　　　・UsePPS
　　　・SSG+RHY
　　　・PMD86->B2
　　　・PPZ8EM
　　　・設定画面に表示されるのは使用中のプラグインにとって有効な設定のみ
　　・Volume セクション追加（各パートの音量調整）
　　・PartMask セクション追加（パートマスク）
・kbemidi.kpi に関する以下の修正
　・emu2413 を v1.5.9(2022/09/21) に更新
　・emu2149 を 2022/09/13 のものに更新
　・emu76489 を 2022/09/13 のものに更新
・kbmsxplug.kpi に関する以下の修正
　・MGS の歌詞ウィンドウを開いた直後のサイズ処理がおかしかったのを修正
　・emu2413 を v1.5.9(2022/09/21) に更新
　・emu8950 を v1.1.2(2022/09/14) に更新
　・emu2149 を 2022/09/13 のものに更新
　・libkss を v1.1.2(2022/09/21) に更新

/*---------------------------------------------------------------------------*/

3.11beta(2022/09/16)

・本体の開発環境を C++Builder 11.2 (v28.0.46141.0937) に更新
・各種プラグイン/DLL の開発環境を VS2022 17.3.3 に更新
・kbflac.kpi に関する以下の修正
　・libFLAC を 1.4.0(2022/09/09) に更新
　・32bit(int) のデータに対応
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 8.70(2022/09/11) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.6.5(2022/08/21) に更新
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.30.2(2022/08/02) に更新
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.80.0.0 に更新
・kbsnesapu.kpi に関する以下の修正
　・SNESAPU.DLL を 2.19.3.7744(2022/07/02) に更新
　　・本プラグイン公開時点での最新版は 2.19.4.7818 だがβ版なので同梱せず
　・設定に関する以下の修正
　　・「同梱の SNESAPU.DLL を使う」と「SNSAPU.DLL のパス」を追加
　　　・「同梱の SNESAPU.DLL を使う」が false のときに「SNESAPU.DLL のパス」で
　　　　指定した場所の DLL を使う
　　・Temporary セクションの「エコー作業メモリ書き換え」を廃止
　　・General セクションに「実機エコー/FIR 処理」を追加
　　　・キー名とセクションを変えただけで「エコー作業メモリ書き換え」と同じ
　　・ Temporary セクションに以下を追加
　　　・「左右拡散度」
　　　・「フィードバック反転度」
　　　・「エンベロープ速度を同期」(SNESAPU.DLL v2.19.3以降)
　　　・「チャンネルミュート」と「チャンネルノイズ」
　　　・8桁の文字列で指定、オフにするチャンネルを 0、オンにするチャンネルを 1
　　　　　(例：10100010)
　　　　・0 以外の数字は 1 と見なす、数字以外の文字は 0 と見なす
　　　　　(102A0000 => 10100000)
　　　　・8桁ない場合、足りない桁は 0 と見なす
　　　　　(0011 => 00110000)
・kbtak.kpi に関する以下の修正
　・tak_deco_lib.dll を 2.3.3(2022/06/30) に更新
　・64bit 版の DLL が同梱されるようになったのでプラグインも 64bit に対応
　・tak_deco_lib.dll を LoadLibrary/GetProcAddress して使うようにした
　　(.lib が SDK に同梱されていない為)
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 6.1.7(2022/05/05) に更新
　・LZMA SDK を 22.01(2022/07/15) に更新
・kbwv.kpi に関する以下の修正
　・libwavpack を 5.5.0(2022/07/07) に更新
・kbzlib.dll に関する以下の修正
　・zlib を 1.2.12(2022/03/27) に更新
・プラグイン設定画面で使用中のプラグインを表示時（再生中の情報表示部の「プラグ
　イン」をダブルクリック時やプラグイン設定画面上の「使用中のプラグイン」をクリ
　ック時）、そのプラグインに設定が存在する場合はツリーのノードを展開して設定の
　存在に気づきやすくした

/*---------------------------------------------------------------------------*/

3.10(2021/07/10)

・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 6.34(2021/07/03) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.5.10(2021/07/04) に更新

/*---------------------------------------------------------------------------*/

3.10beta6(2021/07/04)

・各種プラグイン/DLL の開発環境を VS2019 16.10.3 に更新
・kbdshow.kpi に関する以下の修正
　・環境によって(VMware上のXPで確認)は動画をまともに再生出来なくなっていたのを
　　修正
　・動画のフルスクリーンでの再生に対応
　　・プラグイン設定で「最大化時フルスクリーン」を true にする
　・設定項目追加
　　・「最大化時フルスクリーン」
　・「動画の映像を再生」の設定が false のとき、MediaFoundation で動画を再生する
　　　とフリーズするのを修正
・kbmov.kpi に関する以下の修正
　・環境によって(VMware上のXPで確認)は動画をまともに再生出来なくなっていたのを
　　修正(ウィンドウサイズを変更しないと再描画されないなど)
　・動画のフルスクリーンでの再生に対応
　　・プラグイン設定で「最大化時フルスクリーン」を true にする
　・設定項目追加
　　・「最大化時フルスクリーン」

/*---------------------------------------------------------------------------*/

3.10beta5(2021/06/25)

・プラグイン設定画面でロードに成功してるのに失敗してるような表示になることがあ
　るのを修正
・プラグインで MIDI を再生時、曲の冒頭の液晶の表示がおかしくなることがあるのを
　修正
・kbwasapi.kpi を使用時かつデコーダプラグインで MIDI を再生時、演奏終了出来ない
　のを修正(kbwasapi.kpi のバグ)
・kbvsti.kpi に関する以下の修正
　・VSTi_x64_01(パス)の既定値を
　　Program Files\Roland\Sound Canvas VA\SOUND Canvas VA.dll
　　(Roland Content Store 版のインストール先)
　　が存在すればそのパス、なければ
　　Program Files\Vstplugins\Roland\Sound Canvas VA\SOUND Canvas VA.dll
　　(Roland Cloud 版のインストール先)
　　に設定するようにした
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 6.0.7(2021/06/11) に更新
・kbwasapi.kpi に関する以下の修正
　・IKpiOutDevice::Wait() から戻らなくなることがあるのを修正
　　・音が鳴らない状態で再生位置だけが進む
　　・v0.09 からのバグ
・kbflac.kpi/kbvorbis.kpi/kbopus.kpi/kbpxtone.kpi に関する以下の修正
　・libogg を 1.3.5(2021/06/04) に更新

/*---------------------------------------------------------------------------*/

3.10beta4(2021/06/21)

・各種プラグイン/DLL の開発環境を VS2019 16.10.2 に更新
・Media エクスプローラで隠しフォルダ・隠しファイルを表示しないようにした
　（Windows エクスプローラの設定に従う）
・ドキュメントや歌詞等を読み込み時、BOM なし UTF-8 を自動判別するようにした
・Windows Update や再生デバイスのドライバ更新等によりデバイスの識別子が変更され
　たとき、識別子が変更される前の設定を引き継ぐようにした
　・名称が同じで識別子が異なるデバイスがあり、一方が使用可能で他方が未接続の場
　　合は未接続の方を更新前のデバイスと見なしてその設定をコピーし、未接続の方は
　　削除する
・プラグイン設定画面に関する以下の修正
　・プラグイン名を選択時の「既定値に戻す」が正しく機能しないことがあるのを修正
　・キー名をダブルクリックしたら該当キーの設定を既定値に戻すようにした
　・Enter を押したら選択中のセクションの設定を直ちに適用するようにした
・ランタイムがインストールされてない環境でプラグインのロードに失敗したとき、プ
　ラグイン設定画面で「Failed to load Plug-in」と表示されないのを修正
・kbdshow.kpi と kbmov.kpi に関する以下の修正
　・ビデオレンダラーに関する以下の修正
　　・Enhanced Video Render(EVR) に対応
　　・Windows Vista 以降のときの既定値を VMR9 から EVR に変更
　　・選択肢の「Video Renderer(システムの既定)」を「Default Video Renderer」に
　　　変更
　　・選択肢に「Enhanced Video Render(EVR)」と「Old Video Renderer」を追加
　　・VMR7/VMR9 使用時に Windowless Mode で再生するようにした
　　・VMR7 と Default Video Renderer 使用時、
　　　HKEY_CURRENT_USER\SOFTWARE\Microsoft\Direct3D\Shims\EnableOverlays に
　　　本体のパスが書き込まれていたら削除するようにした
　　　・既に本体のパスが書き込まれていて値が 1 だと削除しても本体を再起動するま
　　　　で映像が真っ黒になることがある
　　　・削除してもしばらくするとまた書き込まれるのでやるだけ無駄かも
　　・DirectShow を使用して動画再生時、ウィンドウのタイトルバーに使用中のビデオ
　　　レンダラー名を表示するようにした(未知の場合は CLSID)
・kbtak.kpi に関する以下の修正
　・tak_deco_lib.dll を 2.3.1(2021/03/28) に更新
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.28.0(2021/06/05) に更新
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 6.29(2021/05/25) に更新
　・SDK がメジャーバージョンアップするまでバージョン番号を更新しないことにした
　　(SDK の更新のみの場合)
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.5.9(2021/05/16) に更新
・kbm4a.kpi に関する以下の修正
　・FAAD2 を v2.10.0 に更新
・kbsap.kpi に関する以下の修正
　・libasap を 5.0.1(2020/01/09) に更新

/*---------------------------------------------------------------------------*/

3.10beta3(2021/06/15)

・各種プラグイン/DLL の開発環境を VS2019 16.10.1 に更新
・デコーダプラグインに再生位置を渡すときの位置の更新頻度を高くした
・kbdshow.kpi に関する以下の修正
　・MediaFoundation 使用時、動画の映像部分の再生に対応
　　・映像と音声の同期に改善すべき点あり(再生速度変更時の動作が不自然など)
　・設定に関する以下の修正
　　・「QuickTime無効化」を追加(true にすると対応拡張子から .qt/.mov を外す)
　　・「MediaFoundationを使う」の既定値を true に変更
　　・「動画位置初期化」が true でもサイズは他の設定に従うようにした
　　・「演奏停止」の「演奏停止時ウィンドウ閉じる/ウィンドウ閉じると演奏停止」を
　　　廃止
　　・DirectShow での動画再生時の映像と音声の同期に関する設定追加
　・動画を最大化状態で再生時、シークや曲の切り替え時に元のサイズに戻るのを修正
・kbmov.kpi に関する以下の修正
　・重複コードを減らして省サイズ化
　・MediaFoundation 使用時のメモリリーク修正
　・動画を最大化状態で再生時、シークや曲の切り替え時に元のサイズに戻るのを修正
・kbqt.kpi に関する以下の修正
　・「QuickTime無効化」の設定を追加
　　・true にすると対応拡張子から .qt/.mov を外す
・kbwasapi.kpi に関する以下の修正
　・再生位置取得の精度が向上

/*---------------------------------------------------------------------------*/

3.10beta2(2021/06/01)

・各種プラグイン/DLL の開発環境を VS2019 16.10.0 に更新
・kbmov.kpi が MediaFoundation に対応することにより、追加の DirectShow フィルタ
　が導入されてなくても(Windows7 以降であれば)標準で MP4 に対応
・kbdshow.kpi に関する以下の修正
　・動画ウィンドウのクライアント領域の縦横比を設定出来るようにした
　　・動画ウィンドウのサイズを(幅だけでなく高さも)固定したい場合に設定する
　・演奏が停止したら動画ウィンドウを閉じる設定を追加
　・データによってはマルチチャンネルを返して再生出来ないことがあったのを修正
　・対応拡張子(DS)の既定値から MP4 関係(.3gp/.3g2/.m4v/.mp4) を外した
　　・追加の DirectShow フィルタ未導入の環境では再生出来ない為
　・「ストリームから開く」の既定値を false に変更
　　・Splitter フィルタ(LAV Splitter 等)がないと WMV を開けないため
　・選択可能なビデオレンダラーに VMR7 を追加
　　・WindowsXP では既定値とした
　　・Windows10(7, 8も?) では、レジストリに実行ファイルのパス情報が書き込まれて
　　　一部の動画形式(.mpg で確認)において映像部分が表示されなくなる現象が確実に
　　　発生するので推奨しない(詳細はプラグイン設定のヘルプを参照)
　・「ストリームから開く」有効時、対象データのファイル名が要求されたら通知する
　　(パスを除いた部分のみ)ようにした(効果は不明)
　　・LAV Splitter からは要求が来るが LAV Splitter 無効時は要求が来ない
　・設定項目追加
　　・DS/MF優先(拡張子が DS/MF ともに有効時に DS/MF どちらで再生するか)
　　・動画縦横比(動画ウィンドウの幅と高さを固定したいときに指定)
　　・演奏停止(演奏停止時に動画ウィンドウを閉じるかどうか)
・kbmov.kpi に関する以下の修正(kbdshow.kpi と共通する部分が多い)
　・MediaFoundation に対応
　　・Windows7 以降であれば DirectShow フィルタを入れなくても標準で mp4 に対応
　・対応拡張子(DS)の既定値から MP4 関係(.3gp/.3g2/.m4v/.mp4) を外した
　　・追加の DirectShow フィルタ未導入の環境では再生出来ない為
　・「ストリームから開く」の既定値を false に変更
　　・Splitter フィルタ(LAV Splitter 等)がないと WMV を開けないため
　・選択可能なビデオレンダラーに VMR7 を追加
　　・WindowsXP では既定値とした
　　・Windows10(7, 8も?) では、レジストリに実行ファイルのパス情報が書き込まれて
　　　一部の動画形式(.mpg で確認)において映像部分が表示されなくなる現象が確実に
　　　発生するので推奨しない(詳細はプラグイン設定のヘルプを参照)
　・「ストリームから開く」有効時、対象データのファイル名が要求されたら通知する
　　(パスを除いた部分のみ)ようにした(効果は不明)
　　・LAV Splitter からは要求が来るが LAV Splitter 無効時は要求が来ない
　・設定項目追加
　　・DS/MF優先(拡張子が DS/MF ともに有効時に DS/MF どちらで再生するか)

/*---------------------------------------------------------------------------*/

3.10beta(2021/05/21)

・各種プラグイン/DLL の開発環境を VS2019 16.9.5 に更新
・プラグインに本体の再生位置を通知する機構に関する改善(kbdshow.kpi 用)
　・ギャップレスで曲を切り替えたときやクロスフェードしたときの通知する位置が正
　　しくないことなど
・動画を再生中はスクリーンサーバーの起動を防止するようにした
・「演奏2」=>「Video」による動画のサイズ指定に関する以下の修正
　・「前回と同じ」を追加
　・横幅のサイズで指定
　・100% 時のサイズより小さくならないのをやめ、指定サイズの方が小さくても指定通
　　りのサイズになるようにした
　・kbdshow.kpi で動画を再生中は機能しない(デコーダプラグインの仕様で制御不可)
・デコーダプラグインが動画のサイズ情報を返しても情報表示部に表示しないのを修正
・拡張子が競合するとき、Player プラグインを優先使用していたのを Deocder プラグ
　インを優先するように仕様変更
・kbdshow.kpi に関する以下の修正
　・大幅にバージョンアップ（ほぼ作り直し）
　・対応拡張子を64bit版と32bit版で区別するのをやめた
　　・どちらか一方でしか再生出来ない形式が見当たらない為
　・動画の映像部分の再生に対応
　　・ある程度完成度が上がって来たら kbmov.kpi を廃止予定
　　・単曲リピート時、先頭に戻った直後にプラグインに対して返す再生位置情報が不
　　　正確なため、終端付近の映像が止まってしまう＆冒頭の映像が正しく表示されな
　　　かったり、止まったまま動かなくなってしまうことがある
　　・サイズや「常に手前に表示」等の設定は本体の「演奏2->Video」からでは制御出
　　　来ない(プラグイン設定で設定可能)
　・ビデオレンダラーに VMR9 と madVR を選択可能(madVR は別途インストール必要)
　・非推奨のインターフェース(IAMMultiMediaStream)の使用をやめて Renderer Filter
　　を内蔵することにより各種不具合修正・改善
　　・LAV Filters 導入時にビット数を正しく取得出来ずに爆音ノイズが発生するのを
　　　ほぼ修正(wavpack の 32bit float だけ int と区別出来ない為、爆音ノイズに
　　　なる)
　　・山岡忠夫氏の wavext v1.05 のソースコードを参考
　・Source Filter を内蔵することによりストリームから開けるようになった
　　・アーカイブ内の曲を一時ファイルを作成しないで展開しながら、またはメモリ上
　　　に展開しての再生に対応
　　・アーカイブを実際にどう処理するかはアーカイブプラグインによる
　　・Gandharva 151108 版(作者名不明)のソースコードを参考
　・Media Foundation(DirectShow の後継とされるもの) に対応
　　・映像には未対応(対応したら追加の DirectShow フィルタなしで mp4 に対応予定)
　　・追加の DirectShow フィルタなしで再生出来る形式が少し増えるが、音楽系(mp3/
　　　aac/m4a/flac等)は標準同梱の専用プラグインがあり、動画系(mp4/3gp等)は映像
　　　に未対応なので現状ではほぼ無意味
　　・有効時は Media Foundation => DirectShow の順に開く
　　・K-Lite Codec Pack 等のコーデックパックを入れても再生可能な形式は増えない
　　　(増えるのは DirectShow の方)
　　・プラグイン設定で有効/無効の切り替え可能。既定は無効
　・設定項目追加
　　・対応拡張子
　　　・編集不可。「対応拡張子(DS/MF)」 と「DirectShow/MediaFoundationを使う」
　　　　の設定により決定される
　　・対応拡張子(DS)
　　・対応拡張子(MF)
　　・DirectShow を使う
　　・Media Foundation を使う(今のところ利用価値なし)
　　・ストリームから開く
　　・動画関係
　　　・動画の映像を再生
　　　・常に手前に表示
　　　・動画のサイズ
　　　・動画位置初期化
　　　・ビデオレンダラー
　・既定の対応拡張子に動画関係追加
・kbmov.kpi に関する以下の修正
　・kbdshow.kpi 同様の大幅修正
　・対応拡張子を64bit版と32bit版で区別するのをやめた
　　・どちらか一方でしか再生出来ない形式が見当たらない為
　・ビデオレンダラーを選択出来るようにした
　・設定項目追加
　　・kbdshow.kpi と大体同じ
　　・対応拡張子
　　　・編集不可。「対応拡張子(DS/MF)」 と「DirectShow/MediaFoundationを使う」
　　　　の設定により決定される
　　・対応拡張子(DS)
　　・対応拡張子(MF)
　　・DirectShow を使う(MediaFoundation が未実装な為、設定は無視される(常に使う
　　　))
　　・Media Foundation を使う(未実装、設定は無視される)
　　・ストリームから開く
　　・動画関係
　　　・動画の映像を再生
　　　・ビデオレンダラー
・kbvsti.kpi に関する以下の修正
　・演奏終了出来ない曲があったのを修正
　　・曲長まで再生してからの無音検出を最大5秒で打ち切る処理の計算ミス
・kbqt.kpi に関する以下の修正
　・再生の必要が生じるまでライブラリを初期化しないようにした
　　(プラグインのロード時間短縮の為)

/*---------------------------------------------------------------------------*/

3.09b(2021/05/03)

・プラグイン設定画面でアクセス違反等のダイアログが表示されることがあるのを修正
・Windows 10 の神モードアイコンが存在するフォルダを Media エクスプローラで選択
　するとアクセス違反のダイアログが表示されるのを修正
・プラグイン設定画面の検索条件に '|'(OR) を指定出来るようにした
　・拡張子 .mid 以外で本体に MIDI と見なされる形式を再生中に「再生中」をクリッ
　　ク時に使用

/*---------------------------------------------------------------------------*/

3.09a(2021/05/01)

・拡張子 .mid 以外で本体によって MIDI と見なされる拡張子に対応するデコーダプラ
　グイン(kbzmdrive.kpi(zms/zmd) / auPiECE.kpi(pmd) 等)を使用して連続再生すると
　メモリリーク(再生中に一時ファイルが作成された場合に削除されない、長時間連続再
　生すると動作が不安定になるなど)していたのを修正
　・一時ファイルは本体終了時に削除されるが動作中は作成されたままになっていた
　・該当プラグインが限られるので実害はあまりなかったかも
・連続再生時、主に無音検出により演奏終了した次の曲がスキップされる(ファイルは開
　くが再生されないまま次の曲に切り替わる)ことがあるのを修正
　・滅多にないはずだがまだ発生するかもしれない(ギャップレス再生が間に合わなかっ
　　たときに発生し、間に合わなかったことの検出がタイミング次第となる為)
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.76.0.0 に更新(プラグインのバージョン番号は変更せず)

/*---------------------------------------------------------------------------*/

3.09(2021/04/18)

・サイト移転に伴い、添付ドキュメント等の URL を修正
・本体の開発環境を C++ Builder 10.4.2 (v27.0.40680.4203) に更新
・各種プラグイン/DLL の開発環境を VS2019 16.9.4 に更新
・動画再生時に演奏停止したら動画ウィンドウを閉じるようにした
・kbswf.kpi 配布終了、SWF を再生出来なくなった
　・Adobe Flash Player サポート終了に伴い、動作しなくなったため
・kbflac.kpi に関する以下の修正
　・libFLAC を 1.3.3(2019/08/04) に更新
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 6.14(2021/03/18) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.5.8(2021/04/11) に更新
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.26.5(2021/03/22) に更新
・kbopus.kpi に関する以下の修正
　・opusfile を 0.12(2020/06/27) に更新
・kbpxtone.kpi に関する以下の修正
　・libvorbis を 1.3.7(2020/07/04) に更新
・kbvorbis.kpi に関する以下の修正
　・libvorbis を 1.3.7(2020/07/04) に更新
・kbwv.kpi に関する以下の修正
　・libwavpack を 5.4.0(2021/01/10) に更新
・kbsnesapu.kpi に関する以下の修正
　・snesapu.dll を 2.18.3.7258(2021/03/14) に更新
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.75.0.0 に更新
・kbpmd.kpi に関する以下の修正
　・PMDWin.dll を v0.39(2020/08/16) に更新(VS2019 でビルド)
・kbmsxplug.kpi に関する以下の修正
　・emu2413 を v1.5.6(2021/02/28) に更新
　・emu8950 を v1.0.1(2020/02/12) に更新
　・libkss を 2021/02/05 のものに更新
　・MSXplug(in_msx) v1.8.0(2020/02/12) を組み込み
・kbs98.kpi に関する以下の修正
　・emu2413 を v1.5.6(2021/02/28) に更新
　・VGM(*.vgm/*.vgz) の有効化/無効化を設定出来るようにした
　　・他の VGM 対応プラグインを使用したい場合に無効化する
・kbemidi.kpi に関する以下の修正
　・emu2413 を v1.5.6(2021/02/28) に更新
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 6.0.5(2021/04/07) に更新

/*---------------------------------------------------------------------------*/

3.08(2020/01/19)

・各種プラグイン/DLL のコンパイラを VS2019 16.4.3 に更新
・ファイルやフォルダのパスの設定があるプラグインの設定時、選択ダイアログが無限
　ループすることがあるのを修正
・プラグイン設定画面で落ちることがあるのを修正
・64bit版で vcruntime140_1.dll がない場合、起動時に最新のランタイムインストール
　を促すダイアログを表示するようにした(プラグインをロード出来ないため)
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 5.14(2020/01/15) に更新

/*---------------------------------------------------------------------------*/

3.08beta3(2020/01/14)

・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.71.0.0 に更新
・kbpmd.kpi に関する以下の修正
　・PMDWin.dll を v0.37(2020/1/12) に更新(VS2019 でビルド)
・kbmsxplug.kpi に関する以下の修正
　・emu2413 を v1.2.7(2020/1/11) に更新
　　(libkss 2020/1/11 版は emu2413 以外は 2020/1/3 版と同じ)
・kbemidi.kpi に関する以下の修正
　・emu2413 を v1.2.7(2020/1/11) に更新

/*---------------------------------------------------------------------------*/

3.08beta2(2020/01/03)

・本体のコンパイラを C++Builder 10.3.3 (v26.0.36039.7899) に更新
・各種プラグイン/DLL のコンパイラを VS2019 16.4.2 に更新
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.25.13(2019/10/26) に更新
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 5.12(2020/01/02) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.4.11(2019/12/22) に更新
・kbwv.kpi に関する以下の修正
　・libwavpack を 5.2.0(2019/12/15) に更新
・kbmsxplug.kpi に関する以下の修正
　・emu2413 を v1.1.0(2020/1/3) に更新
　・libkss を 2020/1/3 のものに更新
・kbemidi.kpi に関する以下の修正
　・emu2413 を v1.1.0(2020/1/3) に更新
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 5.8.5 に更新
・nwdll.dll に関する以下の修正
　・libjpeg を libjpeg 9c(2018/01/14)に更新

/*---------------------------------------------------------------------------*/

3.08beta(2019/10/03)

・本体のコンパイラを C++Builder 10.3.2 (v26.0.34749.6593) に更新
・各種プラグイン/DLL のコンパイラを VS2019 16.3.2 に更新
・歌詞の検索パスを空白にすると実際は \ になってドライブ全体を検索してしまうのを
　修正(\ を指定しても無視するようにした)
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.25.12(2019/08/24) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.4.8(2019/9/30) に更新
・kbflac.kpi/kbvorbis.kpi/kbopus.kpi に関する以下の修正
　・libogg を 1.3.4 に更新
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.92(2019/8/26) に更新
・kbsnesapu.kpi に関する以下の修正
　・snesapu.dll を 2.18.0.6694(2019/08/10) に更新
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 5.8.2 に更新
・kblibpng.dll に関する以下の修正
　・libpng を 1.6.37(2019/4/15) に更新

/*---------------------------------------------------------------------------*/

3.07(2019/06/23)

・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.78(2019/6/18) に更新

/*---------------------------------------------------------------------------*/

3.07beta5(2019/06/19)

・kbm4a.kpi に関する以下の修正
　・タグを取得出来ないことがあるのを修正
・ループ MIDI を正しくループ再生出来ないことがあるのを修正
・各種プラグイン/DLL のコンパイラを VS2017 15.9.13 に更新

/*---------------------------------------------------------------------------*/

3.07beta4(2019/06/06)

・kbm4a.kpi に関する以下の修正
　・FAAD2 を v2.8.8 に更新
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.74(2019/6/1) に更新
・kbmod.kpi に関する以下の修正
　・libopenmpt を 0.4.5(2019/5/27) に更新
・各種プラグイン/DLL のコンパイラを VS2017 15.9.12 に更新
・デバイス設定ボタン右側に▼を2つ表示するようにした(WAVEデバイスとMIDIデバイス)
・無音検出の処理を改善
・*.tag や NEZplug 拡張m3u/pls に曲長が記述されているとき。記述された時間まで再
　生してから無音検出を開始する筈が再生開始直後から検出していたのを修正
　（ファイル自体に曲長を記述出来ない形式で冒頭に長い無音があると、検出を無効に
　　する以外にどうしようもなかった）
・ファイルの終端が再生されないことがあるのを修正
・32bit OS で 64bit プラグインが見えてしまうことがあるのを修正
・Media エクスプローラのちらつきを改善
・IKpiFolder::OpenFile/OpenFolder で渡すファイル名/フォルダ名のパスの区切り文字
　に \ を使うと(実体がアーカイブの中にあると)失敗するのを修正
　・kbxsf.kpi でアーカイブ内でディレクトリ階層が異なる xsflib.lib を参照するデ
　　ータが開けなかったのが修正される

/*---------------------------------------------------------------------------*/

3.07beta3(2019/05/12)

・kbpsf.kpi に関する以下の修正
　・viopsf.bin を kbpsf.kpi に内蔵するのをやめた
　・viopsf が更新されたとき、viopsf.bin を置き換えるだけで動作するようにした
　　(viopsf.bin のインターフェースに変更がなければ)
　・音量(%) の設定を追加
　・音量(%) と volume タグを重ねて適用した結果が 100% 以外のときだけ 64bit
　　float で出力するようにした
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.69.0.0 から 1.70.0.0 に差し替え
　・viopsf2 が更新されたとき、viopsf2.bin を置き換えるだけで動作するようにした
　　(viopsf2.bin のインターフェースに変更がなければ)
　・音量(%) の設定を追加
　・音量(%) と volume タグを重ねて適用した結果が 100% 以外のときだけ 64bit
　　float で出力するようにした
・kbwasapi.kpi に関する以下の修正
　・リソースリーク(イベントハンドルの閉じ忘れ)を修正
・kbzlib.dll に関する以下の修正
　・アセンブラによる最適化コードを組み込み(64bit版のみ)
・Media エクスプローラ右クリックメニューの「設定」に以下を追加
　・「1ファイル複数曲を一覧表示」
　　(1ファイル複数曲を含むフォルダをツリービューで選択時の動作)
　　・オンにするとリストビューに直接一覧表示
　　・オフにするとリストビューにはファイル名のみが表示され、ダブルクリックする
　　　かツリービューで選択してから一覧表示
　　・オフの場合は「1ファイル複数曲をフォルダ表示」が無視され、常にフォルダ表示
　・曲数が多い形式(NSF等)を多数含むフォルダを選択時はオフ、1曲が多いがたまに複
　　数のときがある形式(SID/SAP/MOD等)を含むフォルダを選択時はオンがお勧め
・プラグイン検索の階層の深さを3階層から5階層までに変更
・拡張子snsf/minisnsf/ncsf/minincsfのタグ取得に対応

/*---------------------------------------------------------------------------*/

3.07beta2(2019/05/05)

・kbemidi.kpi に関する以下の修正
　・emu2413 を 2019/3/24 のものに差し替え
・kbmsxplug.kpi に関する以下の修正
　・emu2413 と libkss を 2019/3/24 のものに差し替え
　・ダイアログのレイアウトを調整(高DPI環境で文字列が途切れないように)
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 5.7.5 に差し替え
・kbmod.kpi に関する以下の修正
　・複数の曲を含む場合の曲長が曲番号によらず全曲の長さになっていたのを修正
・DLL 検索パスに作業ディレクトリを含まない環境だと動作しないプラグインがあった
　のを修正(kbtak.kpi/kbofr.kpi/kbtvq.kpi)
・プラグインがタグ取得に対応していると本体がデフォルトのタグ取得ルーチンを正し
　く処理出来ないことがあるのを修正

/*---------------------------------------------------------------------------*/

3.07beta(2019/05/03)

・kbmod.kpi に関する以下の修正
　・ベースを libopenmpt 0.4.4(2019/4/7) に変更
　・対応形式の追加(.mo3 等)
　・対応形式の全てを1ファイル複数曲として通知するようにした
　　・1ファイル複数曲となり得ない拡張子があるか分からないので
　　・mod/it/s3m 等の一般的な MOD 形式にも複数曲含むものが存在する
　・以下の設定を廃止
　　・エフェクト関係全般
　　　・ライブラリが対応しない為
　　・対応拡張子
　　　・無効化は本体によって生成される %Kbmplay% セクションで行う
　・以下の設定を追加
　　・Stereo Separation
　　・Interpolation filter length
　　・Use Amiga Resampler
　・タグ取得に対応
　　・本体のルーチンを使わない
　　・本体よりも多くの形式に対応＆詳細な情報を取得
・kbsid.kpi に関する以下の修正
　・フリーズするデータがあったのを修正
　　・該当データは正しく再生出来ない
　・タイトル/アーティスト/著作権の取得に対応
　　・本体のルーチンを呼ばないようにする
　・再生が必要になるまでなるべく余計な処理をしないようにした
　　・Media エクスプローラでの一覧表示等が高速化
・kbopus.kpi に関する以下の修正
　・libopus を 1.3.1(2019/4/12) に差し替え
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.70(2019/4/28) に差し替え
・kbsap.kpi に関する以下の修正
　・libasap 4.0.0(2019/1/10) に差し替え
・1ファイル複数曲(NSF等)に関する以下の修正
　・Media エクスプローラで曲番号ごとの一覧を直接表示するようにした(フォルダのよ
　　うに表示する必要がなくなった)
　・曲数が 1 のときは曲番号を表示しないようにした
　・ある条件で1ファイル複数曲として認識出来ないことがあるのを修正
　・アーカイブ内にあるとプレイリストに追加出来ないことがあるのを修正
・Media エクスプローラ右クリックメニューの「設定」に以下を追加
　・「1ファイル複数曲をフォルダ表示」
　　・リストビューに直接一覧表示するようにしたのでデフォルトは「オフ」
　・「フォルダの更新監視」
　　・オンにするとフォルダの追加・移動・削除がツリービューで自動的に反映される
　　・オフにすると反映されない(「最新の情報に更新」で反映)
　　・デフォルトは「オン」(従来の動作)
・フォルダの更新を Media エクスプローラで反映時、リストビューはなるべく更新しな
　いようにした
　・ツリービューで選択中のフォルダかその親フォルダが更新されたときだけ更新
　・更新されたフォルダをリストビューに表示していた場合、リストビューでは変更が
　　反映されないので、反映させたければ選択し直すか「最新の情報に更新」
・バージョン情報ダイアログでプラットフォームが反対の VS2019 ランタイムのバージ
　ョンも表示するようにした(64bit OS で動作時)
・ランタイム未インストール状態で実行すると、ランタイムをインストールしてもプラ
　グインが無効化されているのを修正

/*---------------------------------------------------------------------------*/

3.06a(2019/04/19)

・kbpsf2.kpi に関する以下の修正
　・再生周波数が 44100Hz になっていたのを修正(正しくは48000Hz)
　　・音程が低く、再生速度が遅くなっていた
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 5.7.4 に差し替え

/*---------------------------------------------------------------------------*/

3.06(2019/04/15)

・kbpxtone.kpi に関する以下の修正
　・設定項目を追加
　　・音量
　　　・音割れが気になる場合や、連続再生時に他の形式と比べて音量が大きいと感じ
　　　　る場合に小さくする
　　・ループ回数
　　・フェード時間(秒)
　　・ループ判別
　　　・判別条件に従う
　　　・ループと見なさない
　　　・ループと見なす
　　・イントロがない曲をループと見なす
　　　・ループと見なすと連続再生時に「ループ回数」と「フェード時間」に応じた時
　　　　間だけ再生される
　　　・実際はループ曲なのにループと見なさなくても単曲リピート時には問題なくル
　　　　ープ再生される
　　　・実際はループ曲なのにループと見なさないと連続再生時にフェードアウトされ
　　　　ずにぷつっと途切れるように演奏終了する
　　　・イントロがなくてループである曲は少ない為、デフォルトは false
　　・イントロ時間/ループ時間
　　　・イントロに対してループが短い曲の多くはループではないが、どの程度長けれ
　　　　ばループなのか確実に判別することは出来ないのでこの設定で調整する
　・64bit float で出力するようにした
　　・クリッピングを最終出力の直前まで先送りする
　　・音量を 1.0 以外にした時に失われる情報を最小限に抑える
　・音量の初期値を 0.8 に変更(v0.01 では 1.0)
　・イントロがあるループ曲の2ループ目以降の位置へのシークが誤っていたのを修正
　・拍子、テンポ、クロック、小節数等を通知するようにした
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.63b(2019/4/11) に差し替え
・タグ取得時、コメントについては空白のトリム処理をしないようにした
・プラグインから取得したループ曲のループ回数が 1 だと「ループ回数を曲から取得」
　の設定に関わらず「デフォルトのループ回数」にしていたのを修正

/*---------------------------------------------------------------------------*/

3.06beta2(2019/04/10)

・ピストンコラージュ(pttune/.ptcop)に対応(kbpxtone.kpi)
・シーク時のプラグインに対するサンプル単位の位置指定が誤っていたのを修正
・ウィンドウスナップ(画面端に吸い付く処理)を VCL の機能を使うようにした＆スナッ
　プの度合いを控えめにした
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.61(2019/4/3) に差し替え

/*---------------------------------------------------------------------------*/

3.06beta(2019/04/08)

・各種プラグイン/DLL のコンパイラを VS2017 15.9.11 に変更
・バージョン情報ダイアログ等のランタイム関係の表示を VS2019 に変更
　・開発環境は未だ VS2017 だがランタイムは互換性があるようなので
・kbnezplug.kpi に関する以下の修正
　・NEZplug++ 0.9.4.8 + 3 + 24.10 に差し替え
　・メモリを壊している箇所があったのを修正(s_fds1.c/s_fds2.c)
　　・該当箇所が呼ばれる条件が不明
・kbpsf.kpi に関する以下の修正
　・viopsf を v0.14 に差し替え
　・以下の設定項目を追加
　　・「spuEternal.dll のパス」
　　・「spuEternal.dll を使う」
　　・ともに 32bit 版の kbpsf.kpi でのみ有効。64bit版では設定は無視される
・kbpsf2.kpi に関する以下の修正
　・viopsf2 を v0.10beta に差し替え
・先頭へのシークの戻り値が先頭でないプラグインでギャップレス再生や単曲リピート
　をすると再生位置がずれるのを修正
　・kbtim95.kpi で「冒頭の無音をスキップ」を true にした場合

/*---------------------------------------------------------------------------*/

3.05c(2019/03/29)

・各種プラグイン/DLL のコンパイラを VS2017 15.9.10 に変更
・kbunarc.kpi に関する以下の修正
　・ファイル名が UTF-8 で格納された CAB を開くと落ちるのを修正
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.60(2019/3/18) に差し替え
・不正な PNG 画像を読み込むと「外部例外」と出るのを修正(64bit版で発生)

/*---------------------------------------------------------------------------*/

3.05b(2019/03/17)

・各種プラグイン/DLL のコンパイラを VS2017 15.9.9 に変更
・kbwsr.kpi に関する以下の修正
　・KPI_MEDIAINFO::dwUnitSample を 10ms 相当に変更
　　・本体 v3.05 以降で演奏がおかしくなるため
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.59(2019/3/15) に差し替え
・kbswf.kpi に関する以下の修正
　・プラグイン設定から「Flash Player 設定マネージャー」を開けるようにした
　　・kbswf.kpi の再生品質に関わる設定があるかどうかは不明
・SWRD/NWRD の標準サイズ(640x480)時の画質が汚かったのを修正
・プラグイン設定でリストやリストの表示名に空文字列を使用出来ないのを修正
　・標準同梱で該当するプラグインはない
　・プラグイン置き場の kbhtsfms.kpi v0.06alpha が該当

/*---------------------------------------------------------------------------*/

3.05a(2019/03/12)

・MDS と RMI が再生出来なくなっていたのを修正
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.56(2019/3/10) に差し替え

/*---------------------------------------------------------------------------*/

3.05(2019/03/10)

・各種プラグイン/DLL のコンパイラを VS2017 15.9.8 に変更
・デコーダプラグインに Render で渡す dwSizeSample の値を調整(少し大きめにする
　ことにより全体的に高速化)(dwUnitRender=0 のとき)
・MIDI に関する以下の修正
　・末尾の SysEx を捨てていたのを修正
　　・該当データで曲長が変わる為、演奏リストに該当データを含むと再生時や曲長計
　　　算時に「Updated」になる
　・プラグインで MIDI を再生時、「演奏2」->「MIDI」->「PortMode」が「Track17-32
　　to Port-B, 33-48 to Port-C...」のときに複数ポートと見なされるような曲で、発
　　音(ノートオン)情報が含まれないポートの情報がプラグインに渡されないのを修正
　　・Port-B に SysEx しか含まない場合など
　　・↑のようなデータの解釈の仕方はプラグインに委ねる
　・SysEx のみ使用し、発音データを含まないポートは情報表示パネル上で「(Port-B)
　　」のように () で括って表示するようにした
　・複数ポートMIDI を MIDI デコーダプラグインで再生時、液晶の表示が32パート用に
　　切り替わることがあるのを修正
　・midiOut で MIDI を再生時の「プラグイン」部の表示を「Internal MIDI Player」
　　から「midiOut MIDI Player」に変更
・本体内蔵 CD プレイヤーでオーディオ CD 再生時の「プラグイン」部の表示を「Inter
　nal CD Player」から「MCI CD Player」に変更
・kbfmmidi.kpi に関する以下の修正
　・KPI_MEDIAINFO::dwUnitSample 値を 0 にしていたのを 10ms 相当になるように修正
　　・Render の dwSizeSample 値が大きいとテンポがよれよれな感じになる為、本体の
　　　実装により再生結果が変わっていた(dwUnitSample=0 のときに dwSizeSample を
　　　いくつにするかが本体の実装により変わる)
　・再生位置が本来より後ろにずれていたのを修正
　　・ずれの度合いは本体の実装によって変わる
　　・v3.04〜v3.05beta4 だと 44100Hz で 約12ミリ秒
　・複数ポートMIDI再生時、リセット系とマスターボリューム系の SysEx を全てのポー
　　トに送信するようにした
　　・他にも全てのポートに送信すべき SysEx があるかも
・kbemidi.kpi に関する以下の修正
　・複数ポートMIDI再生時、SysEx を全てのポートに送信するようにした
　　・現状 SysEx はマスターボリューム系(GM/GS/XG)のみ対応

/*---------------------------------------------------------------------------*/

3.05beta4(2019/03/03)

・ztom/zmc2/z2m3/zmc3 による ZMD/ZMS の取扱いに関する以下の修正
　・ZMD のバージョンを自動判別して適切な ztom/z2m3 を起動するようにした
　・ZMS の変換に zmc2/zmc3 のどちらを先に起動するか設定出来るようにした
　　・zmc2->zmc3 の場合は zmc2 を先に試して失敗したら zmc3 を試す
　　・zmc3->zmc2 の場合は zmc3 を先に試して失敗したら zmc2 を試す
　　・zmc2 only の場合は zmc2 だけを試す(失敗しても zmc3 を試さない)
　　・zmc3 only の場合は zmc3 だけを試す(失敗しても zmc2 を試さない)
　・コマンドラインに渡すスイッチ文字列を指定出来るようにした
　　・詳細はヘルプを参照
・「ツール」->「環境設定」ダイアログに関する以下の修正
　・プラグインに関する設定のうち重要だが見逃しやすい項目のいくつかはダイアログ
　　上からプラグイン設定画面にジャンプ出来るようにした
　　・「検索パス1」に標準同梱プラグインの検索パス関連(VSTi プラグインのパス等を
　　　追加)(歌詞フォルダと CDPlayer.ini は検索パス2に移動)
　　・「その他」に「動画の拡張子」と「アーカイブのサイズ制限」
・ヘルプを更新(リンク切れ、検索パス関連等)
・kbungca.kpi に関する以下の修正
　・サイズ制限の設定のセクション名を「GCA」から「General」に変更
　　・旧バージョンから自動的に引き継がれないので再設定が必要
・kbqt.kpi に関する以下の修正
　・設定画面のヘルプを修正

/*---------------------------------------------------------------------------*/

3.05beta3(2019/02/27)

・32bit版で 32bit INT での出力処理が遅かったのを修正
・64bit版の本体が 32bit版よりも再生時の処理速度が遅かったのを修正(32bit INT を
　除く)
・プラットフォームが反対の kbunarc.kpi で 7z を開くと kbrunkpi.exe が落ちて
　展開出来ないのを修正
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 5.7.3 に差し替え
・kbwavefile.kpi に関する以下の修正
　・デコーダの速度を計測するためのベンチマークモードを追加
　　・プラグインの設定で「ベンチマークテスト」を true にすると「Benchmark Test
　　　」というデバイスが列挙されるようになる
　　・デコーダプラグインから取得したデータをデバイスプラグインに渡すまで本体が
　　　様々な処理を行うので、純粋なデコーダの速度を計測してるとは言えない
　・初回のダイアログ時に「はい」を選択すると次回もダイアログが表示されるのを修
　　正
　・ダイアログを本体とは独立したスレッドから呼び出すようにした
　　・予期せぬ再入が起こって本体がフリーズするのを回避するため
　　・ダイアログを閉じるまで本体は「応答なし」になる(閉じれば復活するのでフリー
　　　ズするよりマシ)
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.48(2019/2/25) に差し替え
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.64.0.0 から 1.69.0.0 に差し替え

/*---------------------------------------------------------------------------*/

3.05beta2(2019/02/24)

・kbmp3.kpi に関する以下の修正
　・libmpg123 を 1.25.10(2018/03/05) に差し替え
　・64bit 版でも ASM による最適化コードを使えるようになった
　　(64bit float での出力は出来なくなった)
　・デコーダ(ASM による最適化コード)を選択出来るようにした
　　・32bit 版では
　　　SSE
　　　MMX
　　　i586
　　　i386
　　　generic
　　　のうち CPU が対応しているものを使用可能
　　・64bit 版では
　　　AVX
　　　x86-64
　　　generic
　　　のうち CPU が対応しているものを使用可能
・kbvorbis.kpi に関する以下の修正
　・libvorbis を 1.3.6 に差し替え
　・libogg を 1.3.3 に差し替え
・kbflac.kpi に関する以下の修正
　・libogg を 1.3.3 に差し替え
・kbmac.kpi に関する以下の修正
　・Monkey's Audio SDK 4.44(2019/1/13) に差し替え
・kbwv.kpi に関する以下の修正
　・libwavpack を 5.1.0(2017/01/20) に差し替え
・kbopus.kpi に関する以下の修正
　・libogg を 1.3.3 に差し替え
　・opusfile を 0.11 に差し替え
　・libopus を 1.3 に差し替え
・kbunarc.kpi に関する以下の修正
　・unrarsrc を 5.7.2 に差し替え
　・LZMA SDK を 19.00 に差し替え
　・7-zip に関する以下の修正
　　・ストリームから開けるようになった(アーカイブ内の7zで実ファイルが不要)
　　・圧縮メソッド(Copy, LZMA, LZMA2, PPMD 等)を正しく取得出来るようになった
　　　(今までは全て LZMA としていた)
　　・PPMD を展開出来るようになった
　　　・PPMD を展開するかの設定項目を追加
　　　・非常に低速なため、デフォルトでは展開「しない」
　　・実行時のシステムの空きメモリに応じて一時ファイルを作成することがあったの
　　　を、常にメモリ上に展開するように仕様変更(後述のRARも同じ)
　　・メモリの使用量を大幅に軽減
　・TGZ を正しく処理出来なくなっていたのを修正
　　・zlib の inflateCopy 内部の仕様変更によるもの(結構はまった)
　・TAR の格納ファイル名に全角文字を使用してると文字化けすることがあるのを修正
　　(UTF-8 かどうか自動判別)
　・RAR/7Z について、実行時のシステムの空きメモリに応じて一時ファイルを作成する
　　ことがあったのを、常に全てメモリ上に展開するように仕様変更
　　・プラグインによっては一時ファイルを作成する(旧仕様プラグイン等)
　・CAB/RAR/7Z の全展開後のサイズ制限の設定を追加
　　・制限を超える場合、一覧の取得は出来るが展開には失敗する
　　・個別には小さなファイルがあっても、合計が制限を超えると全て失敗する
　・サイズに関する制限を対応形式ごとに設定するのを廃止
　　・General セクションにまとめた
　　・旧バージョンからの設定は引き継がれないので設定し直す必要がある
　　・kbungca.kpi の設定とは共有されない
・kbungca.kpi に関する以下の修正
　・サイズ制限(全展開後合計)の設定の上限を超えたとき、ファイルオープンに失敗
　　していたのを修正(展開は出来ないが一覧は取得出来るようにした)
・libpng を 1.6.36(2018/12/1) に差し替え(kblibpng.dll)
・プラグイン設定画面とデバイス設定画面のフォントを Media エクスプローラの設定
　と同じくした
・高DPI環境でヘルプがぼやけるのを修正
・ヘルプを修正(リンク切れ、フォントの変更他)

/*---------------------------------------------------------------------------*/

3.05beta(2019/02/18)

・本体のコンパイラを C++Builder 10.3.1 Rio に変更
・各種プラグイン/DLL のコンパイラを VS2017 15.9.7 に変更
・x64(x86)の本体から x86(x64) の kbwaveout.kpi を何故か使えないのを修正
　・原因不明、対症療法的な処置で回避
　・動作確認した２台のPCのうち一方でのみ発生(ドライバの不具合？)
・WindowsXP で kbrunkpi.exe 経由での処理が機能しないのを修正
　(ヘルプを表示不可、ノンリエントラントプラグイン使用時の不具合等)
・一部の特殊フォルダの「プロパティ」を表示出来なかったのを修正
・F1 キー押下時に適切なヘルプが表示されない箇所があったのを修正
・「お気に入りの整理」に関する以下の修正
　・フォントや背景色等を Media エクスプローラの設定に準じるようにした
　・下から２番目のアイテムを削除すると落ちるのを修正
　・F2 キー押下で名前を編集出来るようにした
　・追加時＆名前を空文字列に変更時のデフォルトの名前を修正
　・「ライブラリ」等の特殊フォルダのアイコンを正しく取得出来ないのを修正
　・「送る」や「プロパティ」が機能しないのを修正
　・Media エクスプローラの右クリックメニューから「お気に入りに追加」出来るよう
　　にした
　　・リスト部から追加出来るのはフォルダを単独で選択時のみ(複数選択時やファイル
　　　選択時には非表示)
　　・「新規に追加」の真下だと誤操作で追加してしまうことが多い＆頻繁に使用する
　　　ものではないので敢えて下の方に表示
・Mediaエクスプローラを表示時にデスクトップのアイコン群が再描画されるのを修正
・音楽CD再生時の処理を改善(演奏終了出来ないことがある等)
・kbasio.kpi に関する以下の修正
　・RealTek ASIO 使用時に不安定（度々デバイスオープンに失敗したりフリーズする）
　　なのをある程度修正
　・ドライバのバグとしか思えない為、根本的な解決は多分無理
　・対策後にドライバ更新したら ASIO ドライバごと消えてしまったのでもう動作確認
　　出来ず
・kbwasapi.kpi に関する以下の修正
　・WindowsXP でプラグインのロードに失敗するのを修正
　　(WASAPI を使用出来ないことに変わりはない)

/*---------------------------------------------------------------------------*/

3.04(2017/05/22)

・プラグインを使用しての MIDI 再生時、音源マップ制御(Ignore Bank Select 以外)が
　複数ポート使用時に正しく機能していなかったのを修正
・kbvsti.kpi に関する以下の修正
　・複数ポート対応データの SysEx を全て Port-A に送信していたのを修正
　・複数ポート対応の場合、以下の SysEx は全てのポートに送信するようにした
　　・リセット系(GM SYSTEM ON/GS RESET etc...)
　　・マスターボリューム(GM/GS/XG)
　　・他にも全てのポートに送信すべきものがあるかもしれないが不明
　　・全ての SysEx を全てのポートに送信すると明らかに演奏がおかしくなるデータが
　　　存在する
　・タスクバーが下側以外のときに設定ダイアログの位置がおかしくなるのを修正
　・複数ポート再生時のダイアログが重なっているのを修正

/*---------------------------------------------------------------------------*/

3.04beta4(2017/05/18)

・「先読みバッファのサイズ」と「再生バッファサイズ」を 25ms まで小さく設定出来
　るようにした
　・kbvsti.kpi で VSTi プラグインのレベルメータ表示を再生と連動させたい場合は
　　「先読みバッファのサイズ」を 25ms にし、「再生バッファサイズ」を再生可能な
　　範囲で極限まで小さくする(再生デバイスに WASAPI か ASIO を使用すれば 25ms
　　でも再生出来る可能性がある)
　・「先読みバッファのサイズ」を小さくし過ぎるとギャップレス再生が出来なくなる
　　& ループ曲の無音検出時に無音が再生されてしまう時間が長くなる
　・「再生バッファサイズ」を小さくし過ぎるとスペアナが動かなくなることがある
・kbvsti.kpi に関する以下の修正
　・「VSTi 設定」が有効時で複数ポートを使用する曲を再生時、2 番目以降のポート
　　のダイアログも表示するようにした(最大4ポート)
　・設定画面の表示更新頻度を毎秒10回から毎秒100回に変更
　　(SCVA や S-YXG50 Portable VSTi 等でレベルメータの動きが滑らかになった)
・kbemidi.kpi に関する以下の修正
　・深刻なリソースリーク(レンダリングスレッドの終了し忘れ)修正
・kbunarc.kpi に関する以下の修正
　・RAR 解凍ルーチンを unrarsrc 5.5.3 に差し替え

/*---------------------------------------------------------------------------*/

3.04beta3(2017/05/15)

・kbvsti.kpi(VSTi を使用して MIDI 再生するデコーダプラグイン) を同梱
　・初期設定値のままでは(VSTi プラグインのパスを設定しないと)何も再生出来ないの
　　で注意
・kbemidi.kpi に関する以下の修正
　・マルチスレッド化による大幅な高速化
　　・使用するスレッドの数を設定出来るようにした(初期値4)
　　・4 コア 8 スレッド CPU で 4 個使用すると体感で v0.03 以前の数倍程度(シーク
　　　にかかる時間で体感出来る)
　　・スレッドの数は音質には影響しないが、重いデータを再生時の音途切れは改善さ
　　　れる
　・GM/GS/XG のマスターボリューム SysEx に対応
　・マルチポート(メタイベント0x21)に対応
　　・最大4ポート
　　・ポート数に比例して負荷が高くなる(4ポート使用すると4倍)
　・終端付近が再生されない(1〜2秒程度途切れて終了する)のを修正
　・PSG 音源使用時のメモリリークを修正
　・後半に行くほど再生位置がずれていたのを修正
　・(本体によって無視されるが)演奏時間を正しく取得していなかったのを修正
　・設定の「NumDevices」の初期値を 4 から 16 に変更
・kbfmmidi.kpi に関する以下の修正
　・GS/XG のマスターボリューム SysEx に対応(GM は以前から対応済)
　・終端付近が再生されない(1〜2秒程度途切れて終了する)のを修正
・kbfmoplmidi.kpi に関する以下の修正
　・GS のマスターボリューム SysEx に対応(GM/XG は以前から対応済)
　・マルチポート(メタイベント 0x21)に対応(最大4ポート)
　・終端付近が再生されない(1〜2秒程度途切れて終了する)のを修正
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.63.0.0 から 1.64.0.0 に差し替え
・libpng を 1.16.29 に差し替え
・プラグイン設定画面の表示がおかしくなることがあるのを修正
・クロスフェード中にプラグイン設定変更を適用すると落ちることがあるのを修正
・プラグインを使用しての MIDI 再生時、音源マップ制御(Ignore Bank Select 以外)が
　正しく機能していなかったのを修正
・各種プラグイン/DLL のコンパイラを VS2017 15.2(26430.6) に差し替え

/*---------------------------------------------------------------------------*/

3.04beta2(2017/05/05)

・本体のコンパイラに最新の Hotfix を適用
　・64bit版のメインメニュー/右クリックメニューの文字化けが解決
・MIDI 再生時、「プラグイン」の部分に「failed to load plug-in」と表示されること
　があるのを修正
・プラグインの設定変更適用後にセクションやキー等が変わった場合に即座に反映され
　るようにした(kbvsti.kpi 対策)
・ツールバー画像を差し替え&追加(toolbar_Amber.bmp)
・歌詞アイコン画像を追加(Icons_白色文字_透明背景_黒縁取り_灰色枠.bmp)

/*---------------------------------------------------------------------------*/

3.04beta(2017/04/09)

・本体のコンパイラを C++ Builder 10.2 Tokyo に変更
・プラグイン/DLL/kbrunkpi.exe のコンパイラを VS2017 に変更
・ループタグを使用する曲の2ループ目以降がずれるのを修正
・kbpsf2.kpi に関する以下の修正
　・コンパイラを VS2017 に変更
　・ベースを kbviopsf2.kpi Version 0.07beta に差し替え
・kbmpg123.kpi に関する以下の修正
　・ライブラリを libmpg123 1.24.0(2017/03/02) に差し替え

/*---------------------------------------------------------------------------*/

3.03(2017/03/14)

・関連付け起動時や実行ファイルへのドラッグアンドドロップ時に曲が切り替わるまで
　数秒かかることがあるのを修正(kbdsound.kpi/kbasio.kpi を使用した場合)
・kbasio.kpi と kbdsound.kpi に関する以下の修正
　・ドライバの初期化時に渡すウィンドウの作成方法を修正
　　・本体の DDE 通信(関連付け起動、実行ファイルへのドラッグアンドドロップ)に
　　　支障が出る(演奏開始直後だと曲が切り替わるまで数秒かかる)のを修正
・kbmac.kpi に関する以下の修正
　・ライブラリを Monkey's Audio SDK 4.25(2017/3/12) に差し替え

/*---------------------------------------------------------------------------*/

3.02(2017/03/06)

・特になし(バージョン情報のみ)

/*---------------------------------------------------------------------------*/

3.02beta(2017/02/26)

・kbwavefile.kpi(WAV ファイル出力プラグイン)をアーカイブ状態で配布するのをやめ
　て通常通り同梱するようにした
　・代わりにプラグインロード後の初回デバイスオープン時に「使用上の注意」ダイア
　　ログを表示し、ドキュメントファイルの参照を促すようにした
・kbwavefile.kpi に関する以下の修正
　・プラグインロード後の初回デバイスオープン時に「使用上の注意」ダイアログを表
　　示するようにした
　　・表示が煩わしい場合は表示されないようにすることも出来る
　・設定ダイアログ対応
　　・ダイアログ非表示
　　　・true にすれば「使用上の注意」ダイアログが表示されなくなる
　　・出力先
　　　・前回出力したファイル名が自動的に保存されるため、ここで設定する意味はあ
　　　　まりない
・アーカイブプラグインの仕様を変更
　・展開時に作成した一時ファイルの削除を本体側で行うようにした
　・実ファイルとメモリバッファの IKpiFile 化処理に本体のルーチンを使えるように
　　した(kpi_CreateLocalFile/kpi_CreateMemoryFile)
・kbunarc.kpi に関する以下の修正
　・v3.02beta のアーカイブプラグイン仕様に対応
　　・展開時に作成した一時ファイルの削除を本体に任せるようにした
　　・実ファイル展開時/メモリ展開時に本体のルーチンを使用するようにした
　・cab のアーカイブファイル名に Unicode でしか表現出来ない文字を使用していて、
　　格納ファイル名が utf-8 で格納されていない場合に解凍出来ないのを修正
・kbungca.kpi に関する以下の修正
　・v3.02beta のアーカイブプラグイン仕様に対応
　　・展開時に作成した一時ファイルの削除を本体に任せるようにした
　　・実ファイル展開時/メモリ展開時に本体のルーチンを使用するようにした
・kbtta.kpi に関する以下の修正
　・シーク後の戻り値が不正確だったのを修正
　　(CueSheet で 2 番目以降のトラックの再生開始位置がずれるのが修正される)
・kbopus.kpi に関する以下の修正
　・ライブラリを libopus 1.1.4(2017/1/20)に差し替え
・kbmsxplug.kpi に関する以下の修正
　・(実害はなかったが)デバッグコードを含んでいたのを修正
・kbfpd.kpi と kbum.kpi に関する修正
　・ソースコード公開に伴う細かい修正
・kbzlib.dll に関する以下の修正
　・zlib を 1.2.11(2017/1/15) に差し替え
・タイムタグ付き歌詞に関する以下の修正
　・秒の部分で小数点を使う形式に対応([01:23.45] と [01:23:45] を同じものとして
　　解釈)

/*---------------------------------------------------------------------------*/

3.01(2017/01/23)

・TAK と FLAC + CueSheet(FLAC 単体では問題なし)で連続再生が出来ないことがあるの
　を修正
　・プラグインではなくて本体のバグ
・kbmsxplug.kpi で MGS 再生時や kbwinamp+in_bm.dll で再生時に連続再生出来ないの
　を修正(本体の再生位置を取得する機能を使用時)
・タイトルに改行を含む場合にシークすると情報表示パネルの表示がおかしくなるのを
　修正
・MGS/MPK のタグにローマ数字を含むと正しく表示出来ないのを修正(kbmsxplug.kpi を
　使わずに本体がタグ取得する場合)
・kbmsxplug.kpi に関する以下の修正
　・MGS 歌詞に関する以下の修正
　　・表示しきれないデータがまだあったので修正
　　　・82バイト分表示出来る様に修正
　　　・一部の全角文字は半角に変換した方が良いのかも？(「」が怪しい)
　　・1行の文字数が 128 バイト以上のデータで落ちるのを修正
　　・1行の文字数が 80 バイト以上ある場合の歌詞表示を改善
　　・正しい表示の方法が分からないが、実用上はほぼ問題ないはず
　　・ローマ数字を含む場合に正しく表示出来ないのを修正(?)
　　　・kss.c の msx_kanji_fix を呼ぶようにした(必要ない?)
・kbpsf2.kpi に関する以下の修正
　・boost ライブラリを 1.62.0.0 から 1.63.0.0 に差し替え

/*---------------------------------------------------------------------------*/

3.00(2017/01/16)

・17年ぶりのメジャーバージョンアップ
・kbmsxplug.kpi に関する以下の修正
　・MGS 歌詞に関する以下の修正
　　・歌詞を表示しきれないことがあるのを修正(80文字ギリギリ使った場合)
　　・フォントを設定出来るようにした(固定幅フォントのみ)
　　・歌詞ウィンドウのサイズを変更出来るようにした(フォントサイズも変更される)
　　・演奏終了時に歌詞ウィンドウを操作しているとフリーズするのを修正
　・曲長とループ時間を取得出来るようになった(KSS/MBM 以外)
　　・曲長を含まない場合に処理時間がかかるため、煩わしい場合は省略したり設定す
　　　ることが可能(General->曲長計算)
　　・KSS の曲長取得は処理方法が異なるので設定は無関係(動作未確認)
　　・MBM は曲長取得不可
　・MSXplug の一部の設定(「デバイス」タブの「PSG」「SCC」「OPLL」)が反映されて
　　いなかったのを修正
　・MGS のタイトルを正しく取得出来ないのを修正
・kbvorbis.kpi に関する以下の修正
　・埋め込み画像を表示出来なくなっていたのを修正
・kbmpc.kpi に関する以下の修正
　・連続再生時に落ちることがあるのを修正
・kbbms.kpi に関する以下の修正
　・MultiByteToWideChar の使い方がまずい箇所があったのを修正
　　(バッファサイズが足りない場合の処理)
・kbsap.kpi に関する以下の修正
　・SAP Info と STIL Info を取得出来なくなっていたのを修正
・プラグイン置き場で配布していた kbwavefile.kpi(WAVファイル出力プラグイン)を同
　梱することにした
　・使い方が特殊なため、敢えてアーカイブしたまま同梱
　・使用したい場合は Device\Kobarin 以下の kbwavefile_x86.7z (32bit 版)または
　　kbwavefile_x64.7z (64bit版)を解凍する
　・使用する前に必ずドキュメントを読むこと
・BMS/SAP/TSS/MIO のタグ取得時にメモリアクセス違反が発生することがあったのを修
　正
・MIO のタグ取得が Unicode 未対応だったのを修正
・MPK/MGS のタグ取得の不具合修正
・アルバムアート画像読み込み失敗時の「failed to load picture」のメッセージを正
　しく表示出来ないことがあるのを修正
・ビットレートの概算値(プラグインから通知がない場合)を表示しなくなっていたのを
　修正
・「PLS/TAG ファイル作成」に関する以下の修正
　・新仕様のプラグインだと正しく曲長計算出来ないことがあるのを修正
　　(Render 前に Seek 呼び忘れ)
・ヘルプを更新

/*---------------------------------------------------------------------------*/

2.80beta43(2017/01/09)

・kbmsxplug.kpi に関する以下の修正
　・設定ダイアログに関する以下の修正
　　・一部の設定が反映されてなかったのを修正
　　　・演奏設定->再生周波数(本体からの要求が 0 の場合に適用)
　　　・ミキサー->PSG/SCC/OPLL/OPL の音量と Mute
　　　・OPLL をステレオ化したときの「パン設定」
　　　・General セクションの「音色ファイル」
　　・演奏設定->CPU速度のラジオボタンの挙動がおかしいのを修正
　　・チャンネルマスクの設定に対応(変更が反映されるのはダイアログを閉じてから)
　　　・in_msx.dll とは異なり、次回起動時以降も反映されるので注意
　　・EMU2413 TONE EDITOR ダイアログを開けるようにした
　　・設定画面の位置と選択していたページを保存するようにした
　・ファイルを開く度に「音色ファイル」を読み込み直すようにした
　　・EMU2413 TONE EDITOR で編集したら曲を開き直すだけで反映されるように
　・MGS 内蔵歌詞を表示出来るようにした
　　・表示/非表示は設定で切り替え可能(General セクション)
　　・本体の再生位置を取得する非公式の機構を使用
　　　(元々は kbwinamp+in_bm.dll用(BGA再生用))
　・シークが高速化
　・リソースリーク修正(config.c の DeleteCriticalSection し忘れ)
・kbnezplug.kpi に関する以下の修正
　・設定ダイアログの再生周波数の選択肢を修正(8820 => 88200)
・kbmod.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・設定項目を追加
　　・再生周波数
　　　・44100 以外だとリバーブ/バスブースト/サラウンドのかかり方が変なので既定
　　　　値は 44100(要求無視)
　　・対応拡張子
　　・オーバーサンプリング/ノイズリダクションの有効/無効
　　・リバーブ/バスブースト/サラウンドの有効/無効及び詳細設定
　　・再生レート変換の補間処理
・kbtss.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・ファイルオープン時に呼び出す API を PlayMusic から PlayMusicBuffer に変更
・kbqcp.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・SDK を PureVoice SDK 2.1 から PureVoice SDK 3.5 に更新
　・同梱する DLL を qpl.dll から qscl.dll に変更
　・ファイル名に依存しなくなった(IKpiFile でデータの読み込みを行う)
　・高速シークに対応(元々十分速かったが)
　・タグ取得に対応(RIFF のようなので本体のタグ取得機能を呼び出す)
・kbtvq.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・ファイルオープンに実ファイルを必要としなくなった
・kbflac.kpi に関する以下の修正
　・libFLAC を 1.3.2 に差し替え
・kbfpd.kpi に関する以下の修正
　・kbfpd.kpi を KbMedia Player 以外から利用出来ないように細工するのをやめた
　・開発元の株式会社ラット様より、WAV ファイル出力するアプリケーションの配布
　　は問題ないとの確認を取ることが出来ました
　・kbwavefile.kpi 公開時点で既に WAV ファイル出力出来てしまっていたけど
・その他プラグインに関する以下の修正
　・正式版公開に向けての細かい修正(ドキュメント/ソースコードの整理等)
・kbrunkpi.exe に関する以下の修正
　・設定画面を開いた後、画面を開いたまま直ちにリターンするタイプのプラグインが
　　ある程度動作するようになった(in_msx.dll 等)
　・設定画面が開いたままであることを検出し、閉じるまでプラグインをアンロードし
　　ないようにした(閉じるまで待つ間に本体が kbrunkpi の応答なしを検出。設定画面
　　の方を閉じるか強制終了するまで待つ)
・新仕様のデコーダプラグインから本体の再生位置を取得出来るようにした
　・まだ非公式(DDE は使わない)
　・kbmsxplug.kpi での MGS 内蔵歌詞表示用(元々は kbwinamp + in_bm.dll用)
・ギャップレス再生時の音の途切れを改善
　・cue シート(参照元ファイルのシークが低速な形式)で改善されるはず
・タイトル/アーティスト名に改行を含む曲があるとプレイリストを正しく読み書き出
　来ないことがあるのを修正(改行は空白に置換するようにした)
・device/player/unarc フォルダ内のプラグインファイル群の配置を変更
　・各種プラグインにドキュメントを添付して Plugins フォルダ(デコーダプラグイン
　　フォルダ)と同じような構成に(作者名\プラグイン名\xxxx.kpi)
・アルバムアート画像の読み込みに失敗したとき、情報表示パネルの表示がおかしくな
　ることがあるのを修正
・アルバムアート画像の読み込みに失敗したとき、「failed to load picture」という
　文字列を画像部に表示するようにした
・SDK を更新(ソースコードを追加)

/*---------------------------------------------------------------------------*/

2.80beta42(2016/12/31)

・[OK] さん制作の in_msx.kpi の後継として kbmsxplug.kpi を作成
　・初版(v2.80beta41 以前まで同梱していた in_msx.kpi の後継版)
　・プラグインのファイル名を in_msx.kpi から kbmsxplug.kpi に変更
　・ベースは [OK] 氏制作の in_msx.dll(NSFplug v1.1.0) (2015/11/06 版)
　・新プラグイン仕様に対応
　　・アーカイブ内の MBK にきちんと対応
　　・設定可能な項目は NSFplug の Winamp プラグイン(in_msx.dll)と大体同じ
　　・自動生成よりも操作がしやすいと思われる設定項目は in_msx.dll と同じダイア
　　　ログで設定するようにした
・64bit 版を作成
・リストビューのマウスドラッグによるアイテム選択に関する修正
　・マウスを素早く動かしたときの選択漏れを改善
　・選択解除も出来るようになった
　・スクロールは未対応
・kbwv.kpi に関する以下の修正
　・ライブラリを libwavpack 5.0.0(2016/12/7) に差し替え
　・2GB超のファイルサイズに対応(動作は未確認)

/*---------------------------------------------------------------------------*/

2.80beta41(2016/12/25)

・Mamiya さん制作の bmse.kpi の後継として kbbms.kpi を作成
　・初版(v2.80beta40a 以前まで同梱していた bmse.kpi の後継版)
　・プラグインのファイル名を bmse.kpi から kbbms.kpi に変更
　・ベースは bmse.kpi v1.0r13
　・新プラグイン仕様に対応
　・アーカイブ内の BMS にきちんと対応
　・WAV や MP3 等の読み込みにプレイヤー本体のプラグインを使用するようにした
　　・kbbms.kpi 自身がプラグインを検索するのではなく、本体が提供する機能を使う
　　・#WAV コマンドによる指定ファイルの拡張子が .wav の場合は、.wav を開けなか
　　　ったら同名の .mp3 -> .ogg をこの順に開いてみる
　　・#WAV コマンドによる指定ファイルの拡張子が .wav 以外の場合は、指定ファイル
　　　をそのまま開く。本体が対応する全ての形式に対応可能
　　・使用プラグインに設定がある場合は反映される
　　・使用プラグインの有効/無効の設定も反映される
　　・bmse.kpi とは異なり、.WAV ファイルもプラグインを使うため、.wav を再生可
　　　能なプラグインが無効な場合は再生出来なくなる
　・MIDI を使う BMS を再生時は MIDI 対応デコーダプラグインを使うようにした
　　・本体選択中の MIDI デバイスがデコーダプラグインならそれが使用される
　　・本体選択中の MIDI デバイスが midiOut デバイスや演奏プラグインの場合は、
　　　有効にしている MIDI 対応デコーダプラグインの中で使用優先度が最も高いもの
　　　が使用される
　・対応拡張子に .bml を追加
　・64bit 版を作成
・デコーダプラグインから別のデコーダプラグインを使用出来るようにした
　(kpi_CreateDecoder の実装)
　・kbbms.kpi で MP3 や OGG を使う BMS に対応するための機構
　・今のところ、要求するプラグイン(kpi_CreateDecoder を呼び出すプラグイン)が
　　kbrunkpi.exe 経由だと動作しない
　　・x64 版の本体で x86 版の kbbms.kpi を使用しても動作しない
　・提供するプラグイン(kpi_CreateDecoder によって本体が返すデコーダの作成元
　　プラグイン)が kbrunkpi.exe 経由になるのは問題ない
　　・x64版の本体 & x64版の kbbms.kpi で x86 版 otmpg123.kpi を使用して MP3 を
　　　使用する BMS を再生することは可能
　・演奏プラグインからデコーダプラグインを使用することはまだ出来ない
・BMS のタグ取得を強化(タグ取得は本体が行う)
・単曲再生等で演奏終了時、終端部分が再生されないのを修正
・CueSheet 再生時、冒頭で１つ前のトラックの末尾の一部が再生されることがあるのを
　修正
・kbwavefile.kpi 使用時、デコード終了後の「待ち」がなくなった
・kbshow.kpi に関する以下の修正
　・WAV を内蔵ルーチンで再生出来ないことがあるのを修正(該当データは float の場
　　合は再生出来ず、int の場合は DirectShow で再生していた)
・旧式プラグイン使用時、関連ファイルの抽出処理で落ちることがあるのを修正
・旧式プラグイン使用時、アーカイブ内の曲を再生すると本体を終了するまでテンポラ
　リファイルが削除されないことがあるのを修正

/*---------------------------------------------------------------------------*/

2.80beta40a(2016/12/19)

・kbdshow.kpi に関する以下の修正
　・WAV の終端付近にタグ等を含む場合、その部分もオーディオデータとして再生して
　　いた(終端でノイズが鳴っていた)バグを修正
・kbm4a.kpi に関する以下の修正
　・ALAC 再生時に落ちることがあるのを修正
・プラグイン設定画面にヘルプボタンを追加

/*---------------------------------------------------------------------------*/

2.80beta40(2016/12/18)

・ループタグに対応
　・タグに LOOPSTART/LOOPLENGTH を含む場合、本体によってループ処理される
　・LOOPLENGTH の最小値とアウトロ最小値を設定出来るようにした
　　・ツール->環境設定->演奏設定->ループタグ
　・ループタグや設定の意味についてはヘルプを参照
・デバイスプラグインの仕様を変更
　・WAV ファイル出力に対応するための仕様を追加
　・WAV ファイル出力には kbwavefile.kpi(デバイスプラグイン)が必要
　・kbwavefile.kpi は現状では標準同梱せず、プラグイン置き場で配布
・kbm4a.kpi に関する以下の修正
　・先頭にシークすると冒頭にノイズ(シークする直前のゴミデータ)が入ることがある
　　のを修正
・kbpsf2.kpi に関する以下の修正
　・2曲目以降を再生時、冒頭にノイズが入るのを修正
　・viopsf2.bin を内蔵させるのをやめた(↑の不具合対策)
　・メモリリークを修正
・kbdshow.kpi に関する以下の修正
　・WAV 再生に(可能なら)DirectShow を使わないようにした
　　・中身が PCM 以外の場合は従来通り DirectShow を使う
　　・32bit float/64bit float の WAV に対応
・ヘルプを更新

/*---------------------------------------------------------------------------*/

2.80beta39(2016/12/11)

・PSF2(プレイステーション2のサウンド形式)に対応(kbpsf2.kpi)
　・初版
　・kbviopsf2.kpi Version 0.06 をベースに、KbMedia Player の新プラグイン仕様に
　　対応
　・オリジナルからの変更点
　　・無限ループ、フェード時間にきちんと対応
　　・アーカイブ内の psf2lib にきちんと対応
　　・viopsf.bin を内蔵し、zlib を切り離して本体同梱の kbzlib.dll を使用するこ
　　　とにより省サイズ化
　　・設定ダイアログに対応
　　・64bit 版を作成
・Mamiya さん制作の m_sap.kpi の後継として kbsap.kpi を作成
　・初版(v2.80beta38 以前まで同梱していた m_sap.kpi の後継版)
　・プラグインのファイル名を m_sap.kpi から kbsap.kpi に変更
　・ベースは libasap v3.2.0(m_sap.kpi は組み込まず)
　・新プラグイン仕様に対応
　・1ファイル複数曲にきちんと対応
　　・ファイルごとの曲長取得
　　・高速シーク
　　・ループ曲は単曲リピート時に無限ループ
　・詳細情報の取得に対応("SAP Info")
　　・"SAP Info"
　　・通知する情報は ASAP Windows 版(wasap.exe)互換
　・STIL.txt からの情報取得に対応("STIL Info")
　　・再生中のデータの上位フォルダに Docs/STIL.txt という名前のファイルが存在す
　　　ればその内容のうち、再生中のデータと関連する情報を通知
　　・SAP データのフォルダ名やファイル名を変更すると取得出来なくなる
　・64bit 版を作成
・zlib.dll と libpng.dll のファイル名をそれぞれ kbzlib.dll/kblibpng.dll に変更
・↑に伴い、zlib に依存するプラグイン/DLL を修正
・libpng を 1.6.26(2016/10/26) に差し替え
・kbdshow.kpi に関する以下の修正
　・設定ダイアログリソースの削除し忘れ修正
・kbgym.kpi に関する以下の修正
　・設定項目がないのにあるものと通知し、IKpiConfig を要求していたのを修正
・kbgym.kpi/kbnezplug.kpi/kbs98.kpi/kbpsf.kpi に関する以下の修正
　・依存する zlib の DLL 名を zlib.dll から kbzlib.dll に変更
・本体同梱の全てのプラグイン/DLLをビルドし直し(コンパイルオプションの変更等)

/*---------------------------------------------------------------------------*/

2.80beta38(2016/12/04)

・プラグイン置き場で配布していた PSF 再生プラグイン(kbpsf.kpi) を標準で同梱す
　ることにした
・kbpsf.kpi に関する以下の修正
　・viopsf.bin を kbpsf.kpi に内蔵(viopsf.bin は不要になった)
　・zlib を内蔵させずに本体同梱の zlib.dll を使用するようにした
　・旧式プラグインの対応を打ち切った(v2.63a では動作しなくなった)
　・設定ダイアログに対応
　　・SPUPlugin
　　　・spuPeopsSound.dll, spumame.dll, spumednafen.dll から選択
　　　・spuEternal.dll も使用可能(32bit 版の kbpsf.kpi と同じフォルダに置く)
　　　・64bit 版では spuEternal.dll を使用不可
　　・SPUPluginConfig(使用中の SPU プラグインの設定ダイアログを表示)
　　・ResetPeop(spuPeopsSound.dll の設定を初期値に戻す)
　　・EnableInterpreterCPU
　　・IgnoreVolumeTag
　・SPU プラグインの設定ダイアログを閉じたらプラグインを再ロードさせるよう通知
　　するようにした
　　・設定変更が即座に反映されるようにするため
　　・spuPeopsSound.dll の場合は設定が変更された場合のみ再ロードを通知する
　　・spuEternal.dll の場合は「キャンセル」で閉じても再ロードを通知する
　　　・ダイアログを開く前後のレジストリを比較するのが面倒なので
　・spuPeopsSound.dll に関する以下の修正
　　・設定ダイアログをモードレスからモーダルに変更
　　・ダイアログを表示中にプラグインをアンロードすると落ちるため
　　・spuPeopsSound.ini/spuPeopsSound_expert.ini を作成せず、本体で設定の保存
　　　管理を行うようにした
　・フェード時間が 0 の曲で演奏終了直前に落ちることがあるのを修正
　・64bit float で出力するようにした
　　・volume タグが 1 でなく、本体の最終出力段のビット深度が 24bit 以上のとき
　　　の音質が向上
　・64bit 版を作成
　　・64bit 版では spuEternal.dll は使用不可(64bit 版がないため)
・Mamiya さん制作の m_gym.kpi の後継として kbgym.kpi を作成
　・初版(v2.80beta37 以前まで同梱していた m_gym.kpi の後継版)
　・プラグインのファイル名を m_gym.kpi から kbgym.kpi に変更
　・ベースは m_gym.kpi v1.0r10
　・新プラグイン仕様に対応
　・実際はループ曲でないのにループ曲として通知していたのを修正
　　・曲の長さが本体の「デフォルトのフェード時間」分だけ大きくなっていた
　・ループ曲に対応(?)(データがないため動作未確認)
　・zlib を内蔵させずに本体同梱の zlib.dll を使用するようにした
　　(必要になるデータが手元にないため動作未確認)
　・libbzip2 を 1.0.6 に差し替え(必要になるデータが手元にないため動作未確認)
　・64bit 版を作成
・Mamiya さん制作の sidplay.kpi の後継として kbsid.kpi を作成
　・初版(v2.80beta37 以前まで同梱していた sidplay.kpi の後継版)
　・プラグインのファイル名を sdiplay.kpi から kbsid.kpi に変更
　・ベースは sidplay.kpi v1.36.57r7
　・新プラグイン仕様に対応
　・libsidplay を 1.36.60 に差し替え(sidplay.kpi は 1.36.57)
　・reSID を 0.16 に差し替え(sidplay.kpi は 0.13)
　・設定ダイアログに対応
　　・EnableReSID
　・本体からの再生周波数に応じるのを 48000Hz までに制限するようにした
　　・48000Hz を超えると正しく再生出来ないため
　・64bit 版を作成
・演奏リストの再生済み情報と並び順が壊れることがあるのを修正
　・v2.80beta38 と v2.80beta37 以前を交互に起動すると壊れることがあるのは仕様上
　　回避不可(=>v2.80beta37 以前を起動しないようにするしかない)
・実行ファイルのアイコンを差し替え
・ツールバーの初期値を toolbar_Basic.bmp に変更(EXE に内蔵)
　・v2.80beta37 以前のを使いたい場合は toolbar_Classic.bmp を使用して下さい
・image フォルダにツールバーの 32x32 用画像を追加(Thanks カタガネさん)
・NSF/SID/GBS/SGC のタグ取得で、「ゲーム名」としていたのを「著作権」に変更
・細かい修正

/*---------------------------------------------------------------------------*/

2.80beta37(2016/11/27)

・プラグイン設定画面に関する以下の修正
　・正しく設定を読み書き出来なくなることがあるのを修正
　・プラグインごとに再生周波数の要求値を設定出来るようにした
　　・通常は「デバイス設定」の「プラグインに対する再生周波数要求」で設定する
　　・例えば普段は 192000Hz で再生したいが 192000Hz で要求すると正常に処理出来
　　　なくなるプラグイン(auPiECE.kpi 等)に対しては 96000Hz 等にする
・PDX の検索パス設定を廃止
　・kbmdx.kpi で設定する
・SGC のタグ取得に対応
・kbnezplug.kpi に関する以下の修正
　・ColecoBIOSFilePath の設定が機能しなくなっていたのを修正(v0.02 からのバグ)
　・曲データの詳細情報を通知するようにした(NEZplug++ の Winamp プラグイン互換)
・kbs98.kpi に関する以下の修正
　・エラーチェックを強化(一部のデータで落ちるのを修正)
・Mamiya さん制作の mxdrvg.kpi の後継として kbmdx.kpi を作成
　・初版(v2.80beta36 以前まで同梱していた mdxdrvg の後継版)
　・プラグインのファイル名を mdxdrvg.kpi から kbmdx.kpi に変更
　・ベースは Mamiya 氏制作の mdxdrvg.kpi v2.00br11
　・新プラグイン仕様に対応
　・ループ曲に対応
　　・ループ回数は本体の設定に従う
　　・フェード時間、ループ時間は曲データに従う(フェード時間は本体の設定によって
　　　は無視される)
　・設定ダイアログに対応
　　・PDX の検索パスを設定出来るようにした
　　　・本体の PDX 検索パス設定を廃止
　　・ローパスフィルタ(再生周波数が 44100Hz または 48000Hz のときのみ有効)
　・64bit 版は断念(コンパイルは出来たが正常に再生出来ない)
・[OK] さん制作の emidi.kpi の後継として kbemidi.kpi を作成
　・初版(v2.80beta36 以前まで同梱していた emidi.kpi の後継版)
　・プラグインのファイル名を emidi.kpi から kbemidi.kpi に変更
　・ベースは [OK] 氏制作の emidi.kpi (2006/6/9版)
　　・音質が emidi.kpi とは異なる(原因不明)
　・新プラグイン仕様に対応
　・ループMIDIに対応(単曲リピート時の無限ループ)
　・シークが高速化(高速シークの設定を有効時)
　・本体からの再生周波数要求に応じるのは 48000Hz までに制限することにした
　　・PSGDrum 有効時にドラムパートが正常に鳴らないので
　・設定ダイアログに対応
　　・NumDevices(emidi.kpi 互換にするなら 4)
　　・EnableOPLL(emidi.kpi 互換にするなら true)
　　・EnableSCC(emidi.kpi 互換にするなら true)
　　・EnablePSGDrum(emidi.kpi 互換にするなら false)
　　・高速シーク(シーク後に演奏がおかしくなるなら false)
　・emu2149.c(PSG 音源部) と emu2212.c(SCC 音源部)と emu2413.c(OPLL 音源部)を
　　2016/10/22 版に差し替え
　　・emidi.kpi と比べて音質が変わった直接の原因ではない
　　　(差し替えなくても emidi.kpi と音が違う)
　　・emu2149.c は PSGDrum 有効時に使用されるが、emidi.kpi では使用されていな
　　　かった
　・64bit float で出力するようにした
　　・emidi.kpi と比べて音質が変わった直接の原因ではない
　　　(16bit のままでも emidi.kpi と音が違う)
　・マルチプルインスタンス対応として通知することにした
　　・厳密にはまずいが再生周波数が異なるものを同時再生しなければ問題ないので
　・64bit 版を作成

/*---------------------------------------------------------------------------*/

2.80beta36(2016/11/20)

・本体のコンパイラを C++Builder 10.1 Berlin Update 2 に変更
・MP3 のタグ取得時に落ちることがあるのを修正
・音楽 CD の再生に関する各種不具合修正
　・曲長を正しく取得出来ず、シーク出来なかったのを修正
　・CD-Extra を再生出来なかったのを修正
・外付け HDD や CD の挿入・取り外し時に Media エクスプローラのツリー部が自動的
　に反映されるようにした
・kbmpg123.kpi に関する以下の修正
　・コンパイラの最適化オプションを変更(32bit版のみ)
　　・データによっては再生時にノイズが発生するのを修正
・kbnezplug.kpi に関する以下の修正
　・マルチプルインスタンスにするのをやめた
　　・OffGao 氏による修正箇所に怪しいところがあるため
　・ColecoBIOSFilePath を Unicode 化
　・ZLIB が実質使用されていなかった(ZIP 圧縮された NSF 等(NEZ?)を再生出来なかっ
　　た)のを修正
　・ZLIB を内蔵せずに本体の zlib.dll を使用するようにした
・Mamiya さん制作の m_s98.kpi の後継として kbs98.kpi を作成
　・初版(v2.80beta35 以前まで同梱していた m_s98.kpi の後継版)
　・プラグインのファイル名を m_s98.kpi から kbs98.kpi に変更
　・ベースは RuRuRu 氏制作の m_s98.kpi S98 対応版(061019)
　・新プラグイン仕様に対応
　・ループ曲に対応
　　・ループ回数は本体の設定に従う
　・リズム音源のパスを設定出来るようにした
　・64bit float で出力するようにした
　・ZLIB を内蔵させずに本体同梱の zlib.dll を使用するようにした
　・64bit 版を作成
・zlib.dll を更新(kbnezplug.kpi/kbs98.kpi から使用出来るように)

/*---------------------------------------------------------------------------*/

2.80beta35(2016/11/14)

・プラグインの設定に関する以下の修正
　・設定画面のツリー部とリスト部に Media エクスプローラ/演奏リストのフォント設
　　定を適用させるようにした(色と文字サイズは適用しない)
　・プラグインごとに対応拡張子の一部を無効化出来るようにした
　　(デコーダ/演奏/アーカイブプラグイン)
　　・例えば .aaa と .bbb と .ccc に対応するプラグインで .aaa と .bbb だけを無
　　　効にしたい(優先度が低くて拡張子が競合する他のプラグインを使用したい)場合
　　　は .aaa/.bbb のように指定する
　・プラグインごとに音量を指定出来るようにした(デコーダプラグイン)
　　・主にゲームエミュレータ関係の形式で、他のプラグインと比べて音量が小さい場
　　　合などに指定する
　　・100% より大きくすると音割れして音質が劣化する可能性があるため、通常は100%
　　　のまま変更しない
・プラグインキャッシュファイルの仕様を大幅に変更
・音量増幅機能を廃止
・KPI_MEDIAINFO::dwUnitSample の上限値を 16384 から 65536 に変更
　・一部の旧式プラグインを使用出来なかったのを修正(kpiffmpeg.kpi)
・kbunarc.kpi に関する以下の修正
　・7Z 解凍ルーチンを LZMA SDK 16.04 に差し替え

/*---------------------------------------------------------------------------*/

2.80beta34(2016/11/06)

・ID3v2 のタグ取得に関する以下の修正
　・foobar 等で作成した非同期化 ID3v2.4 の情報を取得出来ないのを修正
　・埋め込み画像の「Description」の文字エンコードが UTF-16 だと画像を表示出来
　　ないのを修正
・kbpmd.kpi に関する以下の修正
　・再生に必要な PVI ファイルの抽出方法を修正
　・PMDWin.dll を同梱(v0.36 を VS2015 Update 3 でビルドしたもの)
　　・C60 さんの許可を頂きました
　　・オリジナルの PMDWin.dll を使用することも可能
　・64bit 版を作成(↑の x64版 PMDWin.dll を使用)
・kbmpg123.kpi に関する以下の修正
　・ライブラリを libmpg123 1.23.8(2016/9/27) に差し替え
・kbwv.kpi に関する以下の修正
　・デコード時にメモリバッファを壊していたのを修正
　・WavPack のモードを通知するようにした("WavPack_Mode")
　　・WVC(Hybrid 時に .wvc ファイルが存在するとき)
　　・Lossless
　　・Hybrid
　　・Float
　　・High(or Very High)
　　・Fast
　　・Extra(Level も通知)
　　・SFX
　　・MD5
　　・Dynamic Noise Shaping
　　・↑を | で繋げて表示
・kbofr.kpi に関する以下の修正
　・OptimFROG.dll を v5.100(2016/09/02 版) に差し替え
・Mamiya さん制作の nezplug.kpi の後継として kbnezplug.kpi を作成
　・初版(v2.80beta33a 以前まで同梱していた nezplug.kpi の後継版)
　・プラグインのファイル名を nezplug.kpi から kbnezplug.kpi に変更
　・ベースは OffGao 氏制作の NEZplug++ 0.9.4.8 + 3 + 23.01
　・新プラグイン仕様に対応
　　・SGC を本体の設定を変更せずに 1 ファイル複数曲として扱えるようになった
　　・高速シークに対応
　　・設定画面の自動生成に対応
　　　・設定可能な項目は NEZplug++ の Winamp プラグインと大体同じ
　・64bit 版を作成
　・ZLIB を 1.2.8 に差し替え

/*---------------------------------------------------------------------------*/

2.80beta33a(2016/10/31)

・ID3v2 のジャンルが UTF-8 で書き込まれてると正しく表示出来ないのを修正

/*---------------------------------------------------------------------------*/

2.80beta33(2016/10/30)

・kbm4a.kpi に関する以下の修正
　・タグ取得で著作権と作曲者の取得に対応
・ASF(WMA/WMV) のタグ取得で以下に対応
　・著作権("WM/Copyright")
　・作詞者("WM/Writer")
　・作曲者("WM/Composer")
　・指揮者("WM/Conductor")
・ID3v2 のタグ取得に関する以下の修正
　・ID3v2.2 のフレームサイズの計算が誤っていたのを修正
　・ID3v2.2 の埋め込み画像を取得出来ていなかったのを修正
　・タグ書き換えソフトの ID3v2 のバージョン変換バグにより規格外となった埋め込
　　み画像を読み込めるようにした
　　・STEP 系や mp3infp で
　　　ID3v2.2(画像を含むもの)を ID3v2.3 or v2.4 に変換したデータおよび
　　　ID3v2.3/v2.4(画像を含むもの)を ID3v2.2 に変換したデータ
・本体内蔵の ID3 タグ取得ルーチンを使用した場合は ID3Tag のバージョン(ID3v1.0/
　1.1/2.2/2.3/2.4)を表示するようにした(混在している場合は最初に取得したものを表
　示)

/*---------------------------------------------------------------------------*/

2.80beta32(2016/10/23)

・kbasio.kpi に関する以下の修正
　・DSD Native モード(DoP でない方)での再生に対応
　　・DSD Native に対応するが DoP には未対応なデバイスで DSD をネイティブ再生出
　　　来るようになった
　　・DoP と DSD Native のどちらで再生するか設定可能にした
　　・どちらを使用しても音質は変わらないが、両対応なら DSD Native を使用した方
　　　が良いかも。(HP-A8 ではリレーの切り替えが起こる頻度が少ない)
　・シーク時や一時停止時に PCM モードに切り替わらなくなった(HP-A8 などでリレー
　　の切り替えによるカチカチ音が発生しなくなった)
　・DSD のネイティブ再生は WASAPI より ASIO を推奨
・演奏リストのアイテムをドラッグ時のスクロール処理を修正
　・Windows 標準の動作に近づいた(カーソルは変だが)
　・ドラッグ状態でリストビューの外側にカーソルを持っていった場合はスクロールを
　　加速(クライアント領域から遠いほど高速にスクロール)
・終了時の演奏リストの並び順の保存の不具合が修正しきれていなかったのを修正
　・playdone_{xxxx}.bin のファイル名(xxxx の部分)を変更
・前回終了時のリストが「無題」だった場合、v2.63a 以前の終了時のリストを開くよう
　になっていたのを修正
・ツールバーの画像サンプルに 32x32 のものを追加(32x32_toolbar_basic.bmp)
・default.jpg を画質を変えずに省サイズ化
・「ドキュメント」で読み込むファイル数の上限を 16 個までとした

/*---------------------------------------------------------------------------*/

2.80beta31(2016/10/17)

・Direct Stream Digital(DSD)(DSF/DFF/WSD) に対応
　・Autch さんが作成されたプラグインを同梱させて頂きました
　・DoP 方式による DSD ネイティブ再生プラグイン(kpidop.kpi)
　　・WASAPI/ASIO による再生必須(ASIO4ALL は多分不可)
　　・デバイスが DoP に対応していない場合は再生不可
　　・デバイスが DoP に対応しない場合は↓の kpid2p.kpi を使えば再生可能
　　・音量制御、エコー再生等は不可。音量制御はアンプ側で行って下さい
　　・液晶のスペアナも動きません
　・PCM 変換による DSD 再生プラグイン(kpid2p.kpi)
　　・デバイスが DoP 非対応でも再生可能
　　・音量制御、リプレイゲイン適用、エコー再生、クロスフェードが可能になる等、
　　　DoP 方式の制限がなくなるが、音質は DoP 方式に比べると少し劣化
　・kpidop.kpi/kpid2p.kpi のどちらを使うかは「ツール」->「プラグイン設定」で
　　使わない方のチェックを外すことで設定する
・MIDI 関係の各種不具合修正
　・マックバイナリヘッダがついた MIDI のタイトルを取得出来ないのを修正
　・タイトル文字列からの MIDI 音源の判別処理の不具合修正(Unicode 化に伴うバグ)
　・音源判別の結果が 88Pro であるのに "GS(SC-88Pro or later)" と表示されずに
　　"GS(SC-88 or later)" と表示されていたのを修正(文字列テーブルのミス)
　・MIDI をデコーダプラグインで再生時、プラグインからデコード終了が通知されてな
　　くても本体側で演奏を打ち切っていた(終端付近がデコードされないことがあった)
　　のを修正
・Ctrl+E や Ctrl+Shift+E(ホットキー有効時)で演奏停止しようとするとフェードアウ
　トしていたのを修正
・ファイルオープンダイアログに関する以下の修正
　・アーカイブ対応
　・マルチセレクトに対応
　　・先頭がプレイリストの場合は先頭のプレイリストのみを「新規に開く」
　　　(複数選択されていても先頭がプレイリストなら 2 つ目以降は無視される)
　　・先頭がプレイリスト以外の場合は「リストに追加＋再生」(選択された中にプレイ
　　　リストがあっても無視される)
・「sorted」状態で終了すると、次回起動時に演奏リストの順序が入れ替わるのを修正
　・キャッシュ(playdone_{xxxx}.bin) の仕様変更が必要なため、旧版で終了時に保存
　　された再生済み情報は新版には引き継がれない(演奏リスト自体に保存されているも
　　のは引き継がれる)
・kbfmmidi.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・ループ MIDI に対応
　・再生周波数要求の受け入れ上限値を 96000Hz から 192000Hz に変更
　・音の合成を 32bit int で行っていたのを 64bit float で行うようにした
　　・正弦テーブルとかは int のままなので音質向上は限定的
　・programs.txt が Unicode である場合に対応(UTF-8/UTF-16LE)
・kbfmoplmidi.kpi に関する以下の修正
　・INI ファイルを廃止。本体の設定画面で設定を行えるようにした
　・設定項目は FM OPL MIDI Player に準じるが、いくつかの項目は無視される
・SDK を更新(source.7z に kbasio.kpi のソースコードを追加のみ)

/*---------------------------------------------------------------------------*/

2.80beta30a(2016/10/10)

・ファイルオープンダイアログに関する以下の修正
　・最初の項目選択時でも演奏リストが開けるようにした
　・マルチセレクトモードになっていたのを修正(マルチセレクトは未対応)
・ドキュメント部や情報表示パネルで新規に追加した4色を指定しても反映されないのを
　修正

/*---------------------------------------------------------------------------*/

2.80beta30(2016/10/10)

・Media エクスプローラと演奏リストの選択時の文字色と背景色を設定出来るようにし
　た
・色の設定に関する以下の修正
　・一部の色について、表示名を変更(濃い青=>紺、明るい緑=>黄緑 etc)
　・選択可能な色を追加(VCL の TColor で名前がついているもの)
　　・空色(clSkyBlue)
　　・クリーム(clCream)
　　・ミントグリーン(clMoneyGreen)
　　・ミディアムグレー(clMedGray)
・PSF のタグが文字化けすることがあるのを修正
・別ウィンドウで開く Media エクスプローラでアイコンとフォント等の設定が反映され
　ていなかったのを修正
・タスクトレイの「Media エクスプローラ」メニューが機能していなかったのを修正
・デバイスプラグインの仕様を変更
　・KPI_MEDIAINFO::dwFormatType が DoP かどうかの情報をオープン時に渡すように
　　し、デバイスプラグイン側で DoP 非対応なら失敗させるようにした
・デバイスオープンに失敗したときのメッセージを修正
　・Format Type が PCM か DoP(DSD over PCM) かも表示
・kbum.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・PCM(*.PAC) の検索パスを設定出来るようにした
　・本体側での PCM 検索パスの設定を廃止
・kbfmp.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・設定項目を追加
　　・再生周波数
　　・WinFMP.dll のパス
　　　・未指定の場合はプラグインと同じフォルダまたは OS 既定の DLL 検索アルゴリ
　　　　ズム(本体 EXE と同じフォルダ、システムフォルダ等)で検索
　　　・本体のバージョンアップ時にプラグインと同じフォルダに WinFMP.dll をコピ
　　　　ーするのが煩わしく、かといってシステムフォルダに置きたくない場合に設定
　　　　する
　　・リズム音源の検索パス
　　　・未指定の場合はプラグインと同じフォルダから検索
　　　・本体のバージョンアップ時にプラグインと同じフォルダにリズム音源のデータ
　　　　をコピーするのが煩わしい場合に設定する
　　・PCM(PVI) の検索パス(最大64個まで)
　　・設定の保存場所は kbpmd.kpi と共有
　・本体の PVI 検索パス設定を廃止
　・必要な PCM ファイルが存在しない場合でもファイルを開けるようにした
　　・制作者の意図した通りには鳴らないが、とりあえずは再生出来るように
　・アーカイブ内のデータに(ある程度)きちんと対応
　　・アーカイブプラグインの仕様によっては稀に正しく再生出来ない可能性がある
　・ループ曲にきちんと対応
　　・本体のループ回数の設定が反映されるようになった
　・必要な PCM/PPZ ファイル名を本体に通知するようにした
　　・実際には読み込まれなかった(存在しないorエラーで開けなかった)ものも含む
・kbpmd.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・設定項目を追加
　　・再生周波数
　　・PMDWin.dll のパス
　　　・未指定の場合はプラグインと同じフォルダまたは OS 既定の DLL 検索アルゴリ
　　　　ズム(本体 EXE と同じフォルダ、システムフォルダ等)で検索
　　　・本体のバージョンアップ時にプラグインと同じフォルダに PMDWin.dll をコピ
　　　　ーするのが煩わしく、かといってシステムフォルダに置きたくない場合に設定
　　　　する
　　・リズム音源の検索パス
　　　・未指定の場合はプラグインと同じフォルダから検索
　　　・本体のバージョンアップ時にプラグインと同じフォルダにリズム音源のデータ
　　　　をコピーするのが煩わしい場合に設定する
　　・PCM(PVI) の検索パス(最大64個まで)
　　・設定の保存場所は kbfmp.kpi と共有
　・本体の PVI 検索パス設定を廃止
　・必要な PCM ファイルが存在しない場合でもファイルを開けるようにした
　　・制作者の意図した通りには鳴らないが、とりあえずは再生出来るように
　・アーカイブ内のデータに(ある程度)きちんと対応
　　・アーカイブプラグインの仕様によっては稀に正しく再生出来ない可能性がある
　・ループ曲にきちんと対応
　　・本体のループ回数の設定が反映されるようになった
　・必要な PCM/PPC/PPS/P86/PPZ ファイル名のうち、実際に読み込むことが出来たもの
　　を本体に通知するようにした
　　・存在しないorエラーで開けなかったものは通知しない(API の仕様で必要なファイ
　　　ルを取得することが出来ない?)
・ツールバー/アイコンのサンプル画像を差し替え
・SDK 更新(デバイスプラグインに関する修正)

/*---------------------------------------------------------------------------*/

2.80beta29(2016/10/02)

・デコーダプラグインの仕様を変更
　・SDK 更新(ソースコードの変更が必要)(ほんの少しだけ)
　・デコーダプラグインに関してはこれで確定の予定(変更になったらごめんなさい)
・Media エクスプローラ(行全体を選択時)と演奏リストでマウスドラッグによる複数ア
　イテム選択を改善
　・Media エクスプローラは任意の場所から選択開始
　・演奏リストでは
　　・ドラッグ時の選択項目が１つのときは
　　　マウスの位置が「タイトル」列の文字列内からだとアイテム移動、それ以外から
　　　だとアイテム選択
　　　(アイコン領域や「タイトル」列以外の位置からだとアイテム選択)
　　・ドラッグ時の選択項目が複数のときは
　　　マウスの位置が選択項目内だとアイテム移動、それ以外だとアイテム選択(選択
　　　し直し)
　・Windows エクスプローラと似てるが同じではない
・Media エクスプローラと演奏リストのフォントや背景色を設定出来るようにした
　・情報表示パネル・ドキュメントとは区別するが、Media エクスプローラと演奏リス
　　トは連動
　・背景色によっては複数アイテム選択時に選択項目が分からなくなるのを回避するた
　　め、選択時の文字色を少し変更(RGB値をそれぞれ 3/4 にする。文字色が黒のとき
　　は変わらない)
・アイコン(歌詞と音符)とツールバーの画像をカスタマイズ出来るようにした
　・アイコンは 16x16 を 8 個(txt/lrc/kra/wrd/sry/neo/音符1/音符2)
　・ツールバーは 24x24 を 24 個繋げた BMP ファイル
　・カタガネさんに提供頂いたサンプルを添付
　・詳細は image/image.txt を参照
・高 DPI 環境での表示を改善(検索バー他)
・実行ファイルの MIDI(関連付け用)アイコンをゴージャス?なものに変更＆省サイズ化
・kbdmusic.kpi に関する以下の修正
　・DLS の検索パスを設定出来るようにした
　・演奏開始時に時に少し待つようにした(なぜか DLS の検索パス指定が適用されない
　　ため)
　・本体側での DLS 検索パスの設定を廃止(設定し直す必要がある)
・情報表示部の「プラグイン」をシングルクリックからダブルクリックで設定画面を開
　くように仕様変更
・情報表示部の「ファイルパス」をダブルクリックすると再生中のファイルをエクスプ
　ローラ(「送る」のプログラム1)で開くようにした
・細かいバグを修正

/*---------------------------------------------------------------------------*/

2.80beta28a(2016/09/22)

・「waveIn による波形取得を行う」のチェックが本来の値と反対になっていたのを修正

/*---------------------------------------------------------------------------*/

2.80beta28(2016/09/22)

・本体のコンパイラを C++ Builder 10.1 Berlin Update 1 に変更
・「DirectSound」を使用後にヘルプの「検索」タブで「検索開始」ボタンをクリックす
　るとなぜかフリーズする謎の不具合を修正
　・kbrunkpi.exe を介してヘルプを開くことにより、ヘルプがフリーズしても本体が巻
　　き込まれることはなくなった(フリーズを検知したらダイアログを表示して強制終了
　　可能)
　・「バージョン情報」等のモーダルダイアログ表示状態でもヘルプを操作出来るよう
　　になった
・「デフォルトの曲の長さ」と「メドレー再生時間」の設定の読み書きがおかしくなっ
　ていたのを修正
・↑の設定をミリ秒単位(小数点を使う)で指定出来るように仕様変更(設定の保存場所も
　変更)
・「レジューム再生」の設定を無視して常に有効になっていたのを修正
・48x48 と 256x256 のアイコンを差し替え(ゴージャス？な感じに)

/*---------------------------------------------------------------------------*/

2.80beta27(2016/09/20)

・WMA の埋め込み画像を取得出来ないことがあるのを修正
・プラグインから埋め込み画像の縦横サイズが渡されない場合は本体が取得するように
　した
・演奏リストで歌詞を含む曲の曲長計算をしても歌詞を含むと見なされなくなっていた
　のを修正
・再生中の曲と同一フォルダにある画像のうち、再生中の曲とは無関係と見なされるも
　のは表示しないようにした。表示しない条件は以下の通り
　・画像ファイル名(拡張子を除いた部分。以下同)が "front", "cover", "back",
　　"folder", "artist" のいずれでもない
　・画像ファイル名が再生中のファイル名、親フォルダ名、アルバム名のいずれとも異
　　なる
　・画像ファイル名と同名のメディアファイルが存在する(存在しても上記の条件を満
　　たしていなければ表示する)
　・具体例等、詳細はヘルプの「メインウィンドウ」->「メインメニュー」->
　　「ツール」->「環境設定」->「外観」を参照
・実行ファイルと MIDI(関連付け用) のアイコンに 48x48 と 256x256 を追加
　(カタガネさんに提供して頂いたもの)
・「コピー」メニューとタスクトレイクリック時のメニュー(左側の情報表示部)に長い
　文字列を表示すると、幅が広いままになるのを改善(完全には修正出来ていない)
・SWRD/NWRD に関する以下の修正
　・ウィンドウサイズを自由に変更できるようにした(縦横比は 640:480 固定)
　・解像度切り替えによるフルスクリーン再生を廃止(ダブルクリック時は「最大化」)
　・タイトルバー非表示を廃止(常に表示)
・SWRD 再生時に画像が表示されなくなっていたのを修正
・今さらながらファイルオープンダイアログで演奏リストと CueSheet 以外のファイル
　(mp3 とか)を開けるようにした
・「ファイル」メニューに「設定フォルダの整理」を追加
　・旧バージョンで作成されたが、動作中のバージョンでは参照されなくなってゴミと
　　なっている設定及びキャッシュファイルを削除(%APPDATA%Kobarin's Soft\以下)
　・レジストリの整理は未実装

/*---------------------------------------------------------------------------*/

2.80beta26(2016/09/12)

・曲データに内蔵のアルバムアート(ジャケット写真)に対応
　・デフォルトで対応している形式で、埋め込み画像が利用可能な形式は全て対応した
　　つもり
　・ID3v2.2/2.3/2.4(本体が実装)(MP3/TTA)
　・RIFF(本体が実装)
　　・"ID3 " チャンクの "APIC"(WAV 等)
　　・"DISP" チャンクのタイプ(CF_DIB)(RMI 等)
　・ApeTag(本体が実装)(Monkey's Audio/MusePack/WavPack/TAK/OptimFROG)
　・ASF(本体が実装)(Windows Media Audio/Video/ASF)
　・MPEG4-AAC/ALAC(kbm4a.kpi)
　・FLAC(kbflac.kpi)
　・OggVorbis(kbvorbis.kpi)
　・OggOpus(kbopus.kpi)
・RIFF のタグ取得に関する以下の修正
　・"ID3 " チャンクに対応(リプレイゲイン、埋め込み画像等に対応)
　　・"INFO" よりも "ID3 " チャンクを優先的に取得するため、STEP_K や mp3infp/u
　　　でタグを書き換えても見かけ上反映されないことがある(STEP_K や mp3infp/u は
　　　"ID3 " チャンクに未対応)
　・"DISP" チャンクのタイプ(CF_TEXT)を含む場合は "INAM" を "Title(INAM)" とし
　　て通知するようにした("DISP" チャンクを含まなければ "Title" として通知する)
　・"DISP" チャンクの埋め込み画像(CF_DIB)に対応(Win9x 時代の RMI 等に含まれる)
　・"ISBJ" は "Subject" として通知するようにした(今までは "Title" として通知)
・タグの項目数が上限に満たないとき、「コピー」とタスクトレイのメニューに空行が
　表示されるのを修正
・グレースケールの PNG を表示出来ないのを修正
・液晶の表示に関する以下の修正
　・曲切り替え直後の液晶のちらつきを軽減
　・midiOut ではなくプラグインで MIDI を再生中だとドット絵や文字列を表示する
　　SysEx が含まれていても表示されないのを修正
　・演奏プラグイン(kbdmusic.kpi/kbqt.kpi)で MIDI を再生時、「演奏設定」->「wave
　　In による波形取得を行う」が無効時に液晶が動かないのを修正
　　・midiOut デバイス使用時と同じ表示になるようにした
　　・「waveIn による波形取得を行う」が有効時は波形取得出来ない場合は動かない
・ループ MIDI を正しく再生出来ないことがあるのを修正
・フェードアウトしたときは単曲リピート時や連続再生時でも次の曲に切り替わらない
　ようにした
・Ctrl を押しながら停止ボタンをクリックした場合はフェードアウトするようにした
・kbm4a.kpi に関する以下の修正
　・埋め込み画像に対応
　　・種類(Front/Back)の取得は未対応
　　・最初に見つかったものを front, 2番目を back, 3番目以降を Other として通知
　　・Mp3Tag で埋め込んだ場合と結果が異なる
　・コンピレーションアルバム("compilation")を含むと文字化けした値を通知していた
　　のを修正
　・true/false で通知するようにした
・kbmp3.kpi/kbmad.kpi に関する以下の修正
　・本体が持つタグ取得を以下の順で呼ぶように変更
　　・ID3v2 => ApeTag => RIFF => Lyrics3Tag => ID3v1
・kbtak.kpi に関する以下の修正
　・ApeTag/RIFF ともに本体のルーチンを利用してタグ取得するようにした
　　・TAK のライブラリでは埋め込み画像に対応出来ないため
・kbflac.kpi/kbvorbis.kpi/kbopus.kpi に関する以下の修正
　・埋め込み画像に対応
・プラグイン SDK を更新
　・一部仕様変更されているが、IKpiTagInfo::SetPicture を呼んでいなければ問題な
　　く動作する(はず)
　・ビルド時に少しだけソースコードの修正が必要になったかも

/*---------------------------------------------------------------------------*/

2.80beta25(2016/09/05)

・情報表示パネルに表示する項目に関する以下の修正
　・拡張子で決め打ちしていたのを、実際に情報が含まれている項目だけを表示
　・以下の順(カスタマイズ出来るようにした方が良いかも)
　　・ファイルパス(常に表示)
　　・タイトル("title")(常に表示)
　　・アーティスト("artist")
　　　・Origアーティスト/Albumアーティストも含む場合は / で区切って表示
　　　・名前が重複する場合は非表示
　　　・「ドキュメント」部には個別に表示
　　・作詞者("lyricist")
　　・作曲者("composer")
　　・編曲者("arranger")
　　・演奏者("performer")
　　・著作権("copyright")
　　・作成者("dumper")(SPC/VGM/GYM用)
　　・フォーマット("midiformat")(MIDI用)
　　・トラック数("miditrack")(MIDI用)
　　・対応音源("midimodule")(MIDI用)
　　・使用ポート("midiport")(MIDI用)
　　・アルバム("album")
　　・ゲーム名("game")
　　・memo1("memo1")(FMP/PMD用)
　　・memo2("memo2")(FMP/PMD用)
　　・memo3("memo3")(FMP/PMD用)
　　・機種名("machine")(VGM用)
　　・エミュレータ("emulator")(SPC用)
　　・日付("date")
　　・ジャンル("genre")
　　・参照ファイル("refferenced_file")(CueSheet用)
　　・DiscID("discid"(CueSheet用)
　　・コメント("comment")
　　・コメント("description")(FLAC/OGG のコメント)
　　・曲の長さ(常に表示)
　　・プラグイン(常に表示)
　・上記の順に調べ、情報を含むものだけをこの順に表示
　・表示可能な項目数の限界(9個)に達した分は非表示(「ドキュメント」部には表示)
　・「ファイルパス」「タイトル」「曲の長さ」「プラグイン」は常に表示するため、
　　実質的な項目数の限界は 5 個まで
　・アルバム名にトラック番号とディスク番号を付加するか設定出来るようにした
　　(チェック有効時：アルバム名 Disc 1/2 Track 5/15)
　　・ディスク数が 1 の場合にディスク番号を非表示にするかも設定出来るようにした
　　・トラック番号がなくてトラック数だけ含む場合は番号を ? にする(??/15)
・"comment" と "description" を同一視せずに区別するようにした
　・ドキュメント部には区別して表示し、情報表示パネルではどちらも「コメント」と
　　して表示
・ID3v2 の「作詞者」("TEXT") と「指揮者」("TPE3") と「編曲者」("TPE4")の取得に
　対応("TPE4" を編曲者として良いのか微妙な気もするが)
・初回起動時に規定のデバイスとして「DirectSound」の「プライマリ サウンド ドライ
　バー」が選択されなくなっていたのを修正
・バージョン情報ダイアログに関する以下の修正
　・「QuickTime」と「PsxMC」と「Vivo Active Player」がインストールされていても
　　認識出来なかったのを修正(64bit版のみ)
・kbwasapi.kpi に関する以下の修正
　・演奏停止時にフリーズすることがあったのを修正
・ヘルプを更新
　・環境設定->外観/演奏設定

/*---------------------------------------------------------------------------*/

2.80beta24(2016/08/31)

・nwdll.dll(NWRD 再生 DLL)に関する以下の修正
　・複数の NBF(NeoWRD バイナリ)ファイルを同時に開けない仕様だったのを開けるよう
　　に修正(今のところ、複数の nbf を同時に開くことはないが)
　・不正なデータを開くとメモリを破壊する箇所があったのを修正
　・API に互換性がなくなったので DLL ファイル名とエクスポートする関数名を変更
　・jpeg ライブラリを libjpeg 9b(2016/1/17)に差し替え
・SWRD/NWRD 再生ルーチンを修正(アーカイブ内のデータを再生時に一時ファイルを作成
　せずに画像を扱えるようにする、拡大縮小時の画質が向上他)
・kbunarc.kpi に関する以下の修正
　・RAR 解凍ルーチンを unrarsrc 5.4.5 に差し替え
　・一部の ZIP ファイルを正しく扱えなかったのを修正
　　(Data descriptor フラグが有効なもの)
　・IKpiFile::GetFileName で返すファイル名が仕様と異なることがあったのを修正
　　"aaa/bbb.xxx" を "bbb.xxx" のように返さなければいけないのを "aaa/bbb.xxx"
　　と返していた
・kbnwdll.dll と kbunarc.kpi に内蔵の libpng と zlib を切り離した
　・libpng.dll/zlib.dll として本体と同じフォルダに移動
　・全体的なバイナリサイズを削減(気休め程度)
・libpng を 1.6.24(2016/8/4) に差し替え
・本体の PNG/JPG/GIF 画像読み込みに VCL を使わないようにした
　・PNG は本体と同じフォルダの libpng.dll を使う(ない場合は PNG 画像を扱えない)
　・BMP/JPG/GIF は Windows API の OleLoadPicture 関数を使う
　・本体のバイナリサイズを(64bit版では大幅に)削減
・アルバムアートの上下左右の帯の色がパネルのサイズによって変わるのを修正
　・拡大縮小「後」の左上隅の色だったのを拡大縮小「前」の色にした
・情報表示パネル/アルバムアート/SWRD/NWRD の画像の拡大・縮小時の画質が向上
　・SetStretchBltMode に HALFTONE を指定
　・縮小時の画質が向上したので SWRD/NWRD で 320x240, 480x360, 560x420 を追加
・初回起動時のみ default.kbmu が保存されないのを修正
・空のお気に入りファイルを読み込むと・・のような不正な文字が表示されるのを修正
　(保存時にもその不正な文字を書き込んでいた)
・ロードに失敗したプラグインが次回起動以降見えなくなるのを修正
・kbrukpi.exe のコンパイルオプションを変更(DEP 有効他)

/*---------------------------------------------------------------------------*/

2.80beta23b(2016/08/23)

・プラットフォームが反対のプラグインやノンリエントラントなプラグインを使用時、
　演奏終了時に kbrunkpi.exe 内で落ちる(しばらくの間応答なしになる？)のを修正

/*---------------------------------------------------------------------------*/

2.80beta23a(2016/08/22)

・タグの形式が ApeTag で本体がタグ取得していると Media エクスプローラでタイトル
　を正しく表示出来なくなっていたのを修正(wavpack/ape/一部の mp3)
　・OptimFROG/TAK はプラグイン自身でタグ取得していたので問題なかった
・kbopus.kpi に関する以下の修正
　・ライブラリを libopus 1.1.3(2016/7/15)に差し替え
・kbmpg123.kpi に関する以下の修正
　・ライブラリを libmpg123 1.23.6(2016/6/30) に差し替え
・kbmac.kpi に関する以下の修正
　・ライブラリを Monkey's Audio SDK 4.18(2016/8/6) に差し替え
・kbwv.kpi に関する以下の修正
　・ライブラリを libwavpack 4.80.0(2016/3/28) に差し替え

/*---------------------------------------------------------------------------*/

2.80beta23(2016/08/22)

・プラグインの仕様を変更(タグ取得関係)
　・プラグイン側で本体のタグ取得ルーチン(ID3Tag/ApeTag等)を呼び出せるようにした
　　・対象データのタグ形式が ID3v2 だが本体がそれを知らない場合でも、プラグイン
　　　作者が ID3v2 取得を実装不要になった(もちろん実装しても構わない)
　・本体のタグ取得ルーチン呼び出し後、独自タグ等の上書き制御を以前より柔軟に行
　　えるようにした
　　・本体が取得したリプレイゲイン値と独自に取得した値のどちらを優先するか等
　・本体のタグ取得ルーチン呼び出し結果の値を取得出来るようにした
　　・取得したいフィールド名が分かっている場合のみ。フィールド名の列挙は不可。
　　  (そこまでするならプラグイン作者が自分で実装した方が早い)
　・埋め込み画像(アルバムアート)を通知するためのメソッド追加(未実装)
　・タグ取得時、取得するフィールドの指定フラグを追加
　　・IKpiDecoder::Select/IKpiPlayer::Select
・仕様変更に伴い、全てのデコーダプラグインと演奏プラグインを更新
　・kbmpg123.kpi/kbmad.kpi 以外はインターフェースのみなのでバージョン変更なし
・kbmpg123.kpi と kbmad.kpi に関する以下の修正
　・v2.80beta23 のプラグイン仕様に対応
　・本体が持つタグ取得を以下の順で呼ぶようにした
　　・ApeTag => ID3v2/v1 => RIFF
　　・↑で本体がリプレイゲインを取得した場合、LameTag から得たリプレイゲインが
　　　あっても適用されないようにした
　　・v2.80beta22 以前では本体側でどちらを優先するかを決めていた
　　　(LameTag の方が優先度が低かったので結果は変わらないが)
・SDK 更新(デコーダプラグイン関係を kpi.h から切り離して kpi_decoder.h に移動)
　・ビルドにはソースコードの修正が必要

/*---------------------------------------------------------------------------*/

2.80beta22(2016/08/20)

・Media エクスプローラに関する以下の修正
　・2.80beta21 でアーカイブを多く含むフォルダの表示に時間がかかるようになったの
　　を修正(場合によってはフリーズしているかのように見える)
　・↑の修正に加えて 2.80beta20b 以前よりもツリーの構築が高速化(したはず)
　・ファイルが存在し得ないフォルダ(コントロールパネル等)が表示されなくなった
・64bit版のバージョン情報ダイアログを修正
　・一部の 32bit 版プログラム(PsxMC等)のインストールの認識が正しく動作しない旨
　　を表示(正しく認識出来るようにするのはかなり手間がかかるので後回し)

/*---------------------------------------------------------------------------*/

2.80beta21(2016/08/16)

・プラグイン設定画面に関する以下の修正
　・プラットフォームが反対の同名プラグインを非表示かつ無効化するチェックボック
　　スを追加(2.80beta18 以前の同等チェックボックスだと非表示になるだけだった)
　　・チェックを外せば個別に有効化/無効化出来る
　　・設定も保存される(初期値は非表示&無効化)
　・デバイスプラグインとアーカイブプラグインも使用中であれば表示するようにした
　・使用中のプラグインを検索するボタンを追加
　　・ボタンクリック時は使用中のプラグインだけを抽出
　　・ラベルクリック時は使用中のプラグインに移動
　・使用中のプラグインがツリー上で視覚的に分かるようにした
　・改行を使用する著作権の表示に対応(著作権のみ)
　・セクションの切り替え直後、値の先頭行だけ保存値が表示されるのを修正
　・その他色々バグ修正&細かい改善(忘れた)
・プラグイン仕様に関する以下の修正
　・セクションの表示名とヘルプに対応
・kbrunkpi 経由でプラグインが独自のダイアログを表示中だと、同じプラグインを使用
　する別の曲に切り替えられない(ダイアログを閉じるまでフリーズする)のを修正
・kbrunkpi 経由でダイアログを表示中に「応答がない」というメッセージが表示されな
　くなった
・ハードコーディングしていた日本語文字列をリソース化(本体のみ)
・アンインストール用終了時に %APPDATA% 以下に設定が残ってしまうのを修正
　(プラグインキャッシュファイル関係)
・終了時の演奏リスト情報(default.kbmu)の保存場所を変更
　・本体と同じフォルダ\default.kbmu
　　=>%APPDATA%Kobarin's Soft\KbMedia Player\cache\default.kbmu
　・↑が存在しない場合に 2.80beta20b 以前の default.kbmu を検索しない
　・終了時の演奏リストにファイル名があり、更新もされていない場合は default.kbmu
　　を保存しない(今までと同じ)
・終了時の再生済み情報(playdone.dat)の保存場所とファイル名を変更
　・本体と同じフォルダ\playdone.dat
　　=>%APPDATA%Kobarin's Soft\KbMedia Player\cache\playdone_{guid}.bin
　　　({guid} の部分はデータの互換性がなくなったら変更予定)
　・↑が存在しない場合に 2.80beta20b 以前の再生済み情報ファイルを検索しない
・終了時のお気に入り情報(favorite.dat)の保存場所を変更
　・本体と同じフォルダ\favorite.dat
　　=>%APPDATA%Kobarin's Soft\KbMedia Player\cache\favorite_{guid}.txt
　　　({guid} の部分はデータの互換性がなくなったら変更予定)
　・↑が存在しない場合は 2.80beta20b 以前の再生済み情報ファイルを検索する
　・中身がテキストなので拡張子を .txt に変更
・本体は自身と同じフォルダに設定やキャッシュ等のファイルを作成しなくなった
　・kbfmoplmidi.kpi 等、プラグインによっては自身と同じフォルダに設定ファイル等
　　を作成することがある(標準同梱のものは全て作成されないようにする予定)
・kbm/kbmu 保存時のヘッダー情報の一部(説明部)が欠けていたのを修正
　・説明部分が欠けていただけで、リストとしては問題なかった
・m3u/m3u8 読み込み時、パスの区切り文字に '/' を使用している場合に対応
　・書き込み時はパスの区切り文字は常に \ を使用
　・kbm/kbmu では未対応(対応予定なし)
・m3u/m3u8 が BOM なしの UTF8 である場合にある程度対応(誤判別の可能性あり)
　・書き込み時は常に BOM 付加
・アーカイブプラグインを無効化しても Media エクスプローラで LZH 等が表示される
　のを修正
　・ツリーの開閉ボタンが表示されるのを回避する方法は分からなかった)
　・OS の設定変更が必要?
・kbsnesapu.kpi と kbfpd.kpi に関する以下の修正
　・v2.80beta21 のプラグイン新機能に対応
　　・Genreal/Temporary 各セクションの説明を追加
　　・Temporary セクションの表示名を「一時的な設定」に変更
　　・著作権表示で改行を使用

/*---------------------------------------------------------------------------*/

2.80beta20b(2016/08/09)

・プラグイン設定の書き込みが機能していなかったのを修正
　(beta20a でも直ってなかった)
・起動時に無意味に巨大なメモリを確保(直後に解放)していたのを修正
　(デバッグコードの削除し忘れ)

/*---------------------------------------------------------------------------*/

2.80beta20a(2016/08/08)

・プラグイン設定の書き込みが機能していなかったのを修正
・tag ファイルの読み込みが出来なくなっていたのを修正
・kbrunkpi 経由で1ファイル複数曲を扱えなくなっていたのを修正

/*---------------------------------------------------------------------------*/

2.80beta20(2016/08/08)

・アーカイブ関係(kbunarc.dll/kbungca.dll)の完全プラグイン化
　・DLL ファイル名を決め打ちでロードしていたのを起動時に動的検索
　・拡張子を .kpi に変更(置き場所は UnArc\ 以下に変更)
　・プラグイン設定画面に対応
　・kbunarc.kpi は 32bit/64bit 両対応。kbungca.kpi は 32bit 版のみ
・kbunarc.dll に関する以下の修正
　・64bit 版で CAB を開けない or 開くと落ちることがあるのを修正
　・プラグイン化に伴いファイル名を kbunarc.kpi に変更
　・32bit 版で kbungca.dll を呼び出していたのを呼び出さないように修正
　　(kbungca.dll をプラグイン化)
　・サイズの制限を設定出来るようにした(アーカイブ自体のサイズのみ)
　・SherryWRD 再生時の PNG 画像取得と一部の形式のタグ取得(GZ 圧縮されたもの)に
　　kbunarc.kpi を使用しているため、無効化しても必要に応じてロードされる
・kbungca.dll に関する以下の修正
　・プラグイン化に伴いファイル名を kbungca.kpi に変更
　・サイズの制限を設定出来るようにした
・kbdmusic.kpi に関する以下の修正
　・64bit 版の本体から使用するとファイルを開けない(プラグイン内部で落ちる)か、
　　ファイルを開けても DLS を読めずに正しく再生されないのを修正
・プラットフォームが反対のデバイスプラグインを使用出来るようにした
　・現状全てのデバイスプラグインが x86/x64 両対応なので実用性は全くなし
　　(反対のプラットフォーム版を使う利点はない)
　・デバイスが列挙されるのが目障りな場合は設定で無効にする
・プラグイン SDK を更新
　・設定関係(IKpiConfig)
　・演奏プラグイン(kpi_player.h)
　・デバイスプラグイン(kpi_device.h)
　・アーカイブプラグイン(kpi_unarc.h)
　・次の正式版までにやりたいことの実現度 80% というところ

/*---------------------------------------------------------------------------*/

2.80beta19(2016/08/01)

・プラグインの設定画面に関する以下の修正
　・表示の並べ替え(使用優先度順/名前順)
　・プラットフォームが反対の同名プラグインの無効化
　・「環境設定」->「プラグイン」タブを廃止(同等の機能を全て実装したため)
　・情報を表示すると設定画面を閉じてもプラグインをロードしたままになるのを修正
　・一部の環境で選択状態のノードの文字列が見えないのを修正
・再生しか出来ず、PCM を取得出来ない形式(kbmov.dll 等、主に動画関係)の完全プラ
　グイン化(仕様はまだ非公開)
　・DLL ファイル名を決め打ちでロードしていたのを起動時に動的検索
　・拡張子を .kpi に変更(置き場所は Player\ 以下に変更)
　・プラグイン設定画面に情報表示
　・使用優先度の並び順のアルゴリズムはデコーダプラグインと同じ
　・「デバイス設定」の「Direct Music」と「QuickTime Music Synth」を廃止
　　・「Player」で kbdmusic.kpi/kbqt.kpi を選択
・kbmov.dll に関する以下の修正
　・ファイル名を kbmov.kpi に変更(置き場所は Player\ 以下)
　・対応拡張子を設定出来るようにした
　・QuickTime を kbqt.kpi で再生させたい場合は対応拡張子から .mov と .qt を外す
　・「環境設定」->「その他」->「動画の拡張子」を廃止
・kbqt.dll に関する以下の修正
　・ファイル名を kbqt.kpi に変更(置き場所は Player\ 以下)
　・QuickTime の設定画面を開けるようにした
・kbfmoplmidi.kpi に関する以下の修正
　・v2.80beta19 のプラグイン仕様に対応
　・設定ダイアログ自動生成に仮対応
　　・設定ファイル(kbfmoplmidi.ini)を関連付けで開くのみ
　　・プレイヤーが自動生成した画面上での編集は次版で対応予定
・kbrunkpi 経由でファイルを開くとスレッドが解放されなくなることがあるバグを修正
　(大量のスレッドが(待機状態だが)走行したままになり、動作が重くなる)
・プラグイン仕様を変更(v2.80beta18 以前のプラグインは使えなくなった)
・*.tag ファイルで曲番号1番だけ @Song1= を省略しても表示されるのを修正

/*---------------------------------------------------------------------------*/

2.80beta18(2016/07/25)

・プラグインの設定画面を大幅に修正
　・インストールされているプラグインをツリー表示
　・詳細情報表示(添付ドキュメント含む)と設定の編集が可能
　・設定を編集中でもメインウィンドウ等の操作が出来るようになった
　・設定を編集中は表示値ではなく保存値で表示
　・型が BOOL の場合はチェックボックスを表示
　・一部未実装だが「環境設定」->「プラグイン」タブと同等の機能を備える
　　・プラットフォームが逆の同名プラグインの非表示が未対応
　　・表示順序(ファイル名順等)の変更が未対応
　　・kbfmoplmidi.ini を関連付け起動出来ない(新仕様プラグインで設定を ini に保
　　　存するタイプ)(旧プラグインは対応)
　　・再生中の曲に関わるプラグインの使用/不使用のチェックマークを切り替えて
　　　「適用」しても即座に反映されない(ファイルを開き直せば反映される)
　　・これらを実装したら「環境設定」->「プラグイン」タブは廃止予定
・プラグイン仕様(主に設定に関する部分)を変更
　・GUID が一致すれば置き場所が変わっても設定が共有されるようにした
　・プラグインが対応すれば x86/x64 で設定が共有される(共有されないようにするこ
　　とも出来る)
　・エクスポートする関数名を変更
　　・設定に関する機能を使わなければ 2.80beta17 のプラグインはまだそのまま使え
　　　る(次版以降で使えなくなる予定)
・デバイス関係の完全プラグイン化(仕様はまだ非公開)
　・DLL ファイル名を決め打ちでロードしていたのを起動時に動的検索
　・拡張子を .kpi に変更(置き場所は従来通り device\ 以下)
　・表示順序が変わった(通常 ASIO が最初に表示される)
　　・ファイル名順(並べ替えは未対応)
　・設定画面上でチェックマークを外しても無効化されない(未実装)
・デバイス関係の設定の保存場所を一部変更
　・最後に使用していたデバイスは x86/x64 で区別して保存
・kbfpd.kpi に関する以下の修正
　・v2.80beta18 の新プラグイン仕様に対応
　・設定ダイアログ自動生成に対応
　・kbfpd.ini を廃止
　・本体をバージョンアップして置き場所が変わっても設定が引き継がれる
　・設定可能な項目
　　・FPV 検索フォルダ
　　　・今まで本体で設定していたが廃止。保存場所が変わるため、設定し直す必要
　　　　がある
　　・常に別プロセスで使用
　　　・プラグインが不安定で本体が巻き込まれないようにするための設定
　　　・パフォーマンスが低下するが本体が巻き込まれないので規定では true
　　　　(v0.15 以前では false 相当)
　　　・本体が 64bit 版の場合は設定値に関わらず常に別プロセスで使用される
　　・再生周波数(44100/33075/22050/16538/11025)
　　・ステレオ(false 時はモノラル)
　　・エフェクト(なし/リバーブ/リバーブ・コーラス)
　　・システムエフェクト(なし/リバーブ/リバーブ・コーラス)
　　・ここから下は常用に適さないため、最後に設定変更してから 24 時間以上経過後
　　　に初期値に戻す(戻さないように設定することも出来る)
　　・テンポ
　　　・プレイヤー本体の速度変更機能より高音質低負荷だが、再生位置の進み方が
　　　　速度に連動せず、曲長計算で取得される曲の長さが変わってしまう
　　　・データや設定値によっては再生出来なかったり強制終了してしまうことがある
　　　　・fpd98sub.dll 内でゼロによる除算エラーが発生。プラグイン側で強引に回避
　　　　　を試みるが失敗したら強制終了(FPD98 でも同じ現象が発生する)
　　・トランスポーズ(音程)
　　　・プレイヤー本体の速度変更機能より高音質低負荷
　・モノラル(kbfpd.ini の op_v=1)だと正しく再生出来ていなかったのを修正
・kbsnesapu.kpi に関する以下の修正
　・v2.80beta18 の新プラグイン仕様に対応
　・GUID を元に設定の保存場所が決まるようにした
　・Temporary セクションを初期値に戻す設定を修正
　　・戻すなら24時間後固定に変更
・kbdshow.kpi に関する以下の修正
　・v2.80beta18 の新プラグイン仕様に対応
　・GUID を元に設定の保存場所が決まるようにした
　・x86/x64 版で設定が共有されるようになったが、使用可能な DirectShow フィルタ
　　が x86/x64 で異なる可能性があるため、対応拡張子の設定はキーを異なる値にして
　　区別するようにした
・kbasio.dll/kbdsound.dll/kbwasapi.dll/kbwaveout.dll に関する以下の修正
　・v2.80beta18 の新プラグイン仕様に対応
　・プラグイン化に伴い、拡張子を .kpi に変更
　・GUID を元に設定の保存場所が決まるようにした
　　(x86版とx64版で設定が共有される)

/*---------------------------------------------------------------------------*/

2.80beta17(2016/07/11)

・プラグイン/DLL のコンパイラを VS2015 update 3 に変更
・プラグイン仕様を変更(設定ダイアログ自動生成(IKpiConfig)関係)
　・プラグインから得た情報を元に設定ダイアログを本体側で自動生成する機構を実装
　・新機能については今のところ kbsnesapu.kpi / kbdshow.kpi のみ対応
　・2.80beta16 以前のプラグインは動作しなくなった(2.63a 用のものは動作)
　・非標準(別配布)のものでは kbpsf.kpi(v0.01beta) と kbzmdrive.kpi(v0.11alpha)
　　が該当(近いうちに対応版を公開予定)
・kbsnesapu.kpi に関する以下の修正
　・コンパイラを VS2015 update3 に変更
　・snesapu.dll を 2.17.6.5532(2016/05/29) に差し替え
　・IKpiConfig(本体による設定画面の自動生成)に対応(v2.80beta17 以降)
　　・環境設定->プラグイン->kbsnesapu.kpi 選択時に「設定」ボタンクリック
　・各種設定項目を追加
　　・補間処理
　　・シーク制御(シーク速度とシーク後の演奏の精度の調整)
　　・リプレイゲイン(音量値をリプレイゲインとして通知)
　　・音量既定値(XID6 に音量値がない場合の既定値)
　　・XID6 の使用/不使用(使わない場合は音量既定値)
　　・再生周波数
　　・ローパスフィルタ
　　・サラウンド無効
　　(ここから下は常用には適さないため指定時間経過後に初期値に戻す)
　　・再生速度(再生位置の進み方が速度と連動しない)
　　・音程
　　・BASS BOOST
　　・過去の ADPCM 互換
　　・左右変転
　　・逆位相サラウンド強制
　　・エコー無効
　　・ピッチモジュレーション無効
　　・ピッチベンド無効
　　・FIR フィルタ無効
　　・エンベロープ無効
　　・ノイズ無効
　　・エコー作業メモリ書き換え
　・以下の設定の初期値を変更(そのため初期設定値で v4.13 とは音質が異なる)
　　・補間処理を 高精度ガウス分布補間 => シンク関数補間
　　・ローパスフィルタを false => true (snesapu.dll 制作者の推奨値)
　　・サラウンドを true => false (snesapu.dll 制作者の推奨値)
・kbdshow.kpi に関する以下の修正
　・コンパイラを VS2015 update3 に変更
　・IKpiConfig(本体による設定画面の自動生成)に対応(v2.80beta17 以降)
　　・バージョンアップ時に(本体の置き場所が変わっても)設定が引き継がれるように
　　　なった
・Media エクスプローラで 2GB 超のファイルサイズを正しく表示出来ていなかったのを
　修正＆サイズの表示の仕方を修正(KB 以外の単位も使う、小数第2位まで表示等)
・プラグインを使用して MIDI を再生時にクロスフェードしようとすると落ちるのを修
　正(v2.80beta7 から発生するようになっていて半年近く気が付かなかった)

/*---------------------------------------------------------------------------*/

2.80beta16(2016/06/26)

・プラグインから得た情報を元に設定ダイアログを本体側で自動生成する機構を実装
　・今のところデバイス関係(kbdsound.dll/kbasio.dll/kbwasapi.dll のみ)対応
　・設定の保存場所は %APPDATA%\Kobarin's Soft\KbMedia Player\config\xxxx 以下
　　(xxxx は互換性がなくなったら変更する予定)
　・「デバイス設定」->「設定」ボタンで設定
・kbsound.dll に関する以下の修正
　・DirectSoundNotify を使うかどうか設定出来るようにした
　　・"true" だと正常に再生出来ない場合のみ "false" にする
・kbasio.dll に関する以下の修正
　・デバイスを開いた直後の発音時に無音を再生させるようにした
　　・再生時間を設定可能(初期値50ms)(0〜500ms)
　　・HP-A8 対策(音が途切れる)
　　・手動で曲を切り替え時や再生周波数が切り替わったときに有効。連続再生時は(
　　　再生周波数が変わらなければ)ギャップレスで曲を切り替えるため影響しない
　・「再生バッファサイズ」が ASIO のバッファサイズ(ASIO ドライバ側で設定)よりも
　　小さいと再生出来ないのを修正
　　・HP-A8 の ASIO ドライバだと再生位置とスペアナの表示がおかしくなるので ASIO
　　　のバッファサイズを小さめにすることを推奨
・kbwasapi.dll に関する以下の修正
　・イベント駆動/タイマー駆動のデバイス名を列挙するか設定出来るようにした
　　・イベント駆動で正常再生出来るデバイスはタイマー駆動を使用するメリットがな
　　　いためタイマー駆動を列挙しないようにすると良いかも
　・レイテンシを調整できるようにした
　　・初期値(30ms)でノイズが入るなど正常に再生出来ない場合は変更してみる
　　・大き過ぎても小さく過ぎても良くない
・kbdshow.kpi に関する以下の修正
　・フォーマット(サンプル周波数・ビット深度等)の取得部分がまずかったのを修正
　・無駄に非同期な処理を行っていたのを修正
　・メモリリーク修正
・「アンインストール用終了」時に %APPDATA%\Kobarin's Soft\ 以下も削除するように
　した
・演奏停止ボタンの位置がおかしくなっていたのを修正
・液晶を非表示から表示に切り替えたときにフォントの設定が反映されないのを修正

/*---------------------------------------------------------------------------*/

2.80beta15(2016/06/12)

・kbunarc.dll に関する以下の修正
　・RAR 解凍ルーチンを unrarsrc 5.4.2 に差し替え
　・7Z 解凍ルーチンを LZMA SDK 16.02 に差し替え
　・7Z 解凍時の(かなり深刻な)メモリリークを修正
　・RAR/7Z 解凍時、物理メモリの空き容量の 1/8 まではテンポラリファイルを作らず
　　メモリ上に解凍するようにした(32bit版では 2GB 超えでも最大 256MB まで)
　　・制限を超える分は従来通りテンポラリファイルを作成
　　・ファイル数が多い場合やテンポラリフォルダが HDD 上にある(SSD でない)場合の
　　　処理が大幅に高速化（その代わりメモリ使用量が増加）
　　・主に SPC 等、サイズが小さなデータ用
　　・対象データが見つかるまでの全てをメモリ上に解凍するため、後ろにあるデータ
　　　ほどメモリ使用量が大きくなる
・WASAPI のバッファサイズを調整(kbwasapi.dll)
　・デバイスによっては再生出来ないことがあったのを修正
　・逆に再生出来なくなったデバイスがあるかもしれない
　　（設定出来るようにする必要があるかも）
・kbsnesapu.kpi に関する以下の修正
　・xid6 読み込み時に落ちることがあるのを修正
・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.23.4(2016/05/11版)に差し替え
・連続再生時にタイムタグ付き歌詞を含む曲に切り替わると落ちる or 歌詞を表示出来
　ないことがあるのを修正
・ローカルファイルの処理を修正(環境によっては誤動作していたかも)
・メモリリーク修正

/*---------------------------------------------------------------------------*/

2.80beta14(2016/05/09)

・midiOut デバイス名が重複するとフリーズするのを修正
　・重複した場合は末尾に番号を付加({0001}のように表示)
・2.80beta13a の 64bit 版で png/gif 画像がなぜか表示されないのを修正
　(原因不明。C++ Builder 10.1 Berlin の最適化バグ？)
・IKpiTagInfo::xSetValueU8/u8SetValueX の仕様を以下のように変更
　・Utf8 としては正しくないが、ShiftJIS としては正しい場合は ShiftJIS と見なす
　　ようにした(本来は Utf8 にすべきところを ShiftJIS で書き込む古いタグエディタ
　　が使用された OggVorbis/FLAC が文字化けするのを修正)
・アルバムアートに関する仕様変更
　・情報表示パネルと同じ高さの正方形内に収まるように縦横比を維持して拡大・縮小
　・画像が正方形でない場合は上下か左右に帯を付けて中央に表示
　・帯の部分は画像の左上隅の色で表示(拡大・縮小後の左上隅の色のため、情報表示パ
　　ネルの高さによって帯の色も変わる)
　・液晶非表示 or 小型化時に画像によって「ファイルパス」「タイトル」等の文字の
　　位置が変わることがなくなった
・リストビューのソートマークを△▽から▲▼に変更
・終了時に動画のウィンドウ位置を正しく保存していなかったのを修正
・プラグイン(sidplay.kpi 等)によっては再生中のファイルを Media エクスプローラ
　上で情報表示出来なかったり、曲長計算出来ないことがあったのを修正
・バージョン情報ダイアログの mp3infp/u と VS2015 Runtime の URL を変更
・多重起動時に起動済み本体のハングアップを検知した場合はその旨メッセージを表示
　し、強制終了するか確認するようにした(検知出来ない/強制終了出来ない場合もある)
・ヘルプのリンク切れを修正

/*---------------------------------------------------------------------------*/

2.80beta13a(2016/04/22)

・本体(Kbmplay.exe) のコンパイラを C++ Builder 10.1 Berlin に変更
・ソースコードはほとんど変更なし(バージョン情報のみ)

/*---------------------------------------------------------------------------*/

2.80beta13(2016/04/17)

・VS2015 ランタイムが未インストールの状態で起動した場合はその旨表示するようにし
　た
・アルバムアートに関する以下の修正
　・複数の画像を含む場合、画像部分をクリックしたら次の画像に切り替えるようにし
　　た。画像の表示順は以下の通り
　　・画像ファイル名の優先順位は front->cover->folder->back->その他
　　　(その他は見つかった順)
　　・画像ファイル名が同じ場合、拡張子の優先順位は jpg->jpeg->png->gif->bmp
　　・例えば同一フォルダ内に front.jpg, back.jpg, back.png, picture.bmp が存在
　　　する場合、front.jpg->back.jpg->back.png->picture.bmp の順に表示
　・複数の画像を含む場合に指定時間経過ごとに画像を切り替えられるようにした
　　・「環境設定」->「外観」で設定可(初期値は30秒。0 にすると切り替えない)
・midiOut でループ曲でない MIDI の単曲リピート時、冒頭の「演奏開始前に送信する
　リセット」が送信されずにリピートされるのを修正
・MIDI 系プラグインのファイル名が長すぎると midiOut デバイスと見なされて使用出
　来ないのを修正

/*---------------------------------------------------------------------------*/

2.80beta12(2016/04/04)

・kbrunkpi.exe/プラグイン/各種 DLL のコンパイラを VS2015 Update2 に変更
　・コンパイラを変えただけなのでプラグインのバージョンは変更せず
・kbrunkpi.exe 経由でプラグイン使用時に設定画面などにビジュアルスタイルが適用
　されるようにした
　・kbviopsf.kpi v0.06/kbpsf.kpi v0.01beta を 64bit 版本体から使ったときに
　　「SPU plugin name」のコンボボックスがなぜか機能しないのが修正される
・DirectSound を使用して単曲再生時に演奏終了出来ずに終端がループし続けることが
　あるのを修正
・2.70alpha 以降、プラグインから本体の現在の再生位置を取得する非公式の機能
　(kbwinamp 用)が未実装になっていたのを実装
　・in_bm.dll + kbwinamp で BMS を再生時に BGA が正しく表示出来ないのを修正
・「送る」でファイル名やフォルダ名を正規化してから渡すようにした

/*---------------------------------------------------------------------------*/

2.80beta11(2016/03/22)

・kbfmoplmidi.kpi(FM OPL MIDI Player を使用した MIDI 再生プラグイン) を標準で
　同梱することにした(バージョンは 2016/02/07 公開の 0.02beta で変更なし)
・ギャップレスで曲切り替え時に冒頭付近のリプレイゲインが正しく適用されていない
　(切り替え前の曲のものが適用されていた)のを修正
・RAR 解凍ルーチンを unrarsrc 5.3.11 に差し替え(kbunarc.dll)
・libpng を 1.6.21 に差し替え(nwdll.dll/kbunarc.dll)
・GCA のタイムスタンプがずれていたのを修正(kbungca.dll)
・「環境設定」->「外観」に関する以下の修正
　・フォントの一覧表示時に等幅かプロポーショナルか識別出来るようにした
　・フォントの一覧表示の順序を修正(等幅フォントが最初に来るように)
　・設定可能なフォントの種類を増やした(日本語以外の環境用)
　・default.jpg を修正(2.63a と大体同じに)
　・情報表示パネルの画像をパネルの最大高さに合わせて拡大・縮小するか設定出来る
　　ようにした
　　・チェックが無効だと従来通り(タイル状に表示)
　　・画像の高さがパネルの最大高さよりも小さいときは拡大した方が良いかも
　・アルバムアートの表示・非表示を選択できるようにした(細かい設定は未対応)
　・情報表示パネルの画像の(文字に対する相対的な)位置がアルバムアートの有無に関
　　わらず一定になるようにした(液晶が「常時mini」のときに画像の左側がアルバムア
　　ートの分だけ隠れるのを修正)
・「ドキュメント」部でコードページ 437 のアスキーアートを使う場合はフォントを
　"Consolas" に変更するようにした
　・きちんと表示されるようになった(?)
　・437 を使うかどうかの判定は拡張子が .diz か .nfo のファイルに対してのみ行う
　・437 を使うと判定した場合は .diz/.nfo 以外のテキストに対してもフォントが
　　"Consolas" になる(部分的にフォントを変えることが出来ないので)
　・437 を使うと判定した場合に半角文字を全角に変換していたのをやめた
・演奏リスト「全て未再生にする」のショートカットを「F2」から「Ctrl+F2」に変更
　・F3(検索実行)のつもりがうっかり F2 を押して少しショックだったので。
・「お気に入りの整理」で名前の編集が出来なくなることがあるのを修正
・長さが１秒未満の曲を開くと落ちることがあるのを修正

/*---------------------------------------------------------------------------*/

2.80beta10(2016/03/13)

・Ogg Opus に対応(kbopus.kpi)
・kbmov.dll に関する以下の修正
　・曲を閉じるときに左上に一瞬だけウィンドウが表示されるのを修正
・動画関係 DLL 全般に関する以下の修正
　・動画のウィンドウが画面外にはみ出して行方不明になることがあるのを修正
　・タスクバーの位置によってはファイルを開く度に位置がずれていくのを修正
・CueSheet のビットレートがおかしいことがあるのを修正(演奏ファイル自体から取得
　出来ず、ファイルサイズからの概算で求めた場合)
・階層構造によってはアーカイブを開けないことがあったのを修正
・Unicode 化し切れていない箇所があったのを修正
・Unicode 化(2.70alpha3)以降、未実装になっていた機能のいくつかを実装
　・Media エクスプローラで音楽ファイルと同名で拡張子.txt の中身がタイムタグ付き
　　歌詞のときにアイコンを表示
　・NEZplug 拡張 m3u をプレイリストとして開く機能
　　(NEZplug 拡張 m3u のファイル名が再生する音楽ファイルと同名でない場合に曲長
　　やタイトルが無視されるのは仕様(2.63a でも同じ))
・kbmp3.kpi に関する以下の修正
　・libmpg123 を 1.23.2(2016/02/23版)に差し替え
・kbm4a.kpi に関する以下の修正
　・タグ取得時、フィールド名"album_artist" を "albumartist" として本体に通知す
　　るようにした(本体が「アルバムアーティスト」と認識するようにするため)
・kbsnesapu.kpi に関する以下の修正
　・snesapu.dll を 2.17.5.5391(2016/02/27) に差し替え
・alpha 版にしていたプラグインのバージョン表記から alpha を外した(仕様が確定し
　たわけではないが、動作自体は安定していると判断)
・ループ時間が指定されているループ曲の単曲リピートが無限ループにならないのを修
　正
・DDE のリクエストコマンドで長い文字列を取得すると文字列が1024文字で切り捨てら
　れるのを修正(SupportExt 等)

/*---------------------------------------------------------------------------*/

2.80beta9(2016/02/21)

・NSF 等再生時に m3u/pls/tag ファイルによる曲長指定が利かなくなっていたのを修正
・K.Takata 氏制作の mp3infp/u (mp3infp の UNICODE 版)に対応
　・mp3infp_ViewPropW がエクスポートされていればそちらを呼ぶようにした
　・バージョン情報ダイアログの URL を mp3infp/u の方に修正
・KbMedia Player の起動済みミューテックスオブジェクトに関する修正
　・32bit版/64bit版ともにミューテックスオブジェクト "KbMedia Player" を作成
　・↑に加えて 64bit 版は "KbMedia Player64" を、32bit 版は "KbMedia Player32"
　　を作成
　・まだ 32bit 版、64bit 版の同時起動は可能

/*---------------------------------------------------------------------------*/

2.80beta8(2016/02/07)

・ループMIDI(RPG ツクールによる拡張)に対応
　・コントロールチェンジ 111 番(CC111)をループポイントと見なす
　・CC111 が複数見つかった場合は最初に検出されたもの(時間が最も早いもの)を適用
　・ループポイントを検出しても、ループ時間が短すぎる場合は無視
　・tag ファイルによるループ回数(@LoopCount=)、フェード時間(@FadeOut=)指定も反
　　映される(フェード時間は h:m:s 単位、例えば 5500ms なら 5.5)
　・曲の長さ = length + (length-looppoint) * (loopcount-1) + fadeout
　　・length : CC111 がないものとしたときの長さ
　　・looppoint : 最初の CC111 の時刻
　　・loopcount : ループ回数(「デフォルトのループ回数」or tag ファイル)
　　・fadeout：フェード時間(「デフォルトのフェード時間」or tag ファイル)
　・単曲リピート時は
　　・MIDI デバイス使用時とループ MIDI 対応プラグイン使用時は無限ループに対応
　　・ループ MIDI 非対応プラグイン(DirectMusic/QuickTime含む)使用時は
　　　・ループ回数分再生したらフェードアウト->先頭から再生の繰り返し
　・ループポイントを検出した場合は「ドキュメント」部にその時刻を表示
　・ループ MIDI 対応プラグインは今のところ kbfmoplmidi.kpi(v0.02)のみ
・Muse の *u オプション(文字列系メタイベントを UTF-8 で出力)に仮対応
　・Marker(0x06)メタイベントのパラメータ "UTF-8" を検出したら、以後は文字列系
　　メタイベントを UTF-8 と見なして処理
　・ANSI で表現出来ない文字を含む MUS の歌詞を正しく表示出来るようになる
　・2016/02/07 現在 *u オプション対応の Muse は配布されていない
・ztom のコマンドラインオプションに -L0 -F0 を追加
　・MIDI を使う ZMS/ZMD(v2) のループ曲に対応
　・2016/02/07 現在ループ MIDI 対応の ztom は配布されていない
　・ループ MIDI 対応の ztom は公式サイトでは未公開のため、KbMedia Player のサポ
　　ート掲示板にて対応版 ztom を別途ダウンロードする必要がある)
・液晶表示部でエクスプレッションでない MIDI イベントをエクスプレッションとして
　処理することがあった(データによっては音量の表示が変だった)のを修正
・CueSheet で単曲リピート出来ないことがあったのを修正

/*---------------------------------------------------------------------------*/

2.80beta7(2016/01/31)

・アルバムアート(ジャケット写真)の表示に対応
　・対応する画像ファイルの拡張子(xxx)は jpg/jpeg/png/gif/bmp
　・再生中の曲と同じフォルダの画像ファイルを以下の手順で検索
　　・folder.xxx を検索(jpg=>jpeg=>png=>gif=>bmp の順)
　　・folder.xxx がない場合は同一フォルダ内で最初に見つかった画像を表示
　・埋め込み画像には未対応
・やぎ。氏制作 ztom.exe/z2m3.exe/zmc2.exe/zmc3.exe を使用しての ZMD/ZMS => MIDI
　変換に関する以下の修正
　・2.70alpha 以降、機能していなかった(未実装だった)のを修正
　・exe のパスを設定出来るようにした
　・コマンドラインの長さの制限回避のため標準入出力を使うように変更
　　・ztom.exe で変換出来ないことが多いのを回避(制限が64バイトしかないので)
　　・zmc3.exe は標準入力からだと動作しない(zmc3.exe のバグ?)ので入力ファイル名
　　　のみ実ファイル名を渡す
　・v3 => v2 (zmd は z2m2=>ztom, zms は zmc3=>zmc2)の順で変換を試みていたのを
　　v2 => v3 (zmd は ztom=>z2m2, zms は zmc2=>zmc3)の順で試みるように仕様変更
　　・v3 固有の機能を使わない v3 向け zms は正しく変換出来ないかも？
　・kbzmdrive.kpi 等、ZMS/ZMD 対応プラグインが有効な場合はそちらを使用する
　・MIDI を使う ZMD/ZMS を再生するときはプラグインを無効にする(内蔵音源部分は再
　　生されない）
　・内蔵音源を使う ZMD/ZMS を再生するときは対応プラグイン(kbzmdrive.kpi 等)を使
　　う(MIDI 部分は再生されない)
　・内蔵音源と MIDI の同期再生は未対応
・階層構造によってはアーカイブ内のデータを開けない or 落ちることがあるのを修正
・kbunarc.dll に関する以下の修正
　・RAR 解凍ルーチンを unrarsrc 5.3.9 に差し替え
　・7z 解凍ルーチンを LZMA SDK 15.14 に差し替え
　・マルチボリュームの CAB を正しく処理出来ないことがあるのを修正
　・メモリリーク修正
・kbtak.kpi に関する以下の修正
　・IKpiTagInfo の NULL チェックし忘れ修正
　　・タグ取得部で落ちることがあるのを修正(連続再生時の曲切り替え時に発生)
・kbofr.kpi に関する以下の修正
　・IKpiTagInfo の NULL チェックし忘れ修正
　　・タグ取得部で落ちることがあるのを修正(連続再生時の曲切り替え時に発生)
　・OptimFROG.dll を v5.003(2015/11/06 版) に差し替え
・kbsnesapu.kpi に関する以下の修正
　・30秒以上先にシークする場合は残り30秒までは高速シーク、残り30秒は低速シーク
　　を行うように仕様変更(今までは常に高速シーク)
　・Script700 の #i/#ib コマンドで日本語のファイル名を指定出来ないのを修正
・kbfpd.kpi に関する以下の修正
　・タイトルがない曲のタイトルに不定な値(ゴミ)が入るのを修正
　・日本語のファイル名を正しく扱えないことがあったのを修正
・Media エクスプローラのカーソルがおかしくなることがあるのを修正
・WAV を使う MUS の WAV 部分を再生出来なくなっていたのを修正
　・今のところ MIDI デバイス使用時のみ対応

/*---------------------------------------------------------------------------*/

2.80beta6(2016/01/18)

・WonderSwan の音楽形式(WSR/WSC)に対応(kbwsr.kpi)
　・ベースは in_wsr.dll 20060503(作者不明)
　・本体からの再生周波数要求に応じる(最小8000Hz/最大192000Hz)
　・常に 64bit float で出力
　・拡張子 WSR の曲数は常に 256、拡張子 WSC の曲数は常に 1
　　・不要な曲を非表示・非再生にしたい場合は TAG/(NEZplug拡張)M3U/PLS に記述
　・曲の長さやフェード時間は本体の「曲の長さ(ループ曲)」の設定に従う
　　・TAG/(NEZplug拡張)M3U/PLS に記述すればそちらに従う
・kbsnesapu.kpi に関する以下の修正
　・id666 の方に書き込まれた曲長とフェード時間を IKpiTagInfo に通知するように
　　した(xid6 の方の値が使われる場合は (ignored) を付加)
　・id666 の default channel(enable/disable) を通知するのをやめた
・kbfpd.kpi に関する以下の修正
　・新プラグイン仕様に対応
　・本体からのループ回数要求に応じるようにした
　　・「デフォルトのループ回数」で指定した回数になる
　　・ループ回数を fpd98.dll に渡すのではなく、fpd98sub.dll から得た曲長分だけ
　　　再生する
　　・データによってはループ回数を変えた場合の演奏終了の位置にばらつきがある
　・ループ曲でない場合の曲長にフェード時間が加算されないようになった
　・アーカイブ内の FPV にきちんと対応
　　・新仕様の機能を使用
　　・今までは本体がアーカイブ内の FPV の抽出処理を行っていたが、FPD のファイル
　　　フォーマットが分からないため抽出に失敗する可能性があった
　　・この版からは fpd98.dll が要求してきた FPV ファイルを確実に処理するため失
　　　敗の可能性はほぼなくなった
　・可能な限り UNICODE に対応
　　・FPV の検索パスに UNICODE でしか表現出来ない文字を使用したフォルダ名を指定
　　　しても再生出来るようになった
　・ループしない曲を再生すると曲の終端付近でフリーズするのを修正
　・終了処理(fpd98.dll の PlayEnd 呼び出し)でフリーズすることがあるのを回避する
　　方法がどうしても分からないため、本体を巻き込まないように常に kbrunkpi.exe
　　経由で再生させるようにした
・情報表示パネルに関する以下の修正
　・画像に使える形式を追加(JPEG/PNG/GIF)
　・デフォルトの画像を変更(default.bmp => default.jpg)
　・設定の保存場所を変更
　　・フォントも含めて設定し直す必要あり
　　・2.80beta6 以降で bmp 以外を指定しても 2.80beta5 以前で画像が表示されるよ
　　　うにするため
・テーマを切り替えたとき等に Media エクスプローラ/演奏リストのカラムが消える(幅
　が全て0になる)のを修正
・テーマを切り替えたとき等に「お気に入りの整理」ウィンドウ上のアイテムが全て消
　えることがあるのを修正
・NEZplug拡張 m3u/pls を使用する曲を再生すると tag/m3u/pls を使用しない曲を開け
　なくなるバグを修正
・kbdsound.dll に関する以下の修正
　・再生位置の進み方が不自然な場合があったのを修正
　・終端付近が再生されないことがあるのを修正
・終端付近が再生されないことがあるのを修正(kbdsound.dll のバグとは別件)
・「単曲再生」のときに「次の曲」を押すと再生済みチェックが初期化されるのを修正
・kbrunkpi.exe が異常終了した後に kbrunkpi.exe 経由で曲を開くと落ちるのを修正

/*---------------------------------------------------------------------------*/

2.80beta5(2016/01/11)

・プラットフォームが反対のプラグインを使用している場合の曲長計算とタグ取得が大
　幅に高速化
　・Kbmplay.exe(x64) + kbflac.kpi(x86) で 10000曲の FLAC の曲長計算にかかる時間
　　・約3分(2.80beta4) => 約15秒(2.80beta5) (x64 では約9秒)
　・kbrunkpi.exe をキャッシュすることによる
・kbsnesapu.kpi に関する以下の修正
　・新しいプラグイン仕様に対応(v2.80beta5以降専用)
　　・本体のバグのため、v2.80beta4 以前では使用不可
　・アーカイブ内の Sript700 にきちんと対応(新仕様の機能を使用)
　　・Script700 ファイル内で別の Script700 ファイルを指定する場合(#i,#it,#ib コ
　　　マンド)にも対応
　　・今までも対応していたが、本体側で Script700 ファイルの中身を調べていた
　・フェード時間が反映されるようになった
　・xid6 のタグ取得に対応
　　・ID666 と被る情報は xid6 を優先して取得
　　・イントロ、ループ、フェード、終了時間、ループ回数の取得に対応し、実際の再
　　　生にも反映される(新仕様の機能を使用)
　・バイナリ形式の ID666 を常にテキストと見なしていたのを修正
　　・確実な判別方法が(おそらく)ないため、稀に間違えることがある
　・その他、詳細な情報表示に対応
・kbm4a.kpi に関する以下の修正
　・AAC 再生時にノイズが入るバグを修正
・ループ曲関係の設定項目を追加
　・無音の検出時間(ms)
　　・0 にすると検出しない
　　・小さくし過ぎると誤検出(無音でないのに無音と見なす)が増える
　　・無音を検出しても 500ms は捨てずに再生される(検出時間が 500ms 以下の場合
　　　は除く)
　　・「先読みバッファのサイズ」以下にすると無音が再生される時間も 0に近づく
　・無音の音量レベル(dB)
　　・64bit float のサンプル値(の絶対値)が 10.0^(dB / 20.0) より小さいときに無
　　　音と見なす
　　・-200 にすると 0 のみを無音と見なす
　　・初期値より大きくする(-50 に近づける)と誤検出(無音でないのに無音と見なす)
　　　が増える
　　・初期値より小さくする(-200 に近づける)と検出出来ない(無音なのに無音でない
　　　と見なす)曲が増える
　・フェード時間/ループ回数を曲から取得
　　・チェックが有効な場合は
　　　tag ファイル => 曲 => デフォルト
　　　の順で適用される
　　・チェックが無効な場合は常にデフォルトの値が適用される。ただし、曲から得た
　　　フェード時間が 0 の場合はデフォルトの値は適用されない
　　・そのときの気分で変えたい場合はチェックを外す
・kbrunkpi.exe か本体のどちらかが異常終了したときに他方が巻き込まれるのを回避す
　る処理を改善
・予期しないタイミングでメモリアクセス違反等の例外が発生するとウィンドウを閉じ
　ることが出来ずにタスクマネージャで強制終了するしかなくなるのをある程度回避
　（終了出来るかどうかはエラーの状況による）
・動画再生時に浮動小数点エラーで落ちることがあるのを修正
・対応拡張子が MIDI 系と競合するプラグインを使用出来ないのを修正(auPiECE.kpi)
・QuickTime(*.mov/*.qt) のタグ取得の精度向上＆取得可能な情報追加＆高速化
・着メロ(*.mld/*.pmd) で取得可能な情報追加
　・"Date"(date), "Comment"(note), "Tool"(prot), "Version"(vers),
　　その他(FourCC 4文字を表示)(文字で表示出来ない場合は16進表示)
・Codecs.txt の UNICODE 化(中身は変更なし)
・ループ曲で終端付近(残りの再生時間がフェードアウト時間より短くなるような位置)
　にシークするとフェードアウトの開始位置がずれるのを修正
・IKpiTagInfo::xSetValueX(NULL, -1, NULL, -1)(デフォルトのタグ取得ルーチンを呼
　ばないようにする)で落ちるのを修正(IKmpTagInfo も)
・プラグイン情報でタイムスタンプが正しく表示出来なくなっていたのを修正

/*---------------------------------------------------------------------------*/

2.80beta4(2015/12/30)

・64bit 版で DirectMusic/QuickTime/CSTR/SWF/VIV を再生出来るようになった
　・kbrunkpi.exe 経由で 32bit 版の DLL を使う
・動画関係に関する以下の修正
　・ネイティブプラットフォーム版 kbmov.dll でファイルを開けなかった場合は反対の
　　(64bit ネイティブなら 32bit の) kbmov.dll で開いてみるようにした
　　・ネイティブには Codec が存在しないが反対なら存在する場合に対応
　・拡張子 mp4/m4v/3gp/3g2/ の再生に kbqt.dll よりも kbmov.dll を優先するように
　　した
　　・kbmov.dll(ネイティブ) => kbmov.dll(反対) => kbqt.dll の順で開く
　・拡張子 mov/qt を kbqt.dll を使って開けない場合は kbmov.dll で開くようにした
　　・kbqt.dll => kbmov.dll(ネイティブ) => kbmov.dll(反対) の順で開く
　・将来的にはどの DLL を使うか選べるようにする予定
　・プラットフォームが反対の DLL を使用時は情報表示パネルの DLL 名に "(x64)"(本
　　体が 32bit の場合) か "(x86)"(本体が 64bit の場合) を付加して表示するように
　　した
・MIDI 音源の判別結果が "GS(SC-55 or later)" のときに "????" になっていたのを
　修正
・SMF でない MIDI 関係(*.mus 等) のタイトル/アーティスト情報を SMF に変換後のデ
　ータから取得するようになっていたのを修正

/*---------------------------------------------------------------------------*/

2.80beta3(2015/12/28)

・DirectMusic の再生ルーチンを本体から切り離した(kbdmusic.dll)
・QuickTime の再生ルーチンを kbmov.dll から切り離した(kbqt.dll)
・QuickTime と CSTR 再生時のウィンドウを UNICODE 版(CreateWindowExW)で作成する
　ようにした(UNICODE に対応したわけではない)
・全ての対応動画形式でウィンドウサイズ変更に対応
　・SWF 以外は縦横比を維持(表示自体は SWF も縦横比を維持)
・kbunarc.dll に関する以下の修正
　・LZH 解凍時のエラーチェックを強化(落ちるデータがあったのを修正)
・SDK(kpi.h) の pfnCreateDecoderModule の戻り値を修正(BOOL* => BOOL)
　・プラグイン自体は BOOL で返すように実装されているので影響なし
　・64bit 版が誤動作していたかも？(32bit 版は影響なかったはず)

/*---------------------------------------------------------------------------*/

2.80beta2(2015/12/21)

・2.70alpha3 未満(UNICODE 非対応)で「お気に入り」が読めなくなるのを修正
　(「お気に入り」のファイル名を保存するレジストリキーを変更)
・32bit版と64bit版とで共通するファイルの一部を Kbmplay.exe の1つ上のフォルダに
　移動(Readme.txt/History.txt/Kbmplay.chm/default.bmp/Codecs.txt)
・プラグインの使用を無効にしていても「最新の情報に更新」すると使用する設定に戻
　るのを修正
・「表示」メニューと Media エクスプローラ上の右クリックメニューの「最新の情報
　に更新」時にプラグインの再検索をしないようにした
・↑の代わりに「環境設定」->「プラグイン」及び「デバイス設定」に「最新の情報に
　更新」ボタンを追加(プラグインの再検索を実行)
・kbasio.dll/kbdsound.dll/kbwasapi.dll/kbwaveout.dll の仕様を変更
　・演奏終了後に再生される無音が短くなった
　・デバイス設定画面上の「設定」ボタンクリックで設定画面を出せるようにした
　　(今のところ kbasio.dll のみ)
・kbunarc.dll に関する以下の修正
　・GCA に再対応
　・kbungca.dll を使う
　・kbungca.dll は VC6 で作成(32bit版のみ)
　・64bit 版では kbrunkpi.exe 経由で対応
　・暗号化 ZIP の対応を打ち切り(2.70alpha 以降、機能しなくなっていたが)
　　・unzip32.dll が不要になった
・「バージョン情報」ダイアログで unzip32.dll の項目を削除
　・暗号化 ZIP 対応の打ち切りにより不要になったため
・「ドキュメント」部に *.mus が表示されなくなっていたのを修正

/*---------------------------------------------------------------------------*/

2.80beta(2015/12/14)

・一通りの機能を実装したのとキリがないのでβ版に格上げ(でもあまり自信がない…)
・kbmov.dll/kbcstr.dll/kbswf.dll/kbviv.dll に関する以下の修正
　・UNICODE ファイル名にきちんと対応出来るように仕様変更
　・kbcstr.dll と kbmov.dll(QuickTime 再生部分) はライブラリの仕様上対応不可
　　(ANSI ファイル名のコピーを作成して対応)
・kbcstr.dll に関する以下の修正
　・コンパイラを VS2015 に変更
　　・32bit版のみ(64bit版のライブラリがない)
・kbswf.dll に関する以下の修正
　・コンパイラを VS2015 に変更
　　・バイナリサイズが小さくなった
　　・32bit版のみ(64bit版だと正常に動作しない)
　・ウィンドウサイズを任意の大きさに変更出来るようになった
・kbviv.dll に関する以下の修正
　・コンパイラを VS2015 に変更
　　・バイナリサイズが小さくなった
　　・32bit版のみ(64bit版 OCX がない)
　・ウィンドウサイズを任意の大きさに変更出来るようになった
　・最後まで再生されないのを修正
・「プラグイン」情報でドキュメントがあるのに表示されないことがあるのを修正
・プレイリストが(無題)のときに上書き保存ボタンを押しても何も起こらなくなってい
　たのを、保存ダイアログが表示されるように修正
・2.70 以降 PLS/TAG ファイル作成が未実装だったのを実装
　・UNICODE 文字列が含まれないときは ANSI で保存、含まれる場合は UTF-16(BOM付)
　　で保存(警告なし)
・バージョン情報ダイアログで落ちることがあるのを修正

/*---------------------------------------------------------------------------*/

2.70alpha9(2015/12/07)

・プラグイン/DLL のコンパイラを Visual Studio 2015 Update 1 に変更
・本体のコンパイラを C++Builder 10 Seattle Subscription Update 1 に変更
・音楽 CD を再生出来なくなっていたのを修正
・演奏リストへの保存時、「規定の並び順」で保存していたのを、実際に見えてる順で
　保存するようにした
　・「Sorted」状態は変わらないので、うっかり上書きしても元の並び順に戻してから
　　再度保存し直せば OK
・単曲再生の仕様を変更
　・演奏リスト上で再生開始したときは演奏リストの再生モードに従う
　・Media エクスプローラ上で
　　・「再生」したときは「単曲再生」
　　・「追加＋再生」したときは演奏リストの再生モードに従う
　・関連付け起動時やドラッグアンドドロップ時は、
　　Media エクスプローラの「ダブルクリック時」の設定が
　　・「リストに追加しないで再生」のときは「単曲再生」
　　・「リストに追加＋再生」のときは演奏リストの再生モードに従う
・リストビューの並べ替え時のソートマークの表示の仕方を変更
・長さが不明の曲を再生時にフェードアウトが利かなくなっていたのを修正
・TAG ファイルによるフェードアウト時間の指定値が 0 だと無視されていたのを修正
・コードページ437 のアスキーアートの表示にある程度対応(完璧ではない)
　・拡張子が .diz か .nfo の場合だけ対応
　・2.6x 以前でビジュアルスタイルを無効(Kbmplay.exe.manifest を削除)にして起動
　　したときとの違いは
　　・フォントが Terminal でなくても表示される
　　・罫線(│┌など)が半角2文字分の幅を持つため表示がずれるのを回避するため変換
　　　可能なものは半角を全角に変換、変換不可能なものは同じ文字を2回使用して対処
　　・↑により、横幅が本来の2倍となり、英数字が全角で表示され、二重線の縦の罫線
　　　の表示がおかしくなる。(↑をやらないと│┌等を使用してると表示がずれる)

/*---------------------------------------------------------------------------*/

2.70alpha8(2015/11/30)

・プラグイン仕様に関する以下の修正
　・ループ時間、ループ回数、フェードアウト時間に対応
　・時間の最小単位をミリ秒から100ナノ秒(=1/10000ミリ秒)(実質サンプル単位)に拡張
　・1つのファイルに複数の曲を含む形式にきちんと対応
　・曲番号ごとのタグ取得に対応
　・再生用の全情報取得と Media エクスプローラ用の簡易取得(タイトル/アーティスト
　　のみ)とでタグ取得を区別出来るようにした
　　・実装が面倒なら区別しなくても(処理を同じくしても)良い
　・詳細は SDK\kpi.h を参照
・tag ファイルに関する以下の修正
　・ファイル名.tag => taginfo.tag の順で検索して先に見つかった方だけを開くよう
　　に仕様変更(今までは両方あればファイル名.tag を優先、ファイル名.tag に含まれ
　　ない情報は taginfo.tag から取得していた)
　・演奏時間指定がミリ秒単位まで(秒の小数第4位以降切り捨て)だったのを 100ナノ秒
　　(=1/10000ミリ秒=1/10000000秒)単位(実質的サンプル単位)まで認識するようにした
　　(表示はミリ秒(0.0001秒の桁を四捨五入)だが内部的には 100ns 単位で管理)
　・1ファイル複数曲以外でも曲長、ループ時間、フェードアウト時間、ループ回数を指
　　定出来るようにした
　　・@Length=h:m:s (曲長、ループ曲の場合はイントロ+ループ1回)
　　　未指定の場合はデータから得た時間(不明の場合は「デフォルトの曲の長さ」
　　・@Loop=h:m:s(-)(ループ時間)
　　　未指定の場合はデータから得た時間(不明の場合は「デフォルトのループ時間」
　　　Length が不明の場合は無視される(0 と見なされる)
　　・@FadeOut=h:m:s(フェードアウト時間)
　　　未指定の場合はデータから得た時間(不明の場合は「デフォルトのフェードアウト
　　　時間」
　　・@LoopCount=N(ループ回数)
　　　未指定の場合はデータから得た回数(0以下の場合は「デフォルトのループ回数」)
　　・h:m:s(-) の書式は @SongN= の時間指定と同じ
　　・冒頭に @ をつけるのは再生結果に影響があることを示す意味(@SongN と同様)
　　・最終的な曲の長さ = Length + (LoopCount - 1) * Loop + FadeOut
　　　(Length + (LoopCount-1) * Loop だけ再生後、FadeOut かけてフェードアウト)
　　・s のみ小数点指定が可能、小数第8位以降切り捨て(従来は第4位以降切り捨て)
　　・SPC など、無限ループして演奏終了しない曲用(時間指定しないと「デフォルトの
　　　曲の長さ」だけ再生して演奏が打ち切られる曲用)
　　・元々ループしない曲(普通に演奏終了する曲)でループポイントを指定してループ
　　　機能を実現する訳ではない
　　・データから得た値(新仕様のプラグインはループ時間等も対応)よりも優先される
　　・長さが確定している曲で Length を指定すると途中で演奏が打ち切られるので注
　　　意(終端に不要な無音がある等で意図的に演奏を打ち切りたい場合に使えるかも)
　・1ファイル複数曲で @SongN= では記述不可能な情報(曲番号ごとのアーティスト、コ
　　メント、リプレイゲイン等)も記述出来るようにした
　　・[ファイル名::曲番号]セクションに記述(例：[aaa.nsf::0003])
　　・書式は通常の曲と同じ
　　・[ファイル名]セクションの @SongN= に記述された情報よりも優先される
　　・[ファイル名]セクションに @SongN= を1つでも含むと、そのリストに含まれない
　　　曲番号は再生されなくなるが、[ファイル名::曲番号] を含む場合も再生されな
　　　い。再生したければ @SongN= にも追加する必要がある
　　・@SongN= を [ファイル名::曲番号] セクションに記述しても無視される
・CueSheet に関する以下の修正
　・アーカイブ内の CueSheet に対応
　・FILE でアーカイブ内のファイルの指定に対応
　　・FILE "aaa.zip>bbb/ccc.wav" WAVE
　　・FILE "aaa.zip>bbb.lzh>ccc.wav" WAVE
　　　のような指定が可能(アーカイブの中のアーカイブにも対応)
　・相対パスによる記述の自由度が高くなった(親フォルダの指定も可)
　　・"C:\foo\bar.zip>abc.cue" で "aaa.lzh>bbb/ccc.wav" を指定すると
　　　"C:\foo\bar.zip>aaa.lzh>bbb/ccc.wav" を読み込む
　　・"C:\foo\bar.zip>aaa/bbb.cue" で "../abc.wav" を指定すると
　　  "C:\foo\bar.zip>abc.wav" を読み込む
　　・"C:\foo\bar.zip>aaa/bbb.cue" で "../../abc.wav" を指定すると
　　  "C:\foo\abc.wav" を読み込む
　　・新プラグイン仕様の IKpiFolder を応用
・Tagファイル/CueSheetともに UNICODE 対応時から実装済みだが UTF-8(BOM付) or UTF
　-16(BEも可) で保存すれば UNICODE 文字列も使用可能
・kbdshow.kpi/kbflac.kpi/kbm4a.kpi/kbmac.kpi/kbmad.kpi/kbmio.kpi/kbmpc.kpi
　kbmpg123.kpi/kbofr.kpi/kbtak.kpi/kbtta.kpi/kbvorbis.kpi/kbwma.kpi/kbwv.kpi
　を新しい仕様のプラグインに対応
・kbm4a.kpi に関する以下の修正
　・ALAC デコーダのメモリリークを修正
・kbmac.kpi に関する以下の修正
　・APL に対応(新仕様のプラグインの機能を使用して対応)
・kbmio.kpi に関する以下の修正
　・ライブラリを ERISA-Library version 1.07e にバージョンダウン
　　・EntisGLS ver.4s.05 が巨大過ぎて生成されるバイナリサイズが大きく、64bit 版
　　　のビルド方法も分からなかったため
　　・64bit 版を作成
　　・プラットフォームツールセットを VS2012 のものから VS2015 のものに変更
　　　・VS2012 のランタイムが不要になり、VS2015 のランタイムが必要になった
　　・バイナリサイズが小さくなった (32bit 版で 621KB => 113KB)
・kbvorbis.kpi に関する以下の修正
　・拡張子.oga に対応
・kbwma.kpi に関する以下の修正
　・ビットレートの取得に対応(VBR/CBR も通知)
・kbwv.kpi に関する以下の修正
　・ライブラリを 4.75.2 に差し替え
　・ハイブリッドモードの差分に対応
　　・.wv と同一フォルダ内にある拡張子が .wvc の同名ファイルを読み込む
　　・新仕様のプラグインの機能を使用
　・ビットレートの取得に対応
　　・ハイブリッドモードの場合は 1024kbps(128kbps+896kbps) のように表示
・IKpiFolder でアーカイブ内アーカイブを開こうとすると落ちるバグを修正
・UTF-8 で記録された ID3v2 のタグ情報が文字化けするのを修正
・Lyrics3 Tag の歌詞を取得出来なくなっていたのを修正
・IT の SongMessage の取得方法を修正
・「F0 43 10 4C 00 00 7F 00 F7 を送信する」の設定を廃止(常に送信)
　・Windows2000+YMF7x4 の対策なので今となっては不要
・「waveOut 使用時もクロスフェード有効」の設定を廃止(常に有効)
　・Windows9x/NT4.0 用の設定なので今となっては不要

/*---------------------------------------------------------------------------*/

2.70alpha7a(2015/11/04)

・WindowsXP/Vista で起動出来ないのを修正

/*---------------------------------------------------------------------------*/

2.70alpha7(2015/11/03)

・演奏リストに関する以下の修正
　・UNICODE 対応プレイリストの拡張子を .kbmu とした
　・*.m3u8 に対応
　・*.kbmu は UTF-16 で保存(他のエディタで UTF-8 で保存しても読み込みは可能)
　・*.m3u8 は UTF-8(BOM 付) で保存(BOM なしで保存された m3u8 は ANSI と見なして
　　読み込むため文字化けする)
　・*.kbm と *.m3u は ANSI で保存し、ファイル名に ANSI で表現不可な文字を含む場
　　合は確認のダイアログを表示
　・ANSI で保存する場合はファイル名が ANSI で表現不可な曲はスキップする。ファイ
　　ル名以外の ANSI で表現不可な文字は代替文字か「?」に変換（確認のダイアログも
　　表示しない）
　・ANSI で保存しても現在のプレイリストは保存前と変化なし（UNICODE ファイル名を
　　スキップしても UNICODE ファイル名の曲はリストに残る）
　・「上書き保存」時の動作
　　・kbmu の場合は確認なしに上書き
　　・kbmu 以外の場合は情報が失われる条件を満たすときは保存先ダイアログを表示
　　　・kbm  :ファイル名に ANSI で表現不可な文字を含む
　　　・m3u8 :アーカイブを含む
　　　・m3u  :アーカイブを含むかファイル名に ANSI で表現不可な文字を含む
・64bit 版で RCPCV.DLL が使えるようになった（RCPCV.DLL の置き場所は 32bit版 と
　同じフォルダで良い。64bit版と同じフォルダに置いても認識しない）
・nwdll.dll に関する以下の修正
　・コンパイラを VS2015 に移行
　・64ibt 版を作成、64bit 版で NeoWRD を再生出来るようになった
　・libpng と zlib を最新のものに差し替え(libjpeg は変更なし)
・バージョン情報ダイアログで VS2015 ランタイムの有無を確認出来るようにした
・本体と kbrunkpi.exe との通信中、互いのハングアップを検知して強制終了するかど
　うか確認のダイアログを表示するようにした
　・kbrunkpi.exe のハングアップに巻き込まれて本体もハングアップ＆タスクマネージ
　　ャで本体を強制終了すると kbrunkpi.exe だけシステムにゴミプロセスとして残る
　　現象を回避（kbrunkpi.exe もタスクマネージャで強制終了すれば良いことだが、
　　kbrunkpi.exe はバックグラウンドプロセスで見えないので残っていることに気づか
　　れにくい）
　・一方が無事であれば他方を強制終了してもそれを検知して適切な処理をするのでゴ
　　ミプロセスは残らない
・プラットフォームが反対のプラグインの kmp_Config に対応
　・設定画面を出せるようになった
　・画面表示後一定時間が経過するとハングアップ検知のダイアログが表示されるが、
　　設定画面を閉じれば自動で閉じる
・RCP の Memo の表示が一部文字化けしていたのを修正
・ZMS のタイトルを正しく取得出来なくなっていたのを修正
・kbdshow.kpi に関する以下の修正
　・設定ダイアログを修正(「KBWMA.DLL を使う」を廃止)
・MIDI 対応プラグインに関する以下の修正
　・不使用に設定したプラグインを MIDI デバイスで表示されないようにした
　・MIDI デバイスとしての表示名を「本体のフォルダからの相対パス」だったのを
　　「ファイル名」 + プラットフォーム(反対の場合のみ) に変更
・ロードに失敗したプラグインは次回起動時にロードしないようにした
　・プラグインのタイムスタンプが変わっていた場合は除く
　・ロード出来ないプラグインが存在するときの起動時間が改善
　・「最新の情報に更新」するか「プラグイン情報」で選択すればロードする
・ロードに失敗しても「プラグイン情報」で添付ドキュメントが表示されるようにした
・プラグイン情報ダイアログで同名＆同バージョンでプラットフォームが反対のプラグ
　インを非表示に出来るようにした
・UNICODE 化されていなかった箇所があったのを修正
・UNICODE/ストリーム対応プラグイン SDK 公開(kmp_pi.h 更新、kpi.h 追加)
　・何が出来るようになったかの評価用
　・未完成のため、次の正式版までには確実に仕様変更される

/*---------------------------------------------------------------------------*/

2.70alpha6(2015/10/25)

・本体が WindowsXP で動作するようなので、もうしばらくの間動作対象 OS に XP も含
　めることにした
・VS2015 で作成したプラグイン・DLL が XP でも動作するようにコンパイルオプション
　を変更
・64bit 版で 32bit プラグインを使えるようになった
　・メリットはほとんどないが、32bit 版で 64bit プラグインを使うことも可能
　・設定ダイアログ(kmp_Config) は未対応
　・タグ取得(kmp_GetTestTagInfo) は対応しているが、かなり低速
　・Kbmplay.exe が置かれているフォルダからの相対パス
　　・..\x86\Plugins\ を 32bit プラグイン置き場
　　・..\x64\Plugins\ を 64bit プラグイン置き場
　　としてプラグインを検索
　・64bit版と32bit版の両方が存在する同一バージョンで同名のプラグインが見つかっ
　　た場合は本体のプラットフォームの方を優先（本体が64bit版なら 64bit プラグイ
　　ンを優先)
　・本体とは反対のプラットフォームのプラグインはロードに時間がかかるため、初回
　　起動時(plugin.dat がない状態)の起動時間はかなり長い
・ストリーム対応のタグ取得関連のプラグイン仕様を変更
　・2.70alpha5 以前のα版プラグインを 2.70alpha6 で使う（またはその逆）と落ちる
・kbunarc.dll に関する以下の修正
　・コンパイラを VS2015 に変更
　・64bit 版を作成
　・rar 解凍ルーチンを unrarsrc 5.3.6 に差し替え
　　・UNICODE 対応
　　・メモリ展開出来なくなったので常にテンポラリファイルを作成
　・7z 解凍ルーチンを lzma15.09beta に差し替え
　　・UNICODE 対応
　　・kb7z.dll/7-zip.dll が不要になった
　　・method の取得法が分からないため常に LZMA と表示
　　・メモリ展開出来なくなったので常にテンポラリファイルを作成
　・GCA 対応を打ち切った(VS2015 で GCA SDK を使いたくてもリンカエラーになって
　　使用出来ない & 64bit 対応が面倒 & 使っている人が少なそうなため)
　　・余裕が出来たら VC6 で作成するかも
　・lzh/zip で UNICODE 対応
　・UNICODE 未対応なのは tar のみ(ファイルフォーマット自体が未対応？)
・kbm4a.kpi に関する以下の修正
　・48000Hz の曲が 44100Hz で再生されていたのを修正
・タスクトレイと情報表示パネル上で右クリックしたときの「コピー」メニューの文字
　列の長さの制限を 80 文字から 256 文字に変更
・設定ダイアログ等のフォントがなぜか Tahoma になっていたのを修正
・常駐プラグイン（非公式の機能）を廃止
　・ロードに失敗するようになった
　・需要があれば復活するかも

/*---------------------------------------------------------------------------*/

2.70alpha5(2015/10/20)

・kbasio.dll/kbdsound.dll/kbwaveout.dll/kbwasapi.dll のコンパイルオプションを
　変更（AVX 非対応 CPU だと落ちるのを修正？）
・kbmov.dll のコンパイラを VS2015 に移行。64bit 版でも動画を再生出来るようにな
　った。ただし、
　・QuickTime 形式の動画の再生及び「QuickTime Music Syntesizer」による MIDI 再
　　生は不可
　・↑の他にも、32bit のコーデックはあっても 64bit のがない場合等、32bit版で再
　　生出来ても 64bit 版では再生出来ない形式もある（その逆もあるかも？）
・情報表示パネル上で右クリックしても「コピー」メニューが表示されなくなっていた
　のを修正

/*---------------------------------------------------------------------------*/

2.70alpha4(2015/10/18)

・本体のコンパイラを C++Builder XE から C++Builder 10 Seatle に変更
　・64bit版の開発が可能になった
　・Windows XP 以前の OS サポートを完全に打ち切った(コンパイラが生成するバイナ
　　リが対応しないため)
・全てのプラグインと一部の DLL のコンパイラを VisualStudio 6.0 から
  VisualStudio 2015 に変更
　・本体は特別なランタイムなしで動作するが、プラグインの動作には
　　https://www.microsoft.com/ja-jp/download/details.aspx?id=48145
　の「Visual Studio 2015 の Visual C++ 再頒布可能パッケージ」のインストールが必
　要
・64bit版を公開
　・未完成なので以下の制限あり
　・アーカイブ未対応(kbunarc.dll がまだなので)
　・動画未対応(kbmov.dll/kbcstr.dll/kbviv.dll/kbswf.dll がまだなので)
　・RCPCV.DLL 等、32bit DLL を使う形式は再生不可
　・muse.exe 等、再生に必要なプログラムが 32bit でも相手が .exe なら再生可能
　・32bitプラグインは使用不可。標準で 32bit版しかないのは以下の通り
　　・kbfmp.kpi/kbpmd.kpi/kbfpd.kpi/kbmio.kpi/kbqcp.kpi/kbsnesapu.kpi/kbtak.kpi
　　　kbtss.kpi/kbtvq.kpi/kbum.kpi
　・↑は再生に必要なライブラリが 32bit 版しかないため 64bit 版を作成不可
　　（kbmio.kpi はライブラリにソースコードがあるので理論上は可能だが断念）
　・プラグイン仕様そのものは 32bit版と64bit版で特に違いはないため、公開中の SDK　　を用いて 64bit コンパイラでコンパイルすれば 64bit 版でも動作
　・DirectMusic が再生出来ない(sgt/sgp の再生不可 & DirectMusic による MIDI 再
　　生不可)
　　・IID_IDirectMusicPerformance8 の作成に失敗するが原因不明
　　・元々 64bit に未対応？
・UNICODE 対応に伴って発生した数々の不具合を修正

/*---------------------------------------------------------------------------*/

2.70alpha3(2015/10/11)

・コンパイラを C++Builder2007 から C++BuilderXE に変更
・UNICODE に対応（表示も対応）
・UNICODE 非対応プラグイン/アーカイブ形式で UNICODE ファイル名(ANSI で表現出来
　ない文字列を含むファイル名)を開く場合は、テンポラリフォルダに ANSI ファイル名
　のコピーを作成することで対応
　・%temp%\Kbmplay\XXXXXXXX_u2a\ 以下に作成(XXXXXXXX はランダムな文字列)
　・%temp%\Kbmplay\ 自体が ANSI で表現出来ない場合はどうしようもない
・UNICODE 対応プラグイン
　・kbdshow.kpi
　・kbflac.kpi
　・kbmac.kpi
　・kbmad.kpi
　・kbmio.kpi
　・kbmpc.kpi
　・kbmpg123.kpi
　・kbofr.kpi
　・kbtak.kpi
　・kbtta.kpi
　・kbvorbis.kpi
　・kbwv.kpi
　・kbwma.kpi
・アーカイブの UNICODE 対応状況
　・アーカイブファイル名と格納ファイル名の両対応
　　・cab
　・アーカイブファイル名のみ対応(格納ファイル名は未対応)
　　・lzh/zip/tar/rar
　・未対応(本体が ANSI ファイル名のコピーを作成して対応)
　　・7z/gca
・プレイリスト、歌詞ファイル、tag ファイル、CueSheet 等のテキストファイルの扱い
　・BOM 付でない場合は ANSI (Shift-JIS) と見なす
　・BOM 付の場合は UTF-8/UTF-16(LE)/UTF-16(BE) に対応
・プレイリストは UTF-16LE で保存(UTF-8 や UTF-16BE でも BOM 付であれば読み込み
　可能)
・内部処理は UTF-16LE なのでテキスト系は UTF-16LE が最も高速
・ストリームから開く機構に対応するがノンリエントラントなプラグインに対応
　(kbrunkpi.exe)

/*---------------------------------------------------------------------------*/

2.70alpha2(2015/09/29)

・コンパイラを C++Builder5 から C++Builder2007 に変更
　・Windows9x/NT4.0 で動作しなくなった（Windows2000 以降で動作）
　・正式に UNICODE に対応するまでの「つなぎ」の開発環境
・kbm4a.kpi を新プラグイン仕様(ストリームからファイルを開く機構)に対応
・kbwma.dll を kbdshow.kpi から切り離して kbwma.kpi にし、新プラグイン仕様に対
　応
・kbdshow.kpi を新プラグイン仕様に対応。ただしストリームからファイルを開く機構
　には未対応なのでアーカイブ再生時には一時ファイルを作る。それでも従来よりは効
　率的に動作する（ことがある）

/*---------------------------------------------------------------------------*/

2.70alpha(2015/09/24)

・プラグイン仕様にストリームからファイルを開く機構を搭載
　・アーカイブ内のファイルを再生時に一時ファイルを作成しないため処理が高速化
　・アーカイブ形式とプラグインの両方が対応する必要がある
　・アーカイブはランダムアクセスが可能な形式のみ対応。対応する形式は以下の通り
　　・LZH/ZIP(圧縮されていても対応するが無圧縮の方が高速)
　　　・圧縮されているとファイル終端へのシークが低速なので再生開始前に終端への
　　　　アクセスがある形式だとあまり早くならない
　　・TAR(常に高速)
　　・CAB/RAR(メモリ上に展開)
　　・7Z(状況により一時ファイルを作成 or メモリ上に展開)
　　・GCA(非ソリッド書庫ではメモリ上に展開、ソリッド書庫では一時ファイルを作成)
　　・LZH/ZIP/TAR の無圧縮ならアーカイブが大きくても処理速度、メモリ使用量にほ
　　　とんど影響しない
　　・CAB/RAR は一時ファイルは作らないが大きなアーカイブだとメモリを大量に使用
　　　する（以前のバージョンはメモリを使うのは一時ファイルを作るまでの間だけだ
　　　ったが現行バージョンは再生中も常にメモリを使用する）
　　・7Z/GCA は一時ファイルを作らないときは比較的（以前のバージョンよりは）高
　　　速だがメモリを大量に使用する。一時ファイルを作るときは低速だがメモリはそ
　　　れほど使わない
　・対応するプラグインは今のところ以下の通り
　　・kbflac.kpi
　　・kbmac.kpi
　　・kbmad.kpi
　　・kbmio.kpi
　　・kbmpc.kpi
　　・kbmpg123.kpi
　　・kbofr.kpi
　　・kbtak.kpi
　　・kbtta.kpi
　　・kbvorbis.kpi
　　・kbwv.kpi
　　・これらのプラグインを使用して再生時は大きなアーカイブでも通常のファイルと
　　　ほぼ同等のパフォーマンスで動作する
・アーカイブのサイズ制限を緩和
　・アーカイブ自体の制限を 512MB から 1GB に
　・サイズが大きな CAB/RAR/7Z を扱うのは今のままではちょっと危ない、かも。

/*---------------------------------------------------------------------------*/

2.63a(2015/10/12)

・「waveIn による波形取得を行う」を有効にしても動画再生時にスペアナが表示されな
　いのを修正

/*---------------------------------------------------------------------------*/

2.63(2015/09/29)

・kbm4a.kpi に関する以下の修正
　・再生周波数が 24000Hz 以下の M4A(コーデックが AAC のもの)の曲長を正しく表示
　　出来ず、途中までしか演奏されないのを修正
　・メモリリークを修正
・WindowsXP 以前(XP を含む)の古い OS でのサポートをこの版で打ち切り。今後は
　Windows Vista 以降でしか動作しなくなる予定

/*---------------------------------------------------------------------------*/

2.63(2015/09/29)

・kbm4a.kpi に関する以下の修正
　・再生周波数が 24000Hz 以下の M4A(コーデックが AAC のもの)の曲長を正しく表示
　　出来ず、途中までしか演奏されないのを修正
・WindowsXP 以前(XP を含む)の古い OS でのサポートをこの版で打ち切り。今後は
　Windows Vista 以降でしか動作しなくなる予定


/*---------------------------------------------------------------------------*/

2.62(2015/09/24)

・S98 のタグ取得を強化
・細かいバグの修正

/*---------------------------------------------------------------------------*/

2.62beta2(2015/09/20)

・1ファイル複数曲の拡張子を設定出来るようにした
　・以下の場合に設定し、通常は初期設定のまま変更しない
　　・本体が知らない形式の1ファイル複数曲対応プラグインを使いたい（作りたい）
　　・使用するプラグインの対応拡張子が初期設定では1ファイル複数曲と見なされる
　　　が実際はそうでない
　・暫定的な措置（いずれきちんと対応）
・動画の拡張子の設定場所を「環境設定」->「演奏」タブから「その他」タブに変更
・kbfmmidi.kpi に関する以下の修正
　・浮動小数点エラーで落ちることがあるのを修正
　・再生途中で先頭位置に戻すと冒頭にノイズが入るのを修正
・kbm4a.kpi に関する以下の修正
　・エラーチェックを強化
　・"Codec" を通知するようにした("MPEG-4 AAC LC", "ALAC" 等)

/*---------------------------------------------------------------------------*/

2.62beta(2015/09/15)

・スペアナが「再生バッファサイズ」x0.5(場合によってはx1.0)だけ先行して表示され
　ていたのを修正
・音量調節の変更が DirectSound 使用時以外だとスペアナに反映されないのを修正
・kmp_GetTestTagInfo の cszName に関する修正
　・"Track" を "TrackNumber" と同一視
　・"Disc"  を "DiscNumber"  と同一視
　・"Description" を "Comment" と同一視
　・"Year"  を "Date" と同一視
・kbmpg123.kpi v2.07/kbmad.kpi v0.18
　・LAME タグに書き込まれている LAME のバージョン取得の方法を変更
　　・LAME 3.100alpha でエンコードされた曲の情報取得が出来るようになった
・kbmod.kpi v0.03
　・ライブラリを libmodplug 0.8.8.5(2014/3/10) に差し替え
　・KMPMODULE::dwReentrant=0 になった
　　・MOD を再生中の曲長計算等が低速になった
　　・v0.02 以前でも本来は 0 にしておかないとまずかった
・TAK 再生プラグイン kbtak.kpi を同梱
・MPEG-4 AAC/ALAC 再生プラグイン kbm4a.kpi を同梱
・FMMIDI のエンジンを使用した MIDI 再生プラグイン kbfmmidi.kpi を同梱
・EMU de MIDI のエンジンを使用した MIDI 再生プラグイン emidi.kpi を同梱
　・emidi.kpi の制作者は [OK] 氏

/*---------------------------------------------------------------------------*/

2.61(2015/09/06)

・初回起動時（レジストリに設定が書き込まれていない状態での起動時）にデフォルト
　のデバイスが開けず、ファイルを開いても再生出来ないのを修正
・WAVE/MIDI ともにデバイスを開けなかった場合はメッセージを表示するようにした
　・ダイアログは15秒程度で自動的に閉じる
　・自動で閉じたら最後にもう１度だけオープンを試みて失敗したら演奏停止
　・MIDI デバイスは失敗しても無音で再生していたが停止するように仕様変更
・kbwaveout.dll と kbdsound.dll のエラーチェックを強化
　・再生中に他のアプリケーションが WASAPI デバイスを使用した場合などにフリーズ
　　するのを修正
・kbsound.dll で、他のプログラムが WASAPI で再生中など、実際は再生出来ない状態
　のデバイスを開けてしまうのを修正
・「デバイス設定」に関する以下の修正
　・「デバイスへの出力ビット数」のチェックが入っているもののうち、一番上のもの
　　だけを開くように仕様変更
　・「音質重視」ボタン実行時に使用可能なビット数が分かるようにするため、あえて
　　ラジオボタン（チェックを排他的に入れる）形式にはしない
・手動で曲切替え時、演奏リスト上でフォーカス移動されないことがあるのを修正
　・自動で切替え時は演奏リストがフォーカスを持っていないか、最後に操作してから
　　5秒以上経過していたらフォーカス移動
・kbsnesapu.kpi に関する以下の修正
　・バージョン番号を飛ばして 4.06 にした
　　・kbspc.kpi を開発終了して kbsnesapu.kpi を公開したときに 4.xx に変わったと
　　　見なすことに
　　・kbspc.kpi を含む古いバージョンから上書きしたときに kbspc.kpi よりも優先的
　　　に使われるようにするため
　・snesapu.dll を 2.17.4.5265 に差し替え
・kbmpg123.kpi に関する以下の修正
　・バージョン番号を飛ばして 2.06 にした
　　・kbmp3.kpi を開発終了して kbmpg123.kpi を公開したときに 2.xx に変わったと
　　　見なすことに
　　・kbmp3.kpi を含む古いバージョンから上書きしたときに kbmp3.kpi よりも優先的
　　　に使われるようにするため
　・LAME3.90 未満でエンコードされた MP3 が VBR でも CBR と表示されるのを修正
　・LAME タグに書き込まれたリプレイゲイン情報を本体に通知するようにした
　　・リプレイゲインの処理は本体側で行う
・kbmad.kpi に関する以下の修正
　・LAME3.90 未満でエンコードされた MP3 が VBR でも CBR と表示されるのを修正
　・LAME タグに書き込まれたリプレイゲイン情報を本体に通知するようにした
　　・リプレイゲインの処理は本体側で処理
・リプレイゲインをプラグインから得た場合、本体側でも取得出来た場合は本体で取得
　した方を優先するようにした（LAME Tag に書き込まれたリプレイゲインよりも ID3v2
　の方を優先）
・kmp_GetTestTagInfo で cszName に "METADATA_BLOCK_PICTURE" が渡された場合はサ
　イズが分かる程度の表示をするようにした（そのうち対応）
・mxdrvg.kpi を 2.00br11(2009/07/04) に差し替え
・32 パート使う MIDI を再生時に液晶画面が 32 パートモードに切り替わらなかったり
　画面がちらつくことがあったのを修正
・同一フォルダ内に多数の音楽とドキュメントファイルが存在する場合に「ドキュメン
　ト」表示のためのファイル検索に時間がかかるのを改善
・情報表示パネル上の「プラグイン」をクリックしたら使用中のプラグインの詳細情報
　を表示する（「環境設定」の「プラグイン」タブを開く）ようにした
・「ドキュメント」部で UTF-8/UTF-16LE/UTF-16BE のファイルを読み込むと文字化けす
　るのを修正
　・BOM 付きのみ対応。UNICODE 専用の文字は表示不可（? になる）
・↑同様 *.mus のタイトルが文字化けするのを修正
・ドキュメント部に *.mus ファイルの内容を表示する際の読み込みサイズの上限を
　16KB から 8KB に減らした
　・制作者からのコメント部分が見えれば十分と判断
　・中身は調べないので先頭のコメント部分が 8KB を超えてても途中で打ち切る

/*---------------------------------------------------------------------------*/

2.60(2015/08/30)

・3年振りの正式版
　・2.51betaXX があまりにも長く、2.50 との違いが大きいので、番号を飛ばして 2.60
　　に格上げ（2.50 のときにも同じこと書いてたり）
・曲長が短い曲から長い曲へ切り替わった後にシーク未対応の形式でシークすると再生
　位置がおかしくなるバグを修正
・MIDI 再生時に単曲リピートが出来なくなっていたバグを修正
・拡張子.ofs(OptimFROG の不可逆圧縮版) のタグ取得に対応
・kbdshow.kpi に関する以下の修正
　・Open を呼び出したのとは異なるスレッドから Close を呼ぶと、Open を呼び出した
  　スレッドが終了するまでフリーズするのを修正
　・SetPosition を呼ばずに Render すると失敗するのを修正
　・kbwma.dll を FreeLibrary するようにした(Version 1.14 の当時の問題は解決した
　　と思われるため)
　・実際は 2008年5月頃に修正していたが公開し忘れていた(^^ゞ
・kbfmp.kpi/kbpmd.kpi に関する以下の修正
　・ループしない曲の演奏時間が本体の「デフォルトのフェードアウト時間」の分だけ
　　長く表示されていたのを修正
・kbfpd.kpi に関する以下の修正
　・fpd98sub.dll を v1.05 に差し替え
　・スレッドの同期周りを改善
　　・音が途切れることがあったのを修正
　　・フリーズすることがあったのを修正
　　・シークが高速化
・kbmpg123.kpi と kbmad.kpi に関する以下の修正
　・VBRI の delay 値を反映させるようにした
　　・vbri delay - 1152 - 529 を encoder delay 値と見なす
　　・末尾の捨てるべきサンプル数が分からないのでギャップレス再生は不可
・kbofr.kpi に関する以下の修正
　・OptimFROG.dll を 5.002 (2015/8/18 版)に差し替え
　・拡張子 .ofs に対応
　・kmp_GetTestTagInfo に対応。通知する情報は以下の通り
　　・ビットレート
　　・version
　　・method
　　・speedup
　　・sampletype
　　・channnelConfig
　　・タイトル等のタグ取得(ApeTagv2)は本体に任せる
・kbsnesapu.kpi に関する以下の修正
　・snesapu.dll を 2.17.4.5251 に差し替え
・kbtss.kpi に関する以下の修正
　・in_tss.dll を Version 0.92(2005/12/17 版)に差し替え
・kbum.kpi に関する以下の修正
　・先頭位置に戻すと直前まで再生時の音が冒頭に混入するバグを修正
・その他プラグインに関する細かい修正(著作権表示、ドキュメント修正程度)
　・kbmac.kpi/kbmio.kpi/kbmod.kpi/kbmpc.kpi/kbqcp.kpi/kbtta.kpi/kbtvq.kpi
　　kbvorbis.kpi/kbwv.kpi
・kbcstr.dll に関する以下の修正
　・kbcstr.ini を廃止(常に StretchLevel=1(高品質高負荷) で処理)

/*---------------------------------------------------------------------------*/

2.51 beta29(2015/08/23)

・kbmpg123.kpi に関する以下の修正
　・libmpg123 を 1.22.4(2015/8/12) に差し替え
・演奏リストで再生中の曲へのアイテム移動が出来ないことがあるのを修正
・細かい修正
・ヘルプを更新

/*---------------------------------------------------------------------------*/

2.51 beta28(2015/08/21)

・ASIO 再生時に一時停止すると再生位置がずれるのを修正(kbasio.dll)
・SWRD/NWRD/動画の画面サイズ指定に高解像度ディスプレイ用の項目を追加
　・1600x1200/1920x1440/2880x2160(及びその中間のサイズ)
　・小さいサイズを一部廃止
・単曲リピート時にファイルを開き直さないようにした
・曲長が短い曲を連続再生や単曲リピートすると再生位置がおかしくなるのを修正
・曲長が短い曲を連続再生するとリプレイゲインが正しく適用されないことがあるのを
　修正
・シーク未対応のプラグイン(nezplug.kpi 等)や、対応しても要求した位置と戻り値が
　異なるプラグイン(kbtta.kpi等) でシーク時、常に「Seeking」と表示していたのを、
　処理に１秒以上かかったら表示するように修正
・シーク未対応のプラグインで再生すると前回停止時の位置から始まることがあるのを
　修正
・「未再生の曲だけ再生」が無効でも演奏リストにチェックボックスが表示されること
　があるのを修正
・歌詞フォルダにあるファイルにタイムタグが付いていないと「ドキュメント」部に表
　示されないのを修正
・拡張子が .txt の歌詞ファイルが歌詞フォルダに置いてある場合は中身を調べずに歌
　詞と見なす(演奏リスト、Media エクスプローラでアイコン表示)ようにした
　・音楽ファイルと同じフォルダの場合は中身を調べて判断
　・.lrc/.kra の場合は歌詞フォルダかどうかに関わらず中身を調べずに歌詞と見なす
・液晶のサイズを「mini」にすると液晶が非表示になっていたのを修正
・ドキュメントファイルがないときに「見つかりませんでした」と表示されなくなって
　いたのを修正
・ヘルプを更新

/*---------------------------------------------------------------------------*/

2.51 beta27(2015/08/15)

・kbmpg123.kpi/kbmad.kpi に関する以下の修正
　・VBRI ヘッダを含む VBR の演奏時間取得が正確になった
　　・ギャップレス再生には未対応
　　・ギャップレス再生に使えそうな情報(delay) があるが、解釈の仕方が不明
　・kmp_GetTestTagInfo で以下の情報を通知するようにした
　　・ビットレート(CBR/VBR/ABR を含む)
　　・MPEG (MPEG 1.0 layer 3 etc...)
　　・Stereo Mode (stereo/joint stereo/dual channel/mono)
　　・VBR Tag の各種情報(詳細は kbmpg123.txt/kbmad.txt を参照)
　・タイトル等の情報取得は本体に任せる
・kbvorbis.kpi に関する以下の修正
　・kmp_GetTestTagInfo で通知するフィールド名を増やした(performer/encoded by
　　等、本体が未知なものも含めた全て）
　・kmp_GetTestTagInfo で "vendor" を通知するようにした
・kbflac.kpi に関する以下の修正
　・kmp_GetTestTagInfo で "vendor" を通知するようにした
・ApeTagv2 のタグ取得に関する以下の修正
　・取得するフィールド名を増やした(本体が未知なものも含めた全て）
　・"version" の取得に対応(Monkeys Audio の場合のみ)
・WMA/ASF のタグ取得に関する以下の修正
　・取得するフィールド名を増やした(本体が未知なものも含めた全て）
　・"Codec Type", "Codec Name", "Codec Description" の取得に対応
・タグ(*.tag)ファイルによるタグ取得に関する以下の修正
　・取得するフィールド名を増やした(本体が未知なものも含めた全て）
　　(XXXX=YYYY の XXXX の部分に任意の文字列を使用可能になった)
・フェードアウトが正常に機能していなかったのを修正
・MIDI デバイスの切り替え時、「切り替え時の位置から再生」が有効だと実際にはデバ
　イスが切り替わっていなかったのを修正
・情報表示パネルの「アーティスト」の部分を
　　アーティスト / オリジナルアーティスト / アルバムアーティスト
　のように表示するようにした（値が同じものは表示しない）
・kmp_GetTestTagInfo の仕様を一部変更(詳細は kmp_pi.h を参照)
　・SetValue(NULL, NULL) が呼ばれた時の動作を kmp_pi.h の記述通りに実装（本体
　　のデフォルトタグ取得ルーチンを呼ばなくする）
　・実際に使うプラグインの kmp_GetTagInfo だけを呼び出すようにした（元々そう
　　なっていたが kmp_pi.h と相違していたので kmp_pi.h の記述の方を変更）
・ヘルプを更新

/*---------------------------------------------------------------------------*/

2.51beta26(2015/08/09)

・検索バーに関する以下の修正
　・表示/非表示を切り替えられるようにした
　・ウィンドウサイズに応じてある程度まで広く出来るようにした
　・検索条件に合致するものが見つかったら検索対象のコントロールにフォーカスを移
　　動するようにした（同じ条件で次の結果を探すには F3、新たに検索するには
　　Ctrl+F)
　　・Media エクスプローラ/演奏リストで Enter を続けて押すと再生されてしまうの
　　　のが煩わしいかも？
　・「ドキュメント」部でも検索出来るようになった
・再生中のファイルのタグ情報を「ドキュメント」部に表示するようにした
　・Title/Artist/AlbumArtist/OriginalArtist/Copyright/Composer/Performer/Album/
　　Game/Genre/Date/Comment/Emulator/Creator/Arranger/Machine/Format/Timebase/
　　Track/Module/Port/Encoded By/Encoding Settings/TrackNumber/TrackTotal/
　　DiscNumber/DiscTotal/DiscId/Bitrate/Replaygain_Track_Gain/
　　Replaygain_Track_Peak/Replaygain_Album_Gain/Replaygain_Album_Peak/
　　Refferenced File/Unsynced Lyrics/Memo1/Memo2/Memo3
　・表示する順序は概ね上記の記述順（一部例外あり）
　・Performer は foober が ID3v2 に書き込むもの(TXXX フィールド使用)には未対応
　・上記以外でも kmp_GetTestTagInfo の SetValue で渡されたもの(Name)を全て表示
　・情報を取得出来たもの（データが空白でないもの）だけを表示
　・kmp_pi.h で定義されていないフィールド名は <> で括って表示
・kbflac.kpi に関する以下の修正
　・kmp_GetTestTagInfo で通知するフィールド名を増やした(performer/encoded by
　　等、本体が未知なものも含めた全て）
・ID3v2 タグ取得に関する以下の修正
　・各種フィールドに対応
　　・TCOP(Copyright/著作権)
　　・TCOM(Composer/作曲者)
　　・TOPE(OriginalArtist/オリジナルアーティスト)
　　・TENC(Eocoded By/エンコードした人)
　　・TSSE(Encoding Settings/エンコーダ)
　　・USLT(Unsynced Lyrics/非同期歌詞)
・情報表示パネルの「アルバム名」の表示に関する修正
　・アルバム名自体に「Disc」という文字列を含み、タグ情報にディスク番号(n)とデ
　　ィスク数(t)が含まれる場合、可能なら Disc x を Disc n/t のように置換するよ
　　うにした（可能かどうかの条件はややこしいので説明を省略）
　・ディスク数が 1 の場合はディスク番号とディスク数を表示しないようにした
・フォントによっては起動するごとに情報表示パネルのサイズが一段階ずつ大きくなる
　バグを修正
・Media エクスプローラと演奏リストの右クリックメニューを整理
・ヘルプを更新（まだまだ終わらない…）

/*---------------------------------------------------------------------------*/

2.51beta25(2015/08/02)

・Media エクスプローラと演奏リストで簡単な検索機能を追加
　・Ctrl+F で検索エディットボックスにフォーカス移動
　・F3 または検索ボタン押下で検索実行
　・選択中のタブが「演奏リスト」の場合は
　　・タイトル/アーティスト/種類/ファイルパスの中で検索キーワードを含むアイテム
　　　に移動
　・選択中のタブが「Media エクスプローラ」の場合は
　　・直前に操作していたのがツリービュー部分ならツリービューで検索
　　　・その場合は、既に表示している中で検索キーワードを含むアイテムに移動（未
　　　　表示のフォルダまでは検索しない）
　　・直前に操作していたのがリストビュー部分ならリストビューで検索
　　　・その場合は、一覧表示している中で名前/アーティスト/種類/圧縮形式のうち検
　　　　索キーワードを含むアイテムに移動
　　・ツリーでフォルダを選択後、一覧表示されたリストの中から検索したい場合は一
　　　度リストの方にフォーカスを移動してから検索を実行する必要がある
　・選択中のタブが「ドキュメント」の場合は
　　・何もしない（未対応）
　・大文字/小文字の区別なし（区別する指定は不可）
　・部分一致か完全一致かの指定は不可（常に部分一致）
　・正規表現による検索は不可
・演奏リストに関する以下の仕様変更
　・メドレー再生が有効なときに単曲リピートすると「メドレー再生時間」までしか再
　　生されなかったのを修正
　・「単曲再生」を「連続/ランダム/メドレー再生」とは独立してチェックマークを入
　　れる仕様に戻した（「単曲再生」有効時の「次の曲」ボタン押下時の選曲のされ方
　　が「連続再生」か「ランダム再生」かによって変わるため、連続/ランダム/メドレ
　　ーと同一グループで排他的にチェックを入れるのは不適切と判断）
　・ランダム順に並べ替えを廃止(ランダム再生で代用出来るため)
　・「updated」と「sorted」の 2種類の状態を持つようにした
　・「updated」は
　　・曲長やタイトル・アーティスト情報等が変わっている
　　・WRD やタイムタグ付き歌詞等が追加 or 削除されている
　　・曲が追加 or 削除されている
　　・保存時の並び順（既定の並び順）が変わっている
　　と有効になる。ただし、ファイル名がない(無題)のときは updated にならない
　・「sorted」は
　　・現在の表示順序が保存時の並び順（既定の並び順）と比べて変化している
　　と有効になる
　・「updated」で「sorted」な状態もある
　・ステータスバーにこれらの状態を表示する
　・カラムクリックやドラッグアンドドロップ等で曲順の入れ替えをすると「sorted」
　　になる
　・「sorted」のときに「既定の並び順に設定」すると「sorted」が消え、「updated」
　　になる
　・「sorted」のときにカラムクリックの繰り返しや右クリックメニューで「既定」に
　　並べ替えると「(sorted」は消えるが、「既定」に並べ替える直前の並び順は失われ
　　る
　・リストを保存すると (updated) は消えるが (sorted) は消えず、リストは既定の並
　　び順で保存される
　・以上から、現在の表示順序でリストを保存したい場合は、「既定の並び順に設定」
　　して (sorted) が消えてから保存を実行する必要がある
　・ただし、(sorted) の状態でプレイヤーを終了して再起動してもリストは終了直前の
　　順序が失われることはなく、起動直後に (sorted) 状態になる
　・その他、演奏リストに関する細かな修正
・Media エクスプローラツリービュー部分のスタイルを Windows エクスプローラに近
　づけた（行全体の選択、マウスでポイントされているアイテムの色が変わる）
・「プレイヤー起動時」->「終了時の演奏設定を出来るだけ復元」の設定を廃止（常に
　出来るだけ復元する）
・DDE の XTYP_REQUEST コマンドで取得出来る情報を拡張
　・アルバム、アルバムアーティスト、トラック番号、ビットレート、リプレイゲイン
　　等、kmp_pi.h で定義されている SZ_KMP_TAGINFO_NAME_XXXX 全て
・「フェードアウト」のショートカットを Ctrl+F から Ctrl+Alt+F に変更（検索機能
　と競合するため）
・ヘルプを更新

/*---------------------------------------------------------------------------*/

2.51beta24(2015/07/28)

・環境によっては演奏リストで再生済みチェックボックスが見えなくなっていたのを修
　正
・環境によっては Media エクスプローラで歌詞アイコンが見えなくなっていたのを修正
・起動時に開いた曲が演奏リスト上でフォーカス移動しないのを修正
・ヘルプを更新（リンク切れ修正）

/*---------------------------------------------------------------------------*/

2.51beta23(2015/07/27)

・ヘルプを更新
・演奏リストに関する以下の修正
　・並べ替えを行っているが「既定の並び順に設定」していない状態のときに演奏リス
　　トを保存した場合は「既定の並び順」で保存するようにした
　・並べ替えを行っているときに「新規に追加」や「リストを閉じる」を行った場合は
　　並べ替え状態をリセットするようにした
・前回と今回起動時の Kbmplay.exe の置き場所が異なる場合は前回終了時の演奏リスト
　とお気に入りを読み込むようにした
・CueSheet 再生時に演奏終了や単曲リピートが出来ないことがあるバグを修正
・演奏終了直後だとシークが出来ないことがあるバグを修正
・デバイス切り替え直後に演奏が終了してしまうことがあるのを修正
・演奏開始直後に演奏が終了してしまうことがあるのを修正（↑とは別のバグ）
・演奏リストと Media エクスプローラのカラム右クリックで表示カラムの切り替えを行
　うとカラム以外の部分を右クリックしたときのポップアップメニューも表示されるの
　を修正
・細かい修正

/*---------------------------------------------------------------------------*/

2.51beta22(2015/07/24)

・演奏リストと Media エクスプローラに関する以下の修正
　・ビジュアルスタイルを Windows エクスプローラ同様のものにした
　・マウスドラッグによるカラムの入れ替えに対応
　・右クリックメニューに「カラム」を追加し、表示カラムの選択及び表示と順序のリ
　　セットが出来るようにした。（カラムの右クリックでも可能）
　・カラム右クリックで表示カラムの切り替えを行うとカラム以外の部分を右クリック
　　したときのポップアップメニューも表示される（既知のバグ）
　・演奏リストの「ファイル名」カラムの名称を「ファイルパス」に変更
・お気に入りに関する以下の修正
　・ビジュアルスタイルを Windows エクスプローラ同様のものにした
　・「ファイルパス」カラムを追加
　・追加時のデフォルトの「名前」を「ファイルパス」のファイル名/フォルダ名にな
　　るようにした
　・「Media エクスプローラからドラッグアンドドロップ云々」のメッセージをステー
　　タスバーに常時表示するようにした
　・登録されているファイル・フォルダが存在しなくなっているときに自動でリストか
　　ら削除するのをやめた
　・特殊フォルダ（「ミュージック」等）を登録出来るようにした（アイコンの取得は
　　未対応、右クリックでの「追加」等は未対応）
　・並べ替え時に可能なら並べ替えの方向を示す三角マークを表示するようにした
　　・演奏リストのように既定の並び順に戻すことは出来ない
・液晶の色を調整（青/白の追加、違いを区別しにくいもののうちのの一方を変更等）
・アーカイブ内の曲を再生時、歌詞ファイルがアーカイブ内の同一フォルダになく、歌
　詞の検索パスで指定したフォルダにはある場合に歌詞を表示出来ないことがあるバグ
　を修正
・歌詞ファイルの拡張子が kra だったときのアイコンが lrc のものだったのを修正
・歌詞関係のアイコン(neo/sry/wrd/txt/lrc/kra)を描き直し(kra は追加)
　・文字を小文字、フォントを MS ゴシックで統一
・細かい修正

/*---------------------------------------------------------------------------*/

2.51beta21a(2015/07/18)

・2曲目以降リプレイゲインが適用されなくなるバグを修正

/*---------------------------------------------------------------------------*/

2.51beta21(2015/07/18)

・ギャップレス再生に関する以下の修正
　・次の曲を開くタイミングを修正
　　・切替前の曲の終了時刻の再生バッファサイズ+1秒程度前
　　・例えば再生バッファサイズが1000msなら約2秒前に切り替え
　・曲が切り替わると再生位置がずれるのを修正
　・ギャップレスでの曲の切り替えに失敗（処理が間に合わない等）したときの音の途
　　切れを改善
・「先読みバッファのサイズ」で設定可能な最小値を 1000ms に変更(小さすぎるとギ
　ャップレス再生に失敗しやすくなるため)
・「先読みバッファのサイズ」の実際のサイズの計算方法を
　・「先読みバッファのサイズ」＋「再生バッファサイズ」だったのを
　・「先読みバッファのサイズ」と「再生バッファサイズ」のうちの大きい方
　に変更
・演奏リストに関する以下の修正
　・演奏リストに登録されている曲を再生中、単曲再生だと音符のマークがつかなかっ
　　たのをつけるようにした
　・Media エクスプローラから「再生」で選曲した場合は再生済みのチェックを入れな
　　いようにした
　・曲が切り替わったとき、切り替わった曲にアイテムの選択と移動をする条件を変更
　　・演奏リストがフォーカスを持っていないか、持っている場合は最後にキーボード
　　　かマウスで操作してから5秒以上経過してたら移動
　　・リスト上で何か操作している最中に曲が切り替わっても操作の邪魔にならないよ
　　　うにする
　・「ファイル」→「上書き保存」「名前をつけて保存」をそれぞれ「リストを上書き
　　保存」「リストに名前をつけて保存」に名称変更
　・「ファイル」→「リストを閉じる」を追加
　・「右クリック」→「削除」→「すべて」を「すべて(リストを閉じる)」に名称変更
　・「右クリック」→「並べ替え」→「登録順」を「既定」に名称変更
　・「右クリック」→「並べ替え」→「登録順にする」を「既定の並び順に設定」に名
　　称変更
・DSD に対応するプラグインを使用して再生時は以下の機能を無効にした
　・音量制御（常に100%）
　・リプレイゲイン（常に無効）
　・フェードアウト（直ちに演奏終了）
　・クロスフェード（直ちに曲を切り替え）
　・エコー（無視）
　・再生速度の変更（無視）
　・モノラルをステレオに変換（変換しない）
　・スペアナ（波形の分析を行わない）
　・拡張子 DSF/DFF/WSD のうちのいずれか２つに対応していれば DSD 対応と見なす
　・ドリームキャストの音楽ファイルかもしれないため、拡張子 DSF に対応していても
　　DFF/WSD のどちらかには未対応の場合は DSD 対応とは見なさない
　・↑同様、DSD 以外の未知の形式かもしれないため、DFF だけに対応、WSD だけに対
　　応の場合も DSD 対応とは見なさない
　・DSD over PCM(DoP) 方式で再生する形式を安全に再生するための暫定的な措置
　　（DoP 方式で再生することをプラグインから取得することが仕様上不可なので）
・TAG ファイル及び nezplug拡張M3U/PLS で小数点を使用した時間指定に対応
　・1ms未満は切り捨て(例：1:23.3456 と 1:23'34.56 はどちらも 1分23.345秒)
　・ループ回数やフェード時間が指定されている場合、各項目を合計した値を切り捨て
　　るのではなく、切り捨てた値を合計して曲長が算出される（例：1:23.3456 でルー
　　プ回数 2 回だと 2分45.690秒）
・kbasio.dll に関する以下の修正
　・シークすると再生位置がずれるのを修正
　・シークするとフリーズすることがあるのを修正
・kbdsound.dll に関する以下の修正
　・先頭へのシーク or 再生中に再生ボタンを押下時に冒頭部分が再生されないことが
　　あるのを修正（？）（自信がない）
・動画関係のタグ情報を取得出来なくなっていたバグを修正
・１ファイル複数曲で再生開始直後のシークまたは再生開始ボタン押下時の挙動が変だ
　ったのを修正
・曲長が 100 分以上あるとシークバー左の再生位置と曲長の表示がおかしくなるのを修
　正(1000分以上のときは 999:59 と表示)

/*---------------------------------------------------------------------------*/

2.51beta20(2015/07/12)

・動画の拡張子を設定出来るようにした
　・「環境設定」→「演奏設定」→「動画の拡張子」
　・プラグインよりも優先順位が高い
　・実際に再生出来るかどうかはシステムにインストールされている CODEC による
・モノラルの曲をステレオに変換してから鳴らすようにした（左右同じ音）
　・WASAPI でモノラルの曲が再生出来るようになった
　・モノラルの曲からステレオの曲（またはその逆）に切り替えたときでもノンストッ
　　プで繋がるようになった
・kbsnesapu.kpi に関する以下の修正
　・snesapu.dll を 2.17.4.5209 に差し替え
　・GetSNESAPUContextSize/GetSNESAPUContext/SetSNESAPUContext に対応
　　・KMPMODULE::dwReentrant = 1 になり、クロスフェード再生時や SPC を再生中の
　　　曲長計算のパフォーマンスが向上
・細かい修正

/*---------------------------------------------------------------------------*/

2.51beta19(2015/07/09)

・Media エクスプローラリストビュー部分からの１ファイル複数曲の選曲・リストへの
　追加時の曲番号指定が正しく処理されていなかったバグを修正
　・名前が「ファイル名::曲番号」となるべきところが「ファイル名::::曲番号」とな
　　っていたため）
